package br.ufpr.mityba.controller;

import java.io.IOException;

import br.ufpr.mityba.dao.HorarioConsultaDAO;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * 
 * @author Mityba
 * @since 23/11/2008
 * @version 1.0 23/11/2008
 *
 */

public class GerenteConsultaHorarioConsulta {

	/**
	 * 
	 * @param controle
	 * @param diaSemana
	 * @param idUsuario
	 * @return flag
	 * @throws IOException
	 */

	public static boolean horariosPorDiaSemana(ControlePrincipal controle, int diaSemana, int idUsuario) throws IOException{		
		return new HorarioConsultaDAO(controle).carregaHorarios("and dia_semana_horario_consulta=" + diaSemana +
																" and id_usuario_horario_consulta=" + idUsuario);
	}
	
	/**
	 * 
	 * @param controle
	 * @param diaSemana
	 * @param horario
	 * @param idUsuario
	 * @return flag
	 * @throws IOException
	 */

	public static boolean horariosPorDiaSemanaHorario(ControlePrincipal controle, int diaSemana, String horario, int idUsuario) throws IOException{		
		return new HorarioConsultaDAO(controle).carregaHorarios("and dia_semana_horario_consulta=" + diaSemana +
																" and horario_ini_horario_consulta=" + horario +
																" and id_usuario_horario_consulta=" + idUsuario);
	}
	
	/**
	 * 
	 * @param controle
	 * @param codigo
	 * @return flag
	 * @throws IOException
	 */

	public static boolean horariosConsultaCodigo(ControlePrincipal controle, int codigo) throws IOException{		
		return new HorarioConsultaDAO(controle).carregaHorarios("and id_horario_consulta=" + codigo);
	}
}
