package br.ufpr.mityba.controller;

import java.io.IOException;

import br.ufpr.mityba.dao.MedicamentoDAO;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * 
 * @author Mityba
 * @since 10/11/2008
 * @version 1.0 10/11/2008
 *
 */

public class GerenteConsultaMedicamento {
	
	/**
	 * 
	 * @param controle
	 * @return flag
	 * @throws IOException
	 */

	public static boolean todosMedicamentos(ControlePrincipal controle) throws IOException{		
		return new MedicamentoDAO(controle).carregaMedicamentos("");
	}
	
	/**
	 * 
	 * @param controle
	 * @param idMedicamento
	 * @return flag
	 * @throws IOException
	 */

	public static boolean medicamentoPorCodigo(ControlePrincipal controle, int idMedicamento) throws IOException{
		return new MedicamentoDAO(controle).carregaMedicamentos("and id_medicamento=" + idMedicamento);
	}
	
	/**
	 * 
	 * @param controle
	 * @param nome
	 * @return flag
	 * @throws IOException
	 */

	public static boolean medicamentoPorNome(ControlePrincipal controle, String nome) throws IOException{		
		return new MedicamentoDAO(controle).carregaMedicamentos("and nome_comercial_medicamento like '%" + nome + "%'");
	}
	
	/**
	 * 
	 * @param controle
	 * @param indicacao
	 * @return flag
	 * @throws IOException
	 */

	public static boolean medicamentoPorIndicacao(ControlePrincipal controle, String indicacao) throws IOException{		
		return new MedicamentoDAO(controle).carregaMedicamentos("and indicacao_medicamento like '%" + indicacao + "%'");
	}
}