package br.ufpr.mityba.controller;

import java.io.IOException;

import br.ufpr.mityba.dao.PacienteDAO;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * 
 * @author Mityba
 * @since 04/11/2008
 * @version 1.0 04/11/2008
 *
 */

public class GerenteConsultaPaciente {

	/**
	 * 
	 * @param controle
	 * @param codigo
	 * @return flag
	 * @throws IOException
	 */

	public static boolean pacientePorCodigo(ControlePrincipal controle, int codigo) throws IOException{		
		return new PacienteDAO(controle).carregaPacientes("where id_paciente=" + codigo);
	}
	
	/**
	 * 
	 * @param controle
	 * @param nome
	 * @param soAtivos
	 * @return flag
	 * @throws IOException
	 */

	public static boolean pacientePorNome(ControlePrincipal controle, String nome, boolean soAtivos) throws IOException{		
		return new PacienteDAO(controle).carregaPacientes("where nome_paciente like '%" + nome + "%'" + (soAtivos ? " and status_paciente='s'" : ""));
	}
	
	/**
	 * 
	 * @param controle
	 * @param dtNasc
	 * @param soAtivos
	 * @return
	 * @throws IOException
	 */

	public static boolean pacientePorNascimento(ControlePrincipal controle, String dtNasc, boolean soAtivos) throws IOException{		
		return new PacienteDAO(controle).carregaPacientes("where dt_nasc_paciente like '%" + dtNasc + "%'" + (soAtivos ? " and status_paciente='s'" : ""));
	}
	
	/**
	 * 
	 * @param controle
	 * @param idProfissao
	 * @return flag
	 * @throws IOException
	 */

	public static boolean pacientePorProfissao(ControlePrincipal controle, int idProfissao) throws IOException{		
		return new PacienteDAO(controle).carregaPacientes("where id_profissao_paciente=" + idProfissao);
	}
	
	/**
	 * 
	 * @param controle
	 * @param dataBase
	 * @return flag
	 * @throws IOException
	 */

	public static boolean pacientePorDataAniversario(ControlePrincipal controle, String dataBase) throws IOException{		
		return new PacienteDAO(controle).carregaPacientes("where dt_nasc_paciente like '" + dataBase.substring(0, 5) + "%'");
	}
	
	/**
	 * 
	 * @param controle
	 * @param idsPacientes
	 * @return flag
	 * @throws IOException
	 */

	public static boolean pacientePorCodigos(ControlePrincipal controle, String[] idsPacientes) throws IOException{
		
		StringBuffer where = new StringBuffer();
		
		where.append("where id_paciente in (");
		
		for(int i = 0; i < idsPacientes.length; i++){
			where.append(idsPacientes[i])
				 .append(", ");
		}
		
		where.append(")");
		
		return new PacienteDAO(controle).carregaPacientes(where.toString().replace(", )", ")"));
	}
	
	/**
	 * 
	 * @param controle
	 * @param nome
	 * @param idade
	 * @param sexo
	 * @param status
	 * @param convenio
	 * @param profissao
	 * @param indicacao
	 * @return flag
	 * @throws IOException
	 */

	public static boolean pacientePorCamposMsg(ControlePrincipal controle, String nome, int idade,
				String sexo, String status, int convenio, int profissao) throws IOException{
				
		StringBuffer where = new StringBuffer("where ");

		if (nome != null && ! nome.equals("")){
			where.append("nome_paciente like '%")
				 .append(nome)
				 .append("%' and" );
		}
		if (idade != 0){
			where.append("idade_paciente=")
				 .append(idade)
				 .append(" and ");
		}
		if (status != null && ! status.equals("") && ! status.equals("n")){
			where.append("status_paciente = 's' and");
		}
		if (convenio != -1){
			where.append("id_convenio_paciente=")
				 .append(convenio)
				 .append(" and ");
		}
		if (profissao != -1){
			where.append("id_profissao_paciente=")
				 .append(profissao)
				 .append(" and ");
		}
		if (sexo != null && (sexo.equals("m") || sexo.equals("f"))){
			where.append("sexo_paciente = '%")
				 .append(sexo)
				 .append("'");
		} else {
			where.append("(sexo_paciente = 'm' or sexo_paciente = 'f')");
		}
		
		return new PacienteDAO(controle).carregaPacientes(where.toString());
	}
	
	/**
	 * 
	 * @param controle
	 * @return flag
	 * @throws IOException
	 */

	public static boolean todosPacientes(ControlePrincipal controle) throws IOException{		
		return new PacienteDAO(controle).carregaPacientes("");
	}
}