package br.ufpr.mityba.controller;

import java.io.IOException;

import br.ufpr.mityba.dao.UsuarioDAO;
import br.ufpr.mityba.util.ControlePrincipal;
import br.ufpr.mityba.util.Criptografia;

/**
 * 
 * @author Mityba
 * @since 10/11/2008
 * @version 1.0 10/11/2008
 *
 */

public class GerenteConsultaUsuario {

	/**
	 * 
	 * @param controle
	 * @return flag
	 * @throws IOException
	 */

	public static boolean todosUsuarios(ControlePrincipal controle) throws IOException{		
		return new UsuarioDAO(controle).carregaUsuarios("");
	}
	
	/**
	 * 
	 * @param controle
	 * @param codUsuario
	 * @return flag
	 * @throws IOException
	 */

	public static boolean usuarioPorCodigo(ControlePrincipal controle, int codUsuario) throws IOException{		
		return new UsuarioDAO(controle).carregaUsuarios(" and id_usuario=" + codUsuario);
	}
	
	/**
	 * 
	 * @param controle
	 * @param nomeUsuario
	 * @return flag
	 * @throws IOException
	 */

	public static boolean usuarioPorNome(ControlePrincipal controle, String nomeUsuario) throws IOException{
		return new UsuarioDAO(controle).carregaUsuarios(" and nome_usuario like '%" + nomeUsuario + "%'");
	}
	
	/**
	 * 
	 * @param controle
	 * @return flag
	 * @throws IOException
	 */

	public static boolean usuarioMedico(ControlePrincipal controle) throws IOException{
		return new UsuarioDAO(controle).carregaUsuarios(" and tp_acesso_usuario < 3");
	}
	
	/**
	 * 
	 * @param controle
	 * @param cpfUsuario
	 * @return flag
	 * @throws IOException
	 */

	public static boolean usuarioPorCpf(ControlePrincipal controle, String cpfUsuario) throws IOException{
		return new UsuarioDAO(controle).carregaUsuarios(" and cpf_usuario like '%" + cpfUsuario + "%'");
	}
	
	/**
	 * 
	 * @param controle
	 * @param loginUsuario
	 * @return flag
	 * @throws IOException
	 */

	public static boolean usuarioPorLogin(ControlePrincipal controle, String loginUsuario) throws IOException{
		try {
			return new UsuarioDAO(controle).carregaUsuarios(" and login_usuario like '%" + Criptografia.criptografar(loginUsuario) + "%'");
		} catch (Exception e) {
			return false;
		}
	}
}