package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.AuditLog;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * @author Mityba
 * @since 16/10/2008
 * @version 1.0
 */

public class AuditLogDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public AuditLogDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public AuditLogDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @param orderBy
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaRegistros(String where, String orderBy) throws IOException {
		
		Vector<AuditLog> vector = new Vector<AuditLog>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from audit_log " + where + " " + orderBy;

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {
				
				vector.add(new AuditLog(
					retorno.getInt		("id_registro"),
					retorno.getString	("login_usuario").trim(),	
					retorno.getString	("ip_usuario").trim(),
					retorno.getString	("data_ini").trim(),
					retorno.getString	("data_fim").trim(),
					retorno.getString	("acao_exec").trim()));
			}

			statement.close();
			Conexao.stopConnection(connection);
									
			controle.setAuditLog(vector);
	
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {
			
			e.printStackTrace();
		
			return false;
		}
	}
	
	/**
	 * 
	 * @param auditLog
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiRegistro(AuditLog auditLog) throws IOException{

		try {
			
			connection = Conexao.getConnection();
			
			StringBuffer sql = new StringBuffer();
			sql.append("insert into audit_log (login_usuario, ip_usuario, data_ini, data_fim, acao_exec) ")
			   .append("values (?,?,?,?,?)");

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());

			pstmt.setString	(1, auditLog.getLoginUsuario());
			pstmt.setString	(2, auditLog.getIpUsuario());
			pstmt.setString	(3, auditLog.getDataIni());
			pstmt.setString	(4, auditLog.getDataFim());
			pstmt.setString	(5, auditLog.getAcaoExec());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}
			
			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {
				
			return false;
			
		} catch (Exception e) {
				
			return false;
		}
	}
}