package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.Consulta;
import br.ufpr.mityba.model.ViewPacienteConsulta;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;



/**
 * @author Mityba
 * @since 17/11/2008
 * @version 1.0 17/11/2008
 */

public class ConsultaDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public ConsultaDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public ConsultaDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaConsultas(String where) throws IOException {
		
		Vector<Consulta> vector = new Vector<Consulta>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from consulta " + where;

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {

				vector.add(new Consulta(
					retorno.getInt		("id_consulta"),
					retorno.getInt		("id_horario_consulta"),
					retorno.getInt		("id_convenio_consulta"),
					retorno.getInt		("id_paciente_consulta"),
					retorno.getInt		("id_usuario_consulta"),
					retorno.getInt		("id_status_consulta"),
					retorno.getString	("primeira_consulta").equals("S"),
					retorno.getString	("obs_consulta").trim(),
					retorno.getString	("data_consulta").trim()));
			}
			
			controle.setConsultas(vector);

			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {
		
			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param idConsulta
	 * @return flag
	 * @throws IOException
	 */

	public ViewPacienteConsulta carregaViewPacienteConsulta(int idConsulta) throws IOException {

		try {

			connection = Conexao.getConnection();

			statement = connection.createStatement();

			StringBuffer sql = new StringBuffer();
			sql.append("select c.id_consulta, h.id_horario_consulta, h.horario_ini_horario_consulta, p.nome_paciente, co.nome_convenio, p.fone_celular, ")
				.append("c.primeira_consulta, c.obs_consulta, s.descr_status_consulta ")
				.append("from consulta c, horario_consulta h, paciente p, convenio co, status_consulta s ")
				.append("where c.id_consulta          = " + idConsulta)
				.append(" and  c.id_paciente_consulta = p.id_paciente")
				.append(" and  c.id_convenio_consulta = co.id_convenio")
				.append(" and  c.id_horario_consulta  = h.id_horario_consulta")
				.append(" and  c.id_status_consulta   = s.id_status_consulta");

			retorno = statement.executeQuery(sql.toString());

			while (retorno.next()) {

				return new ViewPacienteConsulta(
					retorno.getString	(1) + "-" + 
					retorno.getString	(2),	// c.id_consulta + id_horario_consulta
					retorno.getString	(3), 	// h.horario_ini_horario_consulta
					retorno.getString	(4), 	// p.nome_paciente
					retorno.getString	(5), 	// co.nome_convenio
					retorno.getString	(6), 	// p.fone_celular
					retorno.getString	(7).equals("S") ? "Sim" : "No", 	// c.primeira_consulta
					retorno.getString	(8), 	// c.obs_consulta
					retorno.getString	(9)); 	// s.descr_status_consulta
			}

			return null;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return null;

		} catch (Exception e) {
		
			e.printStackTrace();
			
			return null;
		}
	}
	
	/**
	 * 
	 * @param data
	 * @param idUsuario
	 * @param idHorario
	 * @param tpVisualizacao
	 * @return
	 * @throws IOException
	 */

	public ViewPacienteConsulta carregaViewPacienteConsulta(String data, int idUsuario, int idHorario, int tpVisualizacao) throws IOException {

		try {

			connection = Conexao.getConnection();

			statement = connection.createStatement();

			StringBuffer sql = new StringBuffer();
			
			//Todos
			
			if(tpVisualizacao == 1){
			
				sql.append("select c.id_consulta, h.id_horario_consulta, h.horario_ini_horario_consulta, p.nome_paciente, co.nome_convenio, p.fone_celular, ")
					.append("c.primeira_consulta, c.obs_consulta, s.descr_status_consulta ")
					.append("from consulta c, horario_consulta h, paciente p, convenio co, status_consulta s ")
					.append("where c.data_consulta        = '" + data + "'")
					.append(" and  c.id_horario_consulta  = " + idHorario)
					.append(" and  c.id_paciente_consulta = p.id_paciente")
					.append(" and  c.id_convenio_consulta = co.id_convenio")
					.append(" and  c.id_horario_consulta  = h.id_horario_consulta")
					.append(" and  c.id_status_consulta   = s.id_status_consulta");
	
				retorno = statement.executeQuery(sql.toString());
	
				while (retorno.next()) {
	
					return new ViewPacienteConsulta(
						retorno.getString	(1) + "." + 
						retorno.getString	(2),	// c.id_consulta + id_horario_consulta
						retorno.getString	(3), 	// h.horario_ini_horario_consulta
						retorno.getString	(4), 	// p.nome_paciente
						retorno.getString	(5), 	// co.nome_convenio
						retorno.getString	(6), 	// p.fone_celular
						retorno.getString	(7).equals("S") ? "Sim" : "No", 	// c.primeira_consulta
						retorno.getString	(8), 	// c.obs_consulta
						retorno.getString	(9)); 	// s.descr_status_consulta
				}
			
				sql = new StringBuffer();
				sql.append("select id_horario_consulta, horario_ini_horario_consulta ")
					.append("from horario_consulta ")
					.append("where  id_horario_consulta  = " + idHorario);
	
				retorno = statement.executeQuery(sql.toString());
	
				while (retorno.next()) {
	
					return new ViewPacienteConsulta(
						0 + "." + retorno.getInt("id_horario_consulta"), 	// c.id_consulta + id_horario_consulta
						retorno.getString("horario_ini_horario_consulta"), 	// h.horario_ini_horario_consulta
						"&nbsp;", 	// p.nome_paciente
						"&nbsp;", 	// co.nome_convenio
						"&nbsp;", 	// p.fone_celular
						"&nbsp;", 	// c.primeira_consulta
						"&nbsp;", 	// c.obs_consulta
						"Livre"); 	// s.descr_status_consulta
				}
				
			//------------- Ocupados
				
			} else if(tpVisualizacao == 2){
			
				sql.append("select c.id_consulta, h.id_horario_consulta, h.horario_ini_horario_consulta, p.nome_paciente, co.nome_convenio, p.fone_celular, ")
					.append("c.primeira_consulta, c.obs_consulta, s.descr_status_consulta ")
					.append("from consulta c, horario_consulta h, paciente p, convenio co, status_consulta s ")
					.append("where c.data_consulta        = '" + data + "'")
					.append(" and  c.id_horario_consulta  = " + idHorario)
					.append(" and  c.id_paciente_consulta = p.id_paciente")
					.append(" and  c.id_convenio_consulta = co.id_convenio")
					.append(" and  c.id_horario_consulta  = h.id_horario_consulta")
					.append(" and  c.id_status_consulta   = s.id_status_consulta");
	
				retorno = statement.executeQuery(sql.toString());
	
				while (retorno.next()) {
	
					return new ViewPacienteConsulta(
						retorno.getString	(1) + "." + 
						retorno.getString	(2),	// c.id_consulta + id_horario_consulta
						retorno.getString	(3), 	// h.horario_ini_horario_consulta
						retorno.getString	(4), 	// p.nome_paciente
						retorno.getString	(5), 	// co.nome_convenio
						retorno.getString	(6), 	// p.fone_celular
						retorno.getString	(7).equals("S") ? "Sim" : "No", 	// c.primeira_consulta
						retorno.getString	(8), 	// c.obs_consulta
						retorno.getString	(9)); 	// s.descr_status_consulta
				}
				
				return null;
			
			//------------- Livres
				
			} else if(tpVisualizacao == 3){
			
				sql.append("select c.id_consulta, h.id_horario_consulta, h.horario_ini_horario_consulta, p.nome_paciente, co.nome_convenio, p.fone_celular, ")
					.append("c.primeira_consulta, c.obs_consulta, s.descr_status_consulta ")
					.append("from consulta c, horario_consulta h, paciente p, convenio co, status_consulta s ")
					.append("where c.data_consulta        = '" + data + "'")
					.append(" and  c.id_horario_consulta  = " + idHorario)
					.append(" and  c.id_paciente_consulta = p.id_paciente")
					.append(" and  c.id_convenio_consulta = co.id_convenio")
					.append(" and  c.id_horario_consulta  = h.id_horario_consulta")
					.append(" and  c.id_status_consulta   = s.id_status_consulta");
	
				retorno = statement.executeQuery(sql.toString());
	
				while (retorno.next()) {
	
					return null;
				}
			
				sql = new StringBuffer();
				sql.append("select id_horario_consulta, horario_ini_horario_consulta ")
					.append("from horario_consulta ")
					.append("where id_horario_consulta  = " + idHorario);
	
				retorno = statement.executeQuery(sql.toString());
	
				while (retorno.next()) {
	
					return new ViewPacienteConsulta(
						0 + "." + retorno.getInt("id_horario_consulta"), 	// c.id_consulta
						retorno.getString("horario_ini_horario_consulta"), 	// h.horario_ini_horario_consulta
						"&nbsp;", 	// p.nome_paciente
						"&nbsp;", 	// co.nome_convenio
						"&nbsp;", 	// p.fone_celular
						"&nbsp;", 	// c.primeira_consulta
						"&nbsp;", 	// c.obs_consulta
						"Livre"); 	// s.descr_status_consulta
				}
				
			}
			
			return null;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return null;

		} catch (Exception e) {
		
			e.printStackTrace();
			
			return null;
		}
	}
	
	/**
	 * 
	 * @param consulta
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiConsulta(Consulta consulta) throws IOException{

		try {
			
			connection = Conexao.getConnection();
			
			StringBuffer sql = new StringBuffer();
			sql.append("insert into consulta (id_horario_consulta, id_convenio_consulta, ")
				.append("id_paciente_consulta, id_usuario_consulta, id_status_consulta, ")
			   	.append("primeira_consulta, obs_consulta, data_consulta) ")
			   	.append("values (?,?,?,?,?,?,?,?)");
			
			PreparedStatement pstmt = connection.prepareStatement(sql.toString());

			pstmt.setInt	(1, consulta.getIdHorarioConsulta());
			pstmt.setInt	(2, consulta.getIdConvenioConsulta());
			pstmt.setInt	(3, consulta.getIdPacienteConsulta());
			pstmt.setInt	(4, consulta.getIdUsuarioConsulta());
			pstmt.setInt	(5, consulta.getIdStatusConsulta());
			pstmt.setString	(6, consulta.isEPrimeiraConsulta() ? "S" : "N");
			pstmt.setString	(7, consulta.getObsConsulta());
			pstmt.setString	(8, consulta.getDataConsulta());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
			
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}

	/**
	 * 
	 * @param consulta
	 * @return flag
	 * @throws IOException
	 */

	public boolean alteraConsulta(Consulta consulta) throws IOException {

		try {

			connection = Conexao.getConnection();

			StringBuffer sql = new StringBuffer();
			sql.append("update consulta set id_horario_consulta=?, id_convenio_consulta=?, ")
				.append("id_paciente_consulta=?, id_usuario_consulta=?, id_status_consulta=?, ")
				.append("primeira_consulta=?, obs_consulta=? , data_consulta=? ")
				.append("where id_consulta=?");

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());

			pstmt.setInt	(1, consulta.getIdHorarioConsulta());
			pstmt.setInt	(2, consulta.getIdConvenioConsulta());
			pstmt.setInt	(3, consulta.getIdPacienteConsulta());
			pstmt.setInt	(4, consulta.getIdUsuarioConsulta());
			pstmt.setInt	(5, consulta.getIdStatusConsulta());
			pstmt.setString	(6, consulta.isEPrimeiraConsulta() ? "S" : "N");
			pstmt.setString	(7, consulta.getObsConsulta());
			pstmt.setString	(8, consulta.getDataConsulta());
			pstmt.setInt	(9, consulta.getIdConsulta());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {

			e.printStackTrace();
			
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param idConsulta
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiConsulta(int idConsulta) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from consulta where id_consulta=" + idConsulta;

			if (statement.executeUpdate(sql) != 1) {
				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		
		} catch (Exception e) {
		
			e.printStackTrace();
		
			return false;
		}
	}
}