package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.ExameCadastrado;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;



/**
 * @author Mityba
 * @since 16/10/2008
 * @version 1.0 16/10/2008
 * @version 1.0 03/11/2008
 */

public class ExameCadastradoDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public ExameCadastradoDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public ExameCadastradoDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return exames
	 * @throws IOException
	 */

	public boolean carregaExamesCadastrados(String where) throws IOException {
		
		Vector<ExameCadastrado> vector = new Vector<ExameCadastrado>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from exame_cadastrado " + where + " order by id_exame";

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {
				
				vector.add(new ExameCadastrado(
					retorno.getInt	 ("id_exame"),
					retorno.getInt	 ("id_unidade_exame"),	
					retorno.getString("nome_exame").trim(),
					retorno.getString("minimo06").trim(),
					retorno.getString("maximo06").trim(),
					retorno.getString("minimo712").trim(),
					retorno.getString("maximo712").trim(),
					retorno.getString("minimo65").trim(),
					retorno.getString("maximo65").trim(),
					retorno.getString("minimo_fem").trim(),
					retorno.getString("maximo_fem").trim(),
					retorno.getString("minimo_mas").trim(),
					retorno.getString("maximo_mas").trim(),
					retorno.getString("minimo_baixo").trim(),
					retorno.getString("maximo_baixo").trim(),
					retorno.getString("minimo_desej").trim(),
					retorno.getString("maximo_desej").trim(),
					retorno.getString("minimo_limite").trim(),
					retorno.getString("maximo_limite").trim(),
					retorno.getString("minimo_alto").trim(),
					retorno.getString("maximo_alto").trim(),
					retorno.getString("minimo_mt_alto").trim(),
					retorno.getString("maximo_mt_alto").trim(),
					retorno.getString("obs_abaixo").trim(),
					retorno.getString("obs_acima").trim()));
			}

			statement.close();
			Conexao.stopConnection(connection);
									
			controle.setExamesCadastrados(vector);
	
			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;

		} catch (Exception e) {

			e.printStackTrace();
			
			controle.setExamesCadastrados(new Vector<ExameCadastrado>());
		
			return false;
		}
	}
	
	/**
	 * 
	 * @param exame
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiExameCadastrado(ExameCadastrado exame) throws IOException{

		try {
			
			connection = Conexao.getConnection();
			
			statement = connection.createStatement();
			
			StringBuffer sql = new StringBuffer();
			sql.append("insert into exame_cadastrado (nome_exame, minimo06, maximo06, minimo712, maximo712, minimo65, maximo65, minimo_baixo, ")
			   	.append("maximo_baixo, minimo_desej, maximo_desej, minimo_limite, maximo_limite, minimo_alto, maximo_alto, ")
			   	.append("minimo_mt_alto, maximo_mt_alto, obs_abaixo, obs_acima, minimo_fem, maximo_fem, minimo_mas, maximo_mas, id_unidade_exame) ")
			   	.append("values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
			
			PreparedStatement pstmt = connection.prepareStatement(sql.toString());
			
			pstmt.setString(1,  exame.getNome());
			pstmt.setString(2,  exame.getMinimo06());
			pstmt.setString(3,  exame.getMaximo06());
			pstmt.setString(4,  exame.getMinimo712());
			pstmt.setString(5,  exame.getMaximo712());
			pstmt.setString(6,  exame.getMinimo65());
			pstmt.setString(7,  exame.getMaximo65());
			pstmt.setString(8,  exame.getMinimoBaixo());
			pstmt.setString(9,  exame.getMaximoBaixo());
			pstmt.setString(10, exame.getMinimoDesej());
			pstmt.setString(11, exame.getMaximoDesej());
			pstmt.setString(12, exame.getMinimoLimite());
			pstmt.setString(13, exame.getMaximoLimite());
			pstmt.setString(14, exame.getMinimoAlto());
			pstmt.setString(15, exame.getMaximoAlto());
			pstmt.setString(16, exame.getMinimoMtAlto());
			pstmt.setString(17, exame.getMaximoMtAlto());
			pstmt.setString(18, exame.getObsAbaixo());
			pstmt.setString(19, exame.getObsAcima());
			pstmt.setString(20, exame.getMinimoFem());
			pstmt.setString(21, exame.getMaximoFem());
			pstmt.setString(22, exame.getMinimoMas());
			pstmt.setString(23, exame.getMaximoMas());
			pstmt.setInt   (24, exame.getUnidade());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}
			
			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {

			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}

	/**
	 * 
	 * @param exame
	 * @return flag
	 * @throws IOException
	 */

	public boolean alteraExameCadastrado(ExameCadastrado exame) throws IOException {

		try {

			connection = Conexao.getConnection();
			
			StringBuffer sql = new StringBuffer();
			sql.append("update exame_cadastrado set nome_exame=?, minimo06=?, maximo06=?, minimo712=?, maximo712=?, minimo65=?, maximo65=?, minimo_baixo=?, ")
			   .append("maximo_baixo=?, minimo_desej=?, maximo_desej=?, minimo_limite=?, maximo_limite=?, minimo_alto=?, maximo_alto=?, ")
			   .append("minimo_mt_alto=?, maximo_mt_alto=?, obs_abaixo=?, obs_acima=?, id_unidade_exame=?")
			   .append("where id_exame=?");

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());
			
			pstmt.setString	(1, exame.getNome());
			pstmt.setString	(2, exame.getMinimo06());
			pstmt.setString	(3, exame.getMaximo06());
			pstmt.setString	(4, exame.getMinimo712());
			pstmt.setString	(5, exame.getMaximo712());
			pstmt.setString	(6, exame.getMinimo65());
			pstmt.setString	(7, exame.getMaximo65());
			pstmt.setString	(8, exame.getMinimoBaixo());
			pstmt.setString	(9, exame.getMaximoBaixo());
			pstmt.setString	(10, exame.getMinimoDesej());
			pstmt.setString	(11, exame.getMaximoDesej());
			pstmt.setString	(12, exame.getMinimoLimite());
			pstmt.setString	(13, exame.getMaximoLimite());
			pstmt.setString	(14, exame.getMinimoAlto());
			pstmt.setString	(15, exame.getMaximoAlto());
			pstmt.setString	(16, exame.getMinimoMtAlto());
			pstmt.setString	(17, exame.getMaximoMtAlto());
			pstmt.setString	(18, exame.getObsAbaixo());
			pstmt.setString	(19, exame.getObsAcima());
			pstmt.setInt	(20, exame.getUnidade());
			pstmt.setInt	(21, exame.getIdExame());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {

			e.printStackTrace();
			
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param idExamesCadastrados
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiExamesCadastrados(int idExamesCadastrados) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from exame_cadastrado where id_exame=" + idExamesCadastrados;

			int retorno = statement.executeUpdate(sql);

			if (retorno != 1) {

				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		}
	}
}