package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.HistoricoPorcao;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * @author Mityba
 * @since 11/11/2008
 * @version 1.0 
 */

public class HistoricoPorcaoDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public HistoricoPorcaoDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public HistoricoPorcaoDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaHistoricoPorcao(String where) throws IOException {
		
		Vector<HistoricoPorcao> vector = new Vector<HistoricoPorcao>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from historico_porcao " + where;

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {

				vector.add(new HistoricoPorcao(
					retorno.getInt("id_historico_paciente_historico_porcao"),
					retorno.getInt("id_grupo_alimenticio_historico_porcao"),
					retorno.getInt("quantidade_porcoes_historico_porcao")));
			}
			
			controle.setHistoricoPorcoes(vector);
			
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {
		
			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param historico
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiHistoricoPorcao(HistoricoPorcao historico) throws IOException{

		try {
			
			connection = Conexao.getConnection();

			StringBuffer sql = new StringBuffer();
			
			sql.append("insert into historico_porcao (id_historico_paciente_historico_porcao, id_grupo_alimenticio_historico_porcao, ")
				.append("quantidade_porcoes_historico_porcao) values(?,?,?)");				

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());
			
			pstmt.setInt(1, historico.getIdHistoricoPacienteHistoricoPorcao());
			pstmt.setInt(2, historico.getIdGrupoAlimenticioHistoricoPorcao());
			pstmt.setInt(3, historico.getQuantidadeHistoricoPorcao());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
			
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}
	
	/**
	 * 
	 * @param idHistoricoPorcao
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiHistoricoPorcao(int idHistoricoPorcao) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from historico_consulta where id_historico_consulta=" + idHistoricoPorcao;

			if (statement.executeUpdate(sql) != 1) {
				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		
		} catch (Exception e) {
		
			e.printStackTrace();
		
			return false;
		}
	}
}