package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.IntoleranciaPaciente;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * @author Mityba
 * @since 02/12/2008
 * @version 1.0 
 */

public class IntoleranciaPacienteDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public IntoleranciaPacienteDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public IntoleranciaPacienteDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaIntoleranciasPaciente(String where) throws IOException {
		
		Vector<IntoleranciaPaciente> vector = new Vector<IntoleranciaPaciente>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from intolerancia_paciente " + where;

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {

				vector.add(new IntoleranciaPaciente(
					retorno.getInt("id_grupo_alimenticio_intolerancia_paciente"),
					retorno.getInt("id_paciente_intolerancia_paciente")));
			}
			
			controle.setIntoleranciasPaciente(vector);
			
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {
		
			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param intolerancia
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiIntoleranciaPaciente(IntoleranciaPaciente intolerancia) throws IOException{

		try {
			
			connection = Conexao.getConnection();

			StringBuffer sql = new StringBuffer();
			
			sql.append("insert into intolerancia_paciente (id_grupo_alimenticio_intolerancia_paciente, id_paciente_intolerancia_paciente) ")
				.append("values(?,?)");				

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());

			pstmt.setInt	(1, intolerancia.getIdGrupoAlimenticio());
			pstmt.setInt	(2, intolerancia.getIdPaciente());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
			
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}
	
	/**
	 * 
	 * @param idGrupoAlimenticioIntoleranciaPaciente
	 * @param idPacienteIntoleranciaPaciente
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiIntoleranciaPaciente(int idGrupoAlimenticioIntoleranciaPaciente, int idPacienteIntoleranciaPaciente) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from alimento where id_grupo_alimenticio_intolerancia_paciente=" + idGrupoAlimenticioIntoleranciaPaciente +
												" and id_paciente_intolerancia_paciente=" + idPacienteIntoleranciaPaciente;

			if (statement.executeUpdate(sql) != 1) {
				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		
		} catch (Exception e) {
		
			e.printStackTrace();
		
			return false;
		}
	}
}