package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.Paciente;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * @author Mityba
 * @since 20/10/2008
 * @version 2.0 30/10/2008
 */

public class PacienteDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public PacienteDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public PacienteDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaPacientes(String where) throws IOException {
		
		Vector<Paciente> vector = new Vector<Paciente>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from paciente " + where + " order by nome_paciente";

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {
				
				vector.add(new Paciente(
					retorno.getInt		("id_paciente"),
					retorno.getInt		("id_profissao_paciente"),
					retorno.getInt		("id_convenio_paciente"),
					retorno.getInt		("indicacao_paciente"),
					retorno.getString	("nome_paciente").trim(),
					retorno.getString	("dt_nasc_paciente").trim(),
					retorno.getString	("idade_paciente").trim(),
					retorno.getString	("sexo_paciente").trim(),
					retorno.getString	("status_paciente").trim(),
					retorno.getString	("estado_civil_paciente").trim(),
					retorno.getString	("cep_paciente").trim(),
					retorno.getString	("logradouro_paciente").trim(),
					retorno.getString	("num_logradouro_paciente").trim(),
					retorno.getString	("complemento_paciente").trim(),
					retorno.getString	("bairro_paciente").trim(),
					retorno.getString	("cidade_paciente").trim(),
					retorno.getString	("uf_paciente").trim(),
					retorno.getString	("fone_residencial").trim(),
					retorno.getString	("fone_comercial").trim(),
					retorno.getString	("fone_celular").trim(),
					retorno.getString	("email_paciente").trim(),
					retorno.getString	("descr_indicacao_paciente").trim(),
					retorno.getString	("acesso_email_paciente")));
			}

			statement.close();
			
			Conexao.stopConnection(connection);

			controle.setPacientes(vector);
	
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {

			e.printStackTrace();
		
			return false;
		}
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public int maxIdPacientes() throws IOException {

		try {

			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "select max(id_paciente) from paciente";

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {				
				return retorno.getInt(1);
			}

			statement.close();
			
			Conexao.stopConnection(connection);
	
			return 0;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return -1;

		} catch (Exception e) {

			e.printStackTrace();
		
			return -1;
		}
	}
	

	
	/**
	 * 
	 * @param loginPaciente
	 * @param senhaPaciente
	 * @return idPaciente
	 */

	public int procuraUsuario(String loginPaciente, String senhaPaciente) {
		
		try {

			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "select id_paciente from paciente where email_paciente='" + loginPaciente 
				+ "' and dt_nasc_paciente='" + senhaPaciente.substring(0,2) + "/" + senhaPaciente.substring(2,4) 
				+ "/" + senhaPaciente.substring(4) + "'";

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {
				return retorno.getInt("id_paciente");
			}

			statement.close();
			Conexao.stopConnection(connection);
							
			return 0;

		} catch (Exception e) {
			
			e.printStackTrace();
			
			return -1;
		}
	}
	
	/**
	 * 
	 * @param paciente
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiPaciente(Paciente paciente) throws IOException{

		try {
			
			connection =  Conexao.getConnection();
			
			StringBuffer sql = new StringBuffer();
			sql.append("insert into paciente (id_profissao_paciente, id_convenio_paciente, nome_paciente, dt_nasc_paciente, idade_paciente, ")
			   .append("sexo_paciente, status_paciente, estado_civil_paciente, cep_paciente, logradouro_paciente, num_logradouro_paciente, ")
			   .append("complemento_paciente, bairro_paciente, cidade_paciente, uf_paciente, fone_residencial, ")
			   .append("fone_comercial, fone_celular, email_paciente, indicacao_paciente, descr_indicacao_paciente, acesso_email_paciente) ")
			   .append("values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());
			
			pstmt.setInt(1,     paciente.getIdProfissao());
			pstmt.setInt(2,     paciente.getIdConvenio());
			pstmt.setString(3,  paciente.getNome());
			pstmt.setString(4,  paciente.getDtNasc());
			pstmt.setString(5,  paciente.getIdade());
			pstmt.setString(6,  paciente.getSexo());
			pstmt.setString(7,  paciente.getAtivo());
			pstmt.setString(8,  paciente.getEstadoCivil());
			pstmt.setString(9,  paciente.getCep());
			pstmt.setString(10, paciente.getLogradouro());
			pstmt.setString(11, paciente.getNumEndereco());
			pstmt.setString(12, paciente.getComplemento());
			pstmt.setString(13, paciente.getBairro());
			pstmt.setString(14, paciente.getCidade());
			pstmt.setString(15, paciente.getUf());
			pstmt.setString(16, paciente.getFoneRes());
			pstmt.setString(17, paciente.getFoneCom());
			pstmt.setString(18, paciente.getFoneCel());
			pstmt.setString(19, paciente.getEmail());
			pstmt.setInt   (20, paciente.getIndicacao());
			pstmt.setString(21, paciente.getDescrIndicacao());
			pstmt.setString(22, paciente.getAcessoEmail());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}
			
			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {

			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}
	
	/**
	 * 
	 * @param paciente
	 * @return flag
	 * @throws IOException
	 */
	
	public boolean alteraPaciente(Paciente paciente) throws IOException {

		try {

			connection = Conexao.getConnection();
			
			StringBuffer sql = new StringBuffer();			
			sql.append("update paciente set id_profissao_paciente=?, id_convenio_paciente=?, nome_paciente=?, dt_nasc_paciente=?, idade_paciente=?, ")
			   .append("sexo_paciente=?, status_paciente=?, estado_civil_paciente=?, cep_paciente=?, logradouro_paciente=?, num_logradouro_paciente=?, ")
			   .append("complemento_paciente=?, bairro_paciente=?, cidade_paciente=?, uf_paciente=?, fone_residencial=?, ")
			   .append("fone_comercial=?, fone_celular=?, email_paciente=?, indicacao_paciente=?, descr_indicacao_paciente=?, acesso_email_paciente=? ")
			   .append("where id_paciente=?");

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());
			
			pstmt.setInt   (1,  paciente.getIdProfissao());
			pstmt.setInt   (2,  paciente.getIdConvenio());
			pstmt.setString(3,  paciente.getNome());
			pstmt.setString(4,  paciente.getDtNasc());
			pstmt.setString(5,  paciente.getIdade());
			pstmt.setString(6,  paciente.getSexo());
			pstmt.setString(7,  paciente.getAtivo());
			pstmt.setString(8,  paciente.getEstadoCivil());
			pstmt.setString(9,  paciente.getCep());
			pstmt.setString(10, paciente.getLogradouro());
			pstmt.setString(11, paciente.getNumEndereco());
			pstmt.setString(12, paciente.getComplemento());
			pstmt.setString(13, paciente.getBairro());
			pstmt.setString(14, paciente.getCidade());
			pstmt.setString(15, paciente.getUf());
			pstmt.setString(16, paciente.getFoneRes());
			pstmt.setString(17, paciente.getFoneCom());
			pstmt.setString(18, paciente.getFoneCel());
			pstmt.setString(19, paciente.getEmail());
			pstmt.setInt   (20, paciente.getIndicacao());
			pstmt.setString(21, paciente.getDescrIndicacao());
			pstmt.setString(22, paciente.getAcessoEmail());
			pstmt.setInt   (23, paciente.getIdPaciente());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
							
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;
			
		} catch (Exception e) {
			
			e.printStackTrace();
						
			return false;
		}
	}
	
	/**
	 * 
	 * @param idPaciente
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiPaciente(int idPaciente) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from paciente where id_paciente=" + idPaciente;

			int retorno = statement.executeUpdate(sql);

			if (retorno != 1) {

				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		}
	}
}