package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.Profissao;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;



/**
 * @author Mityba
 * @since 24/10/2008
 * @version 1.0 
 */

public class ProfissaoDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public ProfissaoDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public ProfissaoDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaProfissoes(String where) throws IOException {
		
		Vector<Profissao> vector = new Vector<Profissao>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from profissao where id_profissao <> 0 " + where + " order by nome_profissao";
			
			retorno = statement.executeQuery(sql);

			while (retorno.next()) {

				vector.add(new Profissao(
					retorno.getInt	 ("id_profissao"),
					retorno.getString("nome_profissao").trim()));
			}
			
			controle.setProfissoes(vector);
			
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {
		
			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param profissao 
	 * @param descrProfissao
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiProfissao(Profissao profissao) throws IOException{

		try {
			
			connection = Conexao.getConnection();

			String sql = "insert into profissao (nome_profissao) values (?)";

			PreparedStatement pstmt = connection.prepareStatement(sql);
			
			pstmt.setString(1, profissao.getDescrProfissao());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
			
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}

	/**
	 * 
	 * @param profissao
	 * @return flag
	 * @throws IOException
	 */

	public boolean alteraProfissao(Profissao profissao) throws IOException {

		try {

			connection = Conexao.getConnection();

			String sql = "update profissao set nome_profissao=? where id_profissao=?";
			
			PreparedStatement pstmt = connection.prepareStatement(sql);

			pstmt.setString(1, profissao.getDescrProfissao());
			pstmt.setInt   (2, profissao.getIdProfissao());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {

			e.printStackTrace();
			
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param idProfissao
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiProfissao(int idProfissao) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from profissao where id_profissao=" + idProfissao;

			if (statement.executeUpdate(sql) != 1) {
				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		
		} catch (Exception e) {
		
			e.printStackTrace();
		
			return false;
		}
	}
}