package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.UnidadeExame;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * @author Mityba
 * @since 06/11/2008
 * @version 1.0 
 */

public class UnidadeExameDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public UnidadeExameDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public UnidadeExameDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaUnidadesExame(String where) throws IOException {
		
		Vector<UnidadeExame> vector = new Vector<UnidadeExame>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from unidade_exame where id_unidade_exame <> 0 " + where + " order by nome_unidade_exame";

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {

				vector.add(new UnidadeExame(
					retorno.getInt	 ("id_unidade_exame"),
					retorno.getString("nome_unidade_exame").trim()));
			}
			
			controle.setUnidadesExame(vector);
			
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {
		
			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param unidadeExame 
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiUnidadeExame(UnidadeExame unidadeExame) throws IOException{

		try {
			
			connection = Conexao.getConnection();

			String sql = "insert into unidade_exame (nome_unidade_exame) values (?)";

			PreparedStatement pstmt = connection.prepareStatement(sql);
			
			pstmt.setString(1, unidadeExame.getDescrUnidadeExame());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
			
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}

	/**
	 * 
	 * @param unidadeExame
	 * @return flag
	 * @throws IOException
	 */

	public boolean alteraUnidadeExame(UnidadeExame unidadeExame) throws IOException {

		try {

			connection = Conexao.getConnection();

			String sql = "update unidade_exame set nome_unidade_exame=? where id_unidade_exame=?";
			
			PreparedStatement pstmt = connection.prepareStatement(sql);

			pstmt.setString(1, unidadeExame.getDescrUnidadeExame());
			pstmt.setInt   (2, unidadeExame.getIdUnidadeExame());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {

			e.printStackTrace();
			
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
			
			return false;
		}
	}
	
	/**
	 * 
	 * @param idUnidadeExame
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiUnidadeExame(int idUnidadeExame) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from unidade_exame where id_unidade_exame=" + idUnidadeExame;

			if (statement.executeUpdate(sql) != 1) {
				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		
		} catch (Exception e) {
		
			e.printStackTrace();
		
			return false;
		}
	}
}