package br.ufpr.mityba.dao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import br.ufpr.mityba.model.Usuario;
import br.ufpr.mityba.util.Conexao;
import br.ufpr.mityba.util.ControlePrincipal;
import br.ufpr.mityba.util.Criptografia;

/**
 * @author Mityba
 * @since 03/11/2008
 * @version 1.0 03/11/2008
 * @version 1.1 13/11/2008
 */

public class UsuarioDAO {
 
	private Connection connection;
	private Statement statement;
	private ResultSet retorno;
	private ControlePrincipal controle;

	/**
	 * 
	 * @param controle
	 */

	public UsuarioDAO(ControlePrincipal controle) {
		this.controle 	= controle;
	}
	
	/**
	 * 
	 */

	public UsuarioDAO() {
	}
	
	/**
	 * 
	 * @param where
	 * @return flag
	 * @throws IOException
	 */

	public boolean carregaUsuarios(String where) throws IOException {
		
		Vector<Usuario> vector = new Vector<Usuario>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select * from usuario where id_usuario <> 0 " + where;

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {

				vector.add(new Usuario(
					retorno.getInt		("id_usuario"),					
					retorno.getInt		("permissao_cadastro_usuario"),
					retorno.getInt		("permissao_financeiro_usuario"),
					retorno.getInt		("permissao_agenda_usuario"),
					retorno.getString	("nome_usuario").trim(),	
					retorno.getString	("cpf_usuario").trim(),
					retorno.getString	("rg_usuario").trim(),
					retorno.getString	("crn_usuario").trim(),
					retorno.getString	("cep_usuario").trim(),
					retorno.getString	("logradouro_usuario").trim(),
					retorno.getString	("num_logradouro_usuario").trim(),
					retorno.getString	("complemento_usuario").trim(),
					retorno.getString	("bairro_usuario").trim(),
					retorno.getString	("cidade_usuario").trim(),
					retorno.getString	("uf_usuario").trim(),
					retorno.getString	("fone_res_usuario").trim(),
					retorno.getString	("fone_cel_usuario").trim(),
					retorno.getString	("fone_com_usuario").trim(),
					retorno.getString	("email_usuario").trim(),
					Criptografia.decriptografar(retorno.getString("login_usuario").trim()),
					Criptografia.decriptografar(retorno.getString("senha_usuario").trim()),
					retorno.getInt		("tp_acesso_usuario")));
			}

			statement.close();
			Conexao.stopConnection(connection);
									
			controle.setUsuarios(vector);
	
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;

		} catch (Exception e) {

			e.printStackTrace();
		
			return false;
		}
	}
	
	/**
	 * 
	 * @param loginUsuario
	 * @param senhaUsuario
	 * @return numUsuarios
	 */

	public int procuraUsuario(String loginUsuario, String senhaUsuario) {
		
		try {

			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "select id_usuario from usuario where login_usuario='" + Criptografia.criptografar(loginUsuario) + "' and senha_usuario='" + Criptografia.criptografar(senhaUsuario) + "'";

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {
				return retorno.getInt("id_usuario");
			}

			statement.close();
			Conexao.stopConnection(connection);
							
			return 0;

		} catch (Exception e) {
			
			e.printStackTrace();
			
			return -1;
		}
	}
	
	/**
	 * 
	 * @param loginUsuario
	 * @return numLogins
	 */

	public int procuraLogin(String loginUsuario) {
		
		Vector<Integer> vector = new Vector<Integer>();

		try {

			connection = Conexao.getConnection();

			vector.removeAllElements();

			statement = connection.createStatement();

			String sql = "select id_usuario from usuario where login_usuario='" + Criptografia.criptografar(loginUsuario) + "'";

			retorno = statement.executeQuery(sql);

			while (retorno.next()) {
				vector.add(retorno.getInt("id_usuario"));
			}

			statement.close();
			Conexao.stopConnection(connection);
							
			if (vector == null)				
				return 0;				
			else				
				return vector.size();

		} catch (Exception e) {
			
			e.printStackTrace();
			
			return -1;
		}
	}
	
	/**
	 * 
	 * @param usuario
	 * @return flag
	 * @throws IOException
	 */

	public boolean incluiUsuario(Usuario usuario) throws IOException{

		try {

			connection = Conexao.getConnection();

			StringBuffer sql = new StringBuffer();
			sql.append("insert into usuario (nome_usuario, cpf_usuario, rg_usuario, crn_usuario, cep_usuario, logradouro_usuario, ")
				.append("num_logradouro_usuario, complemento_usuario, bairro_usuario, cidade_usuario, uf_usuario, fone_res_usuario, ")
				.append("fone_cel_usuario, fone_com_usuario, email_usuario, login_usuario, ")
				.append("senha_usuario, permissao_cadastro_usuario, permissao_financeiro_usuario, permissao_agenda_usuario, tp_acesso_usuario) ")
				.append("values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");			
			
			PreparedStatement pstmt = connection.prepareStatement(sql.toString());

			pstmt.setString	(1,  usuario.getNomeUsuario());
			pstmt.setString	(2,  usuario.getCpfUsuario());
			pstmt.setString	(3,  usuario.getRgUsuario());
			pstmt.setString	(4,  usuario.getCrnUsuario());
			pstmt.setString	(5,  usuario.getCepUsuario());
			pstmt.setString	(6,  usuario.getLogradouroUsuario());
			pstmt.setString	(7,  usuario.getNumLogradouroUsuario());
			pstmt.setString	(8,  usuario.getComplementoUsuario());
			pstmt.setString	(9,  usuario.getBairroUsuario());
			pstmt.setString	(10, usuario.getCidadeUsuario());
			pstmt.setString	(11, usuario.getUfUsuario());
			pstmt.setString	(12, usuario.getFoneResUsuario());
			pstmt.setString	(13, usuario.getFoneCelUsuario());
			pstmt.setString	(14, usuario.getFoneComUsuario());
			pstmt.setString	(15, usuario.getEmailUsuario());
			pstmt.setString	(16, usuario.getLoginUsuario());
			pstmt.setString	(17, usuario.getSenhaUsuario());
			pstmt.setInt	(18, usuario.getCadastroUsuario());
			pstmt.setInt	(19, usuario.getFinanceiroUsuario());
			pstmt.setInt	(20, usuario.getAgendaUsuario());
			pstmt.setInt	(21, usuario.getTpAcessoUsuario());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}
			
			Conexao.stopConnection(connection);
				
			return true;

		} catch (SQLException e) {

			e.printStackTrace();
				
			return false;
			
		} catch (Exception e) {

			e.printStackTrace();
				
			return false;
		}
	}
	
	/**
	 * 
	 * @param usuario
	 * @return flag
	 * @throws IOException
	 */
	
	public boolean alteraUsuario(Usuario usuario) throws IOException {

		try {

			connection = Conexao.getConnection();

			StringBuffer sql = new StringBuffer();
			sql.append("update usuario set nome_usuario=?, cpf_usuario=?, rg_usuario=?, crn_usuario=?, logradouro_usuario=?, num_logradouro_usuario=?, ")
				.append("complemento_usuario=?, bairro_usuario=?, cidade_usuario=?, uf_usuario=?, fone_res_usuario=?, ")
				.append("fone_cel_usuario=?, fone_com_usuario=?, email_usuario=?, login_usuario=?, ")
				.append("senha_usuario=?, permissao_cadastro_usuario=?, permissao_financeiro_usuario=?, permissao_agenda_usuario=? , tp_acesso_usuario=? ")
				.append("where id_usuario=?");

			PreparedStatement pstmt = connection.prepareStatement(sql.toString());

			pstmt.setString	(1,  usuario.getNomeUsuario());
			pstmt.setString	(2,  usuario.getCpfUsuario());
			pstmt.setString	(3,  usuario.getRgUsuario());
			pstmt.setString	(4,  usuario.getCrnUsuario());
			pstmt.setString	(5,  usuario.getLogradouroUsuario());
			pstmt.setString	(6,  usuario.getNumLogradouroUsuario());
			pstmt.setString	(7,  usuario.getComplementoUsuario());
			pstmt.setString	(8,  usuario.getBairroUsuario());
			pstmt.setString	(9,  usuario.getCidadeUsuario());
			pstmt.setString	(10, usuario.getUfUsuario());
			pstmt.setString	(11, usuario.getFoneResUsuario());
			pstmt.setString	(12, usuario.getFoneResUsuario());
			pstmt.setString	(13, usuario.getFoneComUsuario());
			pstmt.setString	(14, usuario.getEmailUsuario());
			pstmt.setString	(15, usuario.getLoginUsuario());
			pstmt.setString	(16, usuario.getSenhaUsuario());
			pstmt.setInt	(17, usuario.getCadastroUsuario());
			pstmt.setInt	(18, usuario.getFinanceiroUsuario());
			pstmt.setInt	(19, usuario.getAgendaUsuario());
			pstmt.setInt	(20, usuario.getTpAcessoUsuario());
			pstmt.setInt	(21, usuario.getIdUsuario());

			if (pstmt.executeUpdate() != 1) {
				return false;
			}

			Conexao.stopConnection(connection);
							
			return true;

		} catch (SQLException e) {
			
			e.printStackTrace();

			return false;
			
		} catch (Exception e) {
			
			e.printStackTrace();
						
			return false;
		}
	}
	
	/**
	 * 
	 * @param idUsuario
	 * @return flag
	 * @throws IOException
	 */

	public boolean excluiUsuario(int idUsuario) throws IOException {
		
		try {
			
			connection = Conexao.getConnection();

			statement = connection.createStatement();

			String sql = "delete from usuario where id_usuario=" + idUsuario;

			int retorno = statement.executeUpdate(sql);

			if (retorno != 1) {
				return false;
			}

			statement.close();
			Conexao.stopConnection(connection);

			return true;

		} catch (SQLException e) {

			e.printStackTrace();

			return false;
		}
	}
}