package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.ufpr.mityba.controller.GerenteConsultaAlimento;
import br.ufpr.mityba.controller.GerenteConsultaGrupoAlimenticio;
import br.ufpr.mityba.dao.AlimentoDAO;
import br.ufpr.mityba.dao.AuditLogDAO;
import br.ufpr.mityba.dao.GrupoAlimenticioDAO;
import br.ufpr.mityba.model.Alimento;
import br.ufpr.mityba.model.AuditLog;
import br.ufpr.mityba.model.GrupoAlimenticio;
import br.ufpr.mityba.util.Constantes;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * Servlet implementation class ServletAlimento
 * 
 * @author Mityba
 * @since 12/11/2008
 * @version 1.0 12/11/2008
 */
public class ServletAlimento extends HttpServlet {
	
	private static final long serialVersionUID = 1231231L;
       
	/**
	 * @param pReq 
	 * @param pResp 
	 * @throws ServletException 
	 * @throws IOException 
	 * 
	 */
	public void service(final HttpServletRequest pReq, final HttpServletResponse pResp) throws ServletException, IOException {

		Vector<String> tErro = new Vector<String>();

		HttpSession session = pReq.getSession(false);

		String service = pReq.getParameter("service");

		if (session == null) {

			tErro.add("Voc deve efetuar o login antes de acessar essa funcionalidade!");

		} else {

			if (service == null || service.equals("")) {

				tErro.add("Informar a ao a ser executada\n");

			} else if (service.equals("cadastroTabelaSubstituicao")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){

					acaoCadastroTabSubstituicao(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("adicionarAlimento")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoSalvarAlimento(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("adicionarGrupo")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoSalvarGrupo(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("removerAlimento")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoExclusaoAlimento(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("removerGrupo")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoExclusaoGrupo(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("editarAlimento")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoEditarAlimento(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("alterarAlimento")) {
				
				acaoAlterarAlimento(pReq, pResp, session);
				
			} else if (service.equals("editarGrupo")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoEditarGrupo(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("alterarGrupo")) {
				
				acaoAlterarGrupo(pReq, pResp, session);
				
			} else if (service.equals("apresentaAlimentos")) {
				
				acaoApresentaAlimentos(pReq, pResp);
				
			} else if (service.equals("voltaTela")) {

				ativarPagina(pReq, pResp, "/PaginaInicial.jsp");
			}
		}

		if (tErro.size() > 0) {
			mostrarErro(pReq, pResp, tErro, "/PaginaInicial.jsp");
		}
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

	private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {
		pReq.setAttribute("Erros", pErro);
		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {
		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoCadastroTabSubstituicao(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		ControlePrincipal controle = new ControlePrincipal();
		
		session.setAttribute(Constantes.ATRIB_DT_INI_CAD_ALIMENTO	, Constantes.HORA_ATUAL());
		session.setAttribute(Constantes.ATRIB_DT_INI_CAD_GR_ALIMENTO, Constantes.HORA_ATUAL());
		
		if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
			pReq.setAttribute("Grupos", controle.getGruposAlimenticios());

		ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoSalvarGrupo(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		Vector<String> tErro			= new Vector<String>();
		
		ControlePrincipal controle		= new ControlePrincipal();
		
		String nomeGrupoDigitado 		= pReq.getParameter("nomeGrupo");
		double valorCaloricoDigitado	= 0.0;

		try{
			valorCaloricoDigitado 		= Double.parseDouble(pReq.getParameter("valorCalorico").replace(",", "."));
		}catch (NumberFormatException e) {
			tErro.add("Campo valor calrico com valor invlido!");
		}
		
		if(nomeGrupoDigitado == null || nomeGrupoDigitado.equals(""))
			tErro.add("O campo nome do grupo deve ser preenchido!");
		
		if(tErro.size() > 0){
			mostrarErro(pReq, pResp, tErro, "/cadastroTabelaSubstituicao.jsp");
			
		} else {
			
			GrupoAlimenticio grupo = new GrupoAlimenticio(
					0,
					valorCaloricoDigitado,
					nomeGrupoDigitado
			);
			
			if(new GrupoAlimenticioDAO().incluiGrupoAlimenticio(grupo)){
				
				String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
				String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
				String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_CAD_GR_ALIMENTO);
				
				AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_CADASTRO_GR_ALIMENTO);
				
				new AuditLogDAO().incluiRegistro(audit);
				
				session.setAttribute(Constantes.ATRIB_DT_INI_CAD_GR_ALIMENTO, Constantes.HORA_ATUAL());
				
			} else {
				
				pReq.setAttribute("Msg", "Problemas ao cadastrar o grupo alimentcio");
			}
			
			if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
				pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
			
			ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoSalvarAlimento(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		Vector<String> tErro			= new Vector<String>();
		
		ControlePrincipal controle		= new ControlePrincipal();

		int    idGrupoDigitado			= Integer.parseInt(pReq.getParameter("codGrupoAlimento"));
		String nomeAlimentoDigitado 	= pReq.getParameter("nomeAlimento");
		String valoresAlimentoDigitado 	= pReq.getParameter("valorAlimento");
		
		if(nomeAlimentoDigitado == null || nomeAlimentoDigitado.equals(""))
			tErro.add("O campo nome do alimento deve ser preenchido!");
		
		if(valoresAlimentoDigitado == null || valoresAlimentoDigitado.equals(""))
			tErro.add("O campo valor do alimento deve ser preenchido!");
		
		if(idGrupoDigitado == -1)
			tErro.add("Um grupo alimentcio deve ser escolhido");
		
		if(tErro.size() > 0){
			mostrarErro(pReq, pResp, tErro, "/cadastroTabelaSubstituicao.jsp");
			
		} else {
			
			Alimento alimento = new Alimento(
					0,
					idGrupoDigitado,
					nomeAlimentoDigitado,
					valoresAlimentoDigitado
			);
			
			if(new AlimentoDAO().incluiAlimento(alimento)){
				
				String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
				String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
				String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_CAD_ALIMENTO);
				
				AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_CADASTRO_ALIMENTO);
				
				new AuditLogDAO().incluiRegistro(audit);
				
				session.setAttribute(Constantes.ATRIB_DT_INI_CAD_ALIMENTO, Constantes.HORA_ATUAL());
				
			} else {
				
				pReq.setAttribute("Msg", "Problemas ao cadastrar o alimento");
			}
			
			pReq.setAttribute("GrupoAlimento", String.valueOf(idGrupoDigitado));
			
			if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
				pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
			
			if(GerenteConsultaAlimento.alimentoPorGrupo(controle, idGrupoDigitado))
				pReq.setAttribute("Alimentos", controle.getAlimentos());
			
			ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoExclusaoGrupo(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		ControlePrincipal controle = new ControlePrincipal();
		
		String codDigitado 	= pReq.getParameter("codGrupo");
			
		int codigo			= 0;
		
		try{
			codigo = Integer.parseInt(codDigitado);
		}catch (NumberFormatException e) {
			codigo = 0;
		}
			
		if(new GrupoAlimenticioDAO().excluiGrupoAlimenticio(codigo)){
			
			String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
			String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
			String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_EXC_GR_ALIMENTO);
			
			AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_EXCLUSAO_GR_ALIMENTO);
			
			new AuditLogDAO().incluiRegistro(audit);
			
		} else {
			
			pReq.setAttribute("Msg", "Problemas ao excluir o grupo alimentcio");
		}
		
		if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
			pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
		
		ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
		
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoExclusaoAlimento(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		ControlePrincipal controle		= new ControlePrincipal();
		
		String codDigitado 				= pReq.getParameter("codAlimento");
			
		int codigo						= 0;
		int    idGrupoDigitado			= Integer.parseInt(pReq.getParameter("codGrupoAlimento"));
		
		try{			
			codigo = Integer.parseInt(codDigitado);
		}catch (NumberFormatException e) {
			codigo = 0;
		}
			
		if(new AlimentoDAO().excluiAlimento(codigo)){
			
			String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
			String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
			String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_EXC_ALIMENTO);
			
			AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_EXCLUSAO_ALIMENTO);
			
			new AuditLogDAO().incluiRegistro(audit);
			
		} else {
			
			pReq.setAttribute("Msg", "Problemas ao excluir o alimento");
		}
		
		pReq.setAttribute("GrupoAlimento", String.valueOf(idGrupoDigitado));
		
		if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
			pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
		
		if(GerenteConsultaAlimento.alimentoPorGrupo(controle, idGrupoDigitado))
			pReq.setAttribute("Alimentos", controle.getAlimentos());
		
		ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
		
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoEditarAlimento(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
				
		session.setAttribute(Constantes.ATRIB_DT_INI_ALT_ALIMENTO, Constantes.HORA_ATUAL());
		
		ControlePrincipal controle	= new ControlePrincipal();
		
		Alimento alimento			= null;
		
		int codAlimento				= Integer.parseInt(pReq.getParameter("codAlimento"));		
		
		if(GerenteConsultaAlimento.alimentoPorCodigo(controle, codAlimento)){
			
			alimento = controle.getAlimentos().get(0);

			pReq.setAttribute("Alimento"		, String.valueOf(alimento.getIdAlimento()));
			pReq.setAttribute("GrupoAlimento"	, String.valueOf(alimento.getIdGrupoAlimenticioAlimento()));
			pReq.setAttribute("NomeAlimento"	, alimento.getNomeAlimento());
			pReq.setAttribute("ValorAlimento"	, alimento.getValoresAlimento());
			
			pReq.setAttribute("Acao"			, "EditarAlimento");
		}
		
		pReq.setAttribute("GrupoAlimento", String.valueOf(alimento.getIdGrupoAlimenticioAlimento()));

		if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
			pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
		
		if(GerenteConsultaAlimento.alimentoPorGrupo(controle, alimento.getIdGrupoAlimenticioAlimento()))
			pReq.setAttribute("Alimentos", controle.getAlimentos());
		
		ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");		
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoEditarGrupo(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
				
		session.setAttribute(Constantes.ATRIB_DT_INI_ALT_GR_ALIMENTO, Constantes.HORA_ATUAL());
		
		ControlePrincipal controle	= new ControlePrincipal();
		
		GrupoAlimenticio grupo		= null;
		
		int codGrupo				= Integer.parseInt(pReq.getParameter("codGrupo"));		
		
		if(GerenteConsultaGrupoAlimenticio.grupoPorCodigo(controle, codGrupo)){
			
			grupo = controle.getGruposAlimenticios().get(0);

			pReq.setAttribute("Grupo"			, String.valueOf(grupo.getIdGrupoAlimenticio()));
			pReq.setAttribute("NomeGrupo"		, grupo.getNomeGrupoAlimenticio());
			pReq.setAttribute("ValorCalorico"	, String.valueOf(grupo.getValorCaloricoGrupoAlimenticio()));
			
			pReq.setAttribute("Acao"			, "EditarGrupo");
		}

		if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
			pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
		
		ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");		
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAlterarGrupo(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		Vector<String> tErro			= new Vector<String>();
		
		ControlePrincipal controle		= new ControlePrincipal();
		
		int    idGrupo					= Integer.parseInt(pReq.getParameter("codAltGrupo"));
		String nomeGrupoDigitado 		= pReq.getParameter("nomeGrupo");
		double valorCaloricoDigitado	= 0.0;

		try{
			valorCaloricoDigitado 		= Double.parseDouble(pReq.getParameter("valorCalorico").replace(",", "."));
		}catch (NumberFormatException e) {
			tErro.add("Campo valor calrico com valor invlido!");
		}
		
		
		if(nomeGrupoDigitado == null || nomeGrupoDigitado.equals(""))
			tErro.add("O campo nome do grupo deve ser preenchido!");
		
		if(tErro.size() > 0){
			mostrarErro(pReq, pResp, tErro, "/cadastroTabelaSubstituicao.jsp");
			
		} else {
			
			GrupoAlimenticio grupo = new GrupoAlimenticio(
					idGrupo,
					valorCaloricoDigitado,
					nomeGrupoDigitado
			);
			
			if(new GrupoAlimenticioDAO().alteraGrupoAlimenticio(grupo)){
				
				String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
				String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
				String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_ALT_GR_ALIMENTO);
				
				AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_ALTERACAO_GR_ALIMENTO);
				
				new AuditLogDAO().incluiRegistro(audit);
				
				session.setAttribute(Constantes.ATRIB_DT_INI_ALT_GR_ALIMENTO, Constantes.HORA_ATUAL());
				
			} else {
				
				pReq.setAttribute("Msg", "Problemas ao alterar o grupo alimentcio");
			}
			
			if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
				pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
			
			ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAlterarAlimento(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		Vector<String> tErro			= new Vector<String>();
		
		ControlePrincipal controle		= new ControlePrincipal();

		int    idAlimentoDigitado		= Integer.parseInt(pReq.getParameter("codAltAlimento"));
		int    idGrupoDigitado			= Integer.parseInt(pReq.getParameter("codGrupoAlimento"));
		String nomeAlimentoDigitado 	= pReq.getParameter("nomeAlimento");
		String valoresAlimentoDigitado 	= pReq.getParameter("valorAlimento");
		
		if(nomeAlimentoDigitado == null || nomeAlimentoDigitado.equals(""))
			tErro.add("O campo nome do alimento deve ser preenchido!");
		
		if(valoresAlimentoDigitado == null || valoresAlimentoDigitado.equals(""))
			tErro.add("O campo valor do alimento deve ser preenchido!");
		
		if(idGrupoDigitado == -1)
			tErro.add("Um grupo alimentcio deve ser escolhido");
		
		if(tErro.size() > 0){
			mostrarErro(pReq, pResp, tErro, "/cadastroTabelaSubstituicao.jsp");
			
		} else {
			
			Alimento alimento = new Alimento(
					idAlimentoDigitado,
					idGrupoDigitado,
					nomeAlimentoDigitado,
					valoresAlimentoDigitado
			);
			
			if(new AlimentoDAO().alteraAlimento(alimento)){
				
				String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
				String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
				String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_ALT_ALIMENTO);
				
				AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_ALTERACAO_ALIMENTO);
				
				new AuditLogDAO().incluiRegistro(audit);
				
			} else {
				
				pReq.setAttribute("Msg", "Problemas ao alterar o alimento");
			}
			
			pReq.setAttribute("GrupoAlimento", String.valueOf(idGrupoDigitado));
			
			if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
				pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
			
			if(GerenteConsultaAlimento.alimentoPorGrupo(controle, idGrupoDigitado))
				pReq.setAttribute("Alimentos", controle.getAlimentos());
			
			ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoApresentaAlimentos(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
		
		ControlePrincipal controle 		= new ControlePrincipal();
		
		int    idGrupoDigitado			= Integer.parseInt(pReq.getParameter("codGrupoAlimento"));
		
		if(GerenteConsultaAlimento.alimentoPorGrupo(controle, idGrupoDigitado))
			pReq.setAttribute("Alimentos", controle.getAlimentos());
		
		if(GerenteConsultaGrupoAlimenticio.todosGrupos(controle))
			pReq.setAttribute("Grupos", controle.getGruposAlimenticios());
		
		pReq.setAttribute("GrupoAlimento", String.valueOf(idGrupoDigitado));
		
		ativarPagina(pReq, pResp, "/cadastroTabelaSubstituicao.jsp");
	}
}