package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.ufpr.mityba.controller.GerenteConsultaPaciente;
import br.ufpr.mityba.dao.PacienteDAO;
import br.ufpr.mityba.model.Paciente;
import br.ufpr.mityba.util.Constantes;
import br.ufpr.mityba.util.ControlePrincipal;

/**
 * Servlet implementation class for Servlet: ServletCadastroSite
 * 
 * @author Mityba
 * @since 09/12/2008
 * @version 1.0 09/12/2008
 */
 public class ServletCadastroSite extends HttpServlet implements Servlet {
	 
   static final long serialVersionUID = 13243842L;
   
   /**
	 * @param pReq 
	 * @param pResp 
	 * @throws ServletException 
	 * @throws IOException 
	 * 
	 */
   public void service(HttpServletRequest pReq, HttpServletResponse pResp)	throws ServletException, IOException {
	   
		Vector<String> tErro = new Vector<String>();

		HttpSession session = pReq.getSession(false);

		String service = pReq.getParameter("service");

		if (session == null) {

			tErro.add("Voc deve efetuar o login antes de acessar essa funcionalidade!");

		} else {
		
			if (service == null || service.equals("")) {
	
				tErro.add("Informar a ao a ser executada\n");
	
			} else if (service.equals("cadastro")) {
				
				acaoCadastroSite(pReq, pResp, session);
	
			} else if (service.equals("salvarAlteracao")) {
				
				acaoSalvarAlteracao(pReq, pResp, session);	
			}
		}
		
		if (tErro.size() > 0){			
			mostrarErro(pReq, pResp, tErro, "/user_home.jsp");
		}
   }

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

   private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {

		pReq.setAttribute("Erros", pErro);

		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {

		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoCadastroSite(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		ControlePrincipal controle = new ControlePrincipal();
		
		int idPaciente = (Integer) session.getAttribute(Constantes.ATRIB_ID_USUARIO_LOGADO);
		
		GerenteConsultaPaciente.pacientePorCodigo(controle, idPaciente);
		
		Paciente paciente = controle.getPacientes().get(0);

		pReq.setAttribute("Nome"		, paciente.getNome());
		pReq.setAttribute("DtNasc"		, paciente.getDtNasc());
		pReq.setAttribute("EstadoCivil"	, paciente.getEstadoCivil());
		pReq.setAttribute("Logradouro"	, paciente.getLogradouro());
		pReq.setAttribute("Numero"		, paciente.getNumEndereco());
		pReq.setAttribute("Complemento"	, paciente.getComplemento());
		pReq.setAttribute("Bairro"		, paciente.getBairro());
		pReq.setAttribute("Cidade"		, paciente.getCidade());
		pReq.setAttribute("UF"			, paciente.getUf());
		pReq.setAttribute("FoneRes"		, paciente.getFoneRes());
		pReq.setAttribute("FoneCel"		, paciente.getFoneCel());
		pReq.setAttribute("FoneCom"		, paciente.getFoneCom());
		pReq.setAttribute("Email"		, paciente.getEmail());
		
		ativarPagina(pReq, pResp, "/user_cadastro.jsp");
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoSalvarAlteracao(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		ControlePrincipal controle = new ControlePrincipal();
		
		int idPaciente = (Integer) session.getAttribute(Constantes.ATRIB_ID_USUARIO_LOGADO);
		
		GerenteConsultaPaciente.pacientePorCodigo(controle, idPaciente);
		
		Paciente paciente = controle.getPacientes().get(0);

		paciente.setNome		(pReq.getParameter("nome"));
		paciente.setDtNasc		(pReq.getParameter("dtNasc"));
		paciente.setEstadoCivil	(pReq.getParameter("estadoCivil"));
		paciente.setLogradouro	(pReq.getParameter("endereco"));
		paciente.setNumEndereco	(pReq.getParameter("numero"));
		paciente.setComplemento	(pReq.getParameter("complemento"));
		paciente.setBairro		(pReq.getParameter("bairro"));
		paciente.setCidade		(pReq.getParameter("cidade"));
		paciente.setUf			(pReq.getParameter("uf"));
		paciente.setFoneRes		(pReq.getParameter("foneResidencial"));
		paciente.setFoneCel		(pReq.getParameter("foneCelular"));
		paciente.setFoneCom		(pReq.getParameter("foneComercial"));
		paciente.setEmail		(pReq.getParameter("email"));
		
		new PacienteDAO().alteraPaciente(paciente);
		
		ativarPagina(pReq, pResp, "/user_home.jsp");
	}
}