package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.ufpr.mityba.controller.GerenteCalendario;
import br.ufpr.mityba.controller.GerenteConsultaConsulta;
import br.ufpr.mityba.controller.GerenteConsultaConvenio;
import br.ufpr.mityba.controller.GerenteConsultaHorarioConsulta;
import br.ufpr.mityba.controller.GerenteConsultaPaciente;
import br.ufpr.mityba.controller.GerenteConsultaUsuario;
import br.ufpr.mityba.dao.ConsultaDAO;
import br.ufpr.mityba.dao.LancamentoDAO;
import br.ufpr.mityba.dao.PacienteDAO;
import br.ufpr.mityba.model.Consulta;
import br.ufpr.mityba.model.HorarioConsulta;
import br.ufpr.mityba.model.Lancamento;
import br.ufpr.mityba.model.Paciente;
import br.ufpr.mityba.model.ViewPacienteConsulta;
import br.ufpr.mityba.util.Constantes;
import br.ufpr.mityba.util.ControlePrincipal;
import br.ufpr.mityba.util.Utilitarios;


/**
 * Servlet implementation class for Servlet: ServletCalendario
 * 
 * @author Mityba
 * @since 06/08/2008
 * @version 1.0 06/08/2008
 * @version 1.1 19/11/2008
 * @version 2.0 27/11/2008
 * 
 */
public class ServletCalendario extends HttpServlet implements Servlet {

	static final long serialVersionUID = 1546465L;	

	/**
    * @param pReq 
    * @param pResp 
    * @throws ServletException 
    * @throws IOException 
    * 
    */
	public void service(HttpServletRequest pReq, HttpServletResponse pResp)	throws ServletException, IOException {

		Vector<String> tErro = new Vector<String>();
		
		HttpSession session = pReq.getSession(false);
		
		if (session == null) {

			tErro.add("Voc deve efetuar o login antes de acessar essa funcionalidade!");

		} else {

			String service = pReq.getParameter("service");
	
			if (service == null || service.equals("")) {
	
				tErro.add("Informar a ao a ser executada\n");
				
			} else if (service.equals("entrarAgenda")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_AGENDA) >= 2){
				
					acaoEntrarAgenda(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("procurarPaciente")) {
				
				acaoPesquisarPacientes(pReq, pResp, session);
				
			} else if (service.equals("novoPaciente")) {
				
				acaoNovoPaciente(pReq, pResp, session);
				
			} else if (service.equals("escolherPaciente")) {
				
				acaoEscolherPaciente(pReq, pResp, session);
				
			} else if (service.equals("agendarConsulta")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_AGENDA) == 3){
				
					acaoAgendarConsulta(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("atenderConsulta")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_AGENDA) == 3 && (Integer) session.getAttribute(Constantes.ATRIB_TIPO_ACESSO) <= Constantes.ACESSO_MEDICO){
				
					acaoRealizarConsulta(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("faltaConsulta")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_AGENDA) == 3){
				
					acaoFaltaConsulta(pReq, pResp, session, true);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("remarcarConsulta")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_AGENDA) == 3){
				
					acaoFaltaConsulta(pReq, pResp, session, false);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("avancaMes")) {
				
				acaoAvancaMes(pReq, pResp, session);
				
			} else if (service.equals("voltaMes")) {
				
				acaoVoltaMes(pReq, pResp, session);
				
			} else if (service.equals("detalhe")) {
				
				acaoDetalhe(pReq, pResp, session);
				
			} else if (service.equals("voltaDia")) {
				
				acaoVoltaDia(pReq, pResp, session);
				
			} else if (service.equals("avancaDia")) {
				
				acaoAvancaDia(pReq, pResp, session);
				
			} else if (service.equals("mudaSelecao")) {
				
				acaoMudaVisualizacao(pReq, pResp, session);
				
			} else if (service.equals("mudaMedico")) {
				
				acaoEntrarAgenda(pReq, pResp, session);
				
			} else if (service.equals("voltaTela")) {
				
				ativarPagina(pReq, pResp, "/PaginaInicial.jsp");			
			}
		}
		
		if(tErro.size() > 0){
			mostrarErro(pReq, pResp, tErro, "/PaginaInicial.jsp");
		}
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

	private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {

		pReq.setAttribute("Erros", pErro);

		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {

		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoEntrarAgenda(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		long dataCorrente = 0L;
		
		try{
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		pReq.setAttribute("Visualizacao", pReq.getParameter("visualizacao"));
		
		String dia = new SimpleDateFormat("dd").format  (dataCorrente);
		String mes = new SimpleDateFormat("MM").format  (dataCorrente);
		String ano = new SimpleDateFormat("yyyy").format(dataCorrente);		

		acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, ano + mes + dia, session);
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoMudaVisualizacao(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		long dataCorrente = 0L;
		
		try{
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		pReq.setAttribute("Visualizacao", pReq.getParameter("visualizacao"));

		acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, pReq.getParameter("dataDetalhe"), session);
	}
	

	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @param eFalta
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoFaltaConsulta(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session, boolean eFalta) throws ServletException, IOException {
		
		Vector<String> tErro		= new Vector<String>();
		
		ControlePrincipal controle	= new ControlePrincipal();
		
		Consulta consulta			= null;

		String idsConsultaHorario	= pReq.getParameter("idConsulta");
		
		long miliDataDetalhe		= 0L;
		
		int codConsulta				= 0;
		
		try{
			codConsulta = Integer.parseInt(idsConsultaHorario.substring(0, idsConsultaHorario.indexOf(".")));
		}catch (Exception e) {
			codConsulta = 0;
		}
		
		try{
			miliDataDetalhe = Long.parseLong(pReq.getParameter("miliDataDetalhe"));
		}catch (Exception e) {
			miliDataDetalhe = System.currentTimeMillis();
		}
		
		if (codConsulta == 0){
			
			tErro.add("No h consultas agendadas nesse horrio");
		
		} else {
			
			GerenteConsultaConsulta.consultaPorCodigo(controle, codConsulta);
			
			consulta 	= controle.getConsultas().get(0);
			
			if(consulta.getIdStatusConsulta() != Constantes.COD_CONSULTA_PENDENTE){				
				tErro.add("A consulta escolhida no est pendente");
			}
		}		

		if(tErro.size() > 0){

			pReq.setAttribute("Erros", tErro);
			acaoEntrarAgenda(pReq, pResp, session);

		} else {
			
			consulta.setIdStatusConsulta(eFalta ? Constantes.COD_CONSULTA_FALTA : Constantes.COD_CONSULTA_REMARCADA);
			
			if(!eFalta)	consulta.setIdHorarioConsulta(0); //Caso a consulta seja remarcarcada ela deixa de aparecer no calendrio
			
			GerenteConsultaConvenio.convenioPorCodigo(controle, consulta.getIdConvenioConsulta());			
			
			Lancamento lancamento = new Lancamento(
				0,
				consulta.getIdConvenioConsulta(),
				consulta.getIdStatusConsulta(),
				controle.getConvenios().get(0).getValorConsultaConvenio(),
				new SimpleDateFormat("dd/MM/yyyy").format(miliDataDetalhe)
			);
			
			new LancamentoDAO().incluiLancamento(lancamento);
			
			new ConsultaDAO().alteraConsulta(consulta);
				
			acaoEntrarAgenda(pReq, pResp, session);	
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoRealizarConsulta(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		Vector<String> tErro		= new Vector<String>();
		
		String[] opcoes				= pReq.getParameterValues("marcar");
		
		ControlePrincipal controle	= new ControlePrincipal();
		
		Consulta consulta			= null;
		
		int codConsulta				= 0;
		
		if(opcoes == null || opcoes.length == 0){
			
			tErro.add(" necessrio que algum horrio seja escolhido");
			
		} else if(opcoes.length > 1){
			
			tErro.add("Escolha apenas um horrio para realizar consulta");
			
		} else if (Integer.parseInt(opcoes[0].substring(0, opcoes[0].indexOf("."))) == 0){
			
			tErro.add("No h consultas agendadas nesse horrio");
		
		} else {
			
			codConsulta	= Integer.parseInt(opcoes[0].substring(0, opcoes[0].indexOf(".")));
			
			GerenteConsultaConsulta.consultaPorCodigo(controle, codConsulta);
			
			consulta 	= controle.getConsultas().get(0);
			
			if(consulta.getIdStatusConsulta() != Constantes.COD_CONSULTA_PENDENTE){
				
				tErro.add("A consulta escolhida no est pendente");
			}
		}

		if(tErro.size() > 0){

			pReq.setAttribute("Erros", tErro);
			acaoEntrarAgenda(pReq, pResp, session);

		} else {

			pReq.setAttribute("CodConsulta", String.valueOf(codConsulta)); //idConsulta

			RequestDispatcher disp = pReq.getRequestDispatcher("ServletConsulta");
			disp.forward(pReq, pResp);
		}
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoEscolherPaciente(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		ControlePrincipal controle 	= new ControlePrincipal();
		
		Paciente paciente			= null;
		
		int codPaciente 			= Integer.parseInt(pReq.getParameter("codPaciente"));
		
		if(GerenteConsultaPaciente.pacientePorCodigo(controle, codPaciente)){
			
			paciente = controle.getPacientes().get(0);

			pReq.setAttribute("CodPaciente"	, String.valueOf(paciente.getIdPaciente()));
			pReq.setAttribute("Nome"		, paciente.getNome());
			pReq.setAttribute("Convenio"	, String.valueOf(paciente.getIdConvenio()));
			pReq.setAttribute("Contato"		, paciente.getFoneCel());
		}
		
		acaoEntrarAgenda(pReq, pResp, session);
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoAgendarConsulta(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		ControlePrincipal controle 	= new ControlePrincipal();
		
		Vector<String> tErro		= new Vector<String>();
		
		PacienteDAO pacienteDAO		= new PacienteDAO(controle);
		
		Paciente paciente			= null;
		
		Consulta consulta			= null;
		
		int codPaciente 			= 0;
		
		boolean eNovo				= pReq.getParameter("eNovo").equals("sim");
		
		String[] opcoes				= pReq.getParameterValues("marcar");
		
		String dataDetalhe			= pReq.getParameter("dataDetalhe");
		
		//------- Caso o codigo seja "null"  porque no foi pesquisado nenhum paciente ou  um novo
		
		try{
			codPaciente 			= Integer.parseInt(pReq.getParameter("codPaciente"));			
		} catch (Exception e) {
			if(!eNovo)
				tErro.add("Pesquise o paciente clicando na lupa");
			else{				
				String nome	= pReq.getParameter("nome");				
				if(nome == null || nome.equals(""))
					tErro.add("O campo nome deve ser preenchido");				
			}
		}
		
		//-------
		
		if(opcoes == null || opcoes.length == 0){
			
			tErro.add(" necessrio que algum horrio seja escolhido");
			
		} else if(opcoes.length > 1){
			
			tErro.add("Escolha apenas um horrio para agendamento");
			
		} else if (Integer.parseInt(opcoes[0].substring(0, opcoes[0].indexOf("."))) != 0){
			
			tErro.add("J existe uma consulta agendada nesse horrio");
		}
		
		if(tErro.size() > 0){
			
			pReq.setAttribute("Erros", tErro);
			acaoEntrarAgenda(pReq, pResp, session);
			
		} else {
			
			int idUsuario	= (Integer) session.getAttribute(Constantes.ATRIB_ID_USUARIO_LOGADO);
			int idConvenio	= Integer.parseInt(pReq.getParameter("convenio"));

			String obs		= pReq.getParameter("observacao");
				
			if(eNovo){
				
				String nome 	= pReq.getParameter("nome");
				String contato 	= pReq.getParameter("contato");
		
				paciente = new Paciente();
				
				paciente.setNome		(nome);
				paciente.setFoneCel		(contato);
				paciente.setIdConvenio	(idConvenio);
				paciente.setAtivo		("s");
				
				pacienteDAO.incluiPaciente(paciente);
				
				codPaciente = pacienteDAO.maxIdPacientes();
			}

			consulta = new Consulta(
				0,
				Integer.parseInt(opcoes[0].substring((opcoes[0].indexOf(".")) + 1)), //idHorarioConsulta
				idConvenio,
				codPaciente,
				idUsuario,
				Constantes.COD_CONSULTA_PENDENTE,
				eNovo,
				obs,
				dataDetalhe.substring(6) + "/" + dataDetalhe.substring(4, 6) + "/" + dataDetalhe.substring(0, 4)
			);
			
			new ConsultaDAO().incluiConsulta(consulta);

			acaoEntrarAgenda(pReq, pResp, session);
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoAvancaMes(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String diaDetalhe 	= pReq.getParameter("diaDetalhe");
		
		long dataCorrente = 0L;
		
		try{			
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));			
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		//Caso 30 dias a mais avancem o limite do ms corrente
		
		if(new SimpleDateFormat("yyyy").format(dataCorrente).equals(new SimpleDateFormat("yyyy").format(dataCorrente + Constantes.MILISEGUNDOS_MES))){
			while(Integer.parseInt(new SimpleDateFormat("MM").format(dataCorrente)) != 
				 (Integer.parseInt(new SimpleDateFormat("MM").format(dataCorrente + Constantes.MILISEGUNDOS_MES)) - 1)){
				
				dataCorrente -= Constantes.MILISEGUNDOS_DIA;
			}
		}
		
		long dataReferendia = dataCorrente += Constantes.MILISEGUNDOS_MES;

		String mes = new SimpleDateFormat("MM").format  (dataReferendia);
		String ano = new SimpleDateFormat("yyyy").format(dataReferendia);
		
		acaoMontarCalendario(pReq, pResp, dataReferendia, dataCorrente, ano + mes + diaDetalhe, session);	
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoVoltaMes(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String diaDetalhe 	= pReq.getParameter("diaDetalhe");
		
		long dataCorrente = 0L;
		
		try{			
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));			
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		//Caso 30 dias a menos avancem o limite do ms corrente
		
		if(new SimpleDateFormat("yyyy").format(dataCorrente).equals(new SimpleDateFormat("yyyy").format(dataCorrente - Constantes.MILISEGUNDOS_MES))){
			while(Integer.parseInt(new SimpleDateFormat("MM").format(dataCorrente)) != 
				 (Integer.parseInt(new SimpleDateFormat("MM").format(dataCorrente - Constantes.MILISEGUNDOS_MES)) + 1)){
				
				dataCorrente += Constantes.MILISEGUNDOS_DIA;
			}
		}
		
		long dataReferendia = dataCorrente -= Constantes.MILISEGUNDOS_MES;
		
		String mes = new SimpleDateFormat("MM").format(dataReferendia);
		String ano = new SimpleDateFormat("yyyy").format(dataReferendia);
		
		acaoMontarCalendario(pReq, pResp, dataReferendia, dataCorrente, ano + mes + diaDetalhe, session);
	
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoAvancaDia(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String dataDetalhe 	= pReq.getParameter("dataDetalhe");
		
		long dataCorrente = 0L;
		
		try{			
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));			
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		String dia = new SimpleDateFormat("dd").format  (dataCorrente);
		String mes = new SimpleDateFormat("MM").format  (dataCorrente);
		String ano = new SimpleDateFormat("yyyy").format(dataCorrente);
		
		try{
			
			String dataNumDetalhe =  "";
			
			//Tratamento do ltimo dia do ms
			
			if (dataDetalhe.endsWith(String.valueOf(GerenteCalendario.carregaArrayMeses()[Integer.parseInt(mes) - 1]))){
				
				dataNumDetalhe = dataDetalhe;
			
			} else {
				
				dataNumDetalhe = String.valueOf(Integer.parseInt(dataDetalhe) + 1);
			}
			
			acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, dataNumDetalhe, session);	

		} catch (Exception e) {
			
			acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, String.valueOf(Integer.parseInt(ano + mes + dia) + 1), session);
		}
		
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoVoltaDia(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String dataDetalhe 	= pReq.getParameter("dataDetalhe");
		
		long dataCorrente = 0L;
		
		try{			
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));			
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		String dia = new SimpleDateFormat("dd").format  (dataCorrente);
		String mes = new SimpleDateFormat("MM").format  (dataCorrente);
		String ano = new SimpleDateFormat("yyyy").format(dataCorrente);
		
		try{
			
			String dataNumDetalhe =  "";
			
			//Tratamento do primeiro dia do ms
			
			if (dataDetalhe.endsWith("01")){
				
				dataNumDetalhe = dataDetalhe;
			
			} else {
				
				dataNumDetalhe = String.valueOf(Integer.parseInt(dataDetalhe) - 1);
			}
			
			acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, dataNumDetalhe, session);
			
		} catch (Exception e) {
			
			acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, String.valueOf(Integer.parseInt(ano + mes + dia) - 1), session);
		}
	
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws IOException 
	 * @throws ServletException 
	 */

	private void acaoDetalhe(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String dataDetalhe 	= pReq.getParameter("dataDetalhe");
		
		long dataCorrente = 0L;
		
		try{			
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));			
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, dataDetalhe, session);	
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoPesquisarPacientes(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
				
		ControlePrincipal controle 	= new ControlePrincipal();
		
		long dataCorrente = 0L;
		
		try{			
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));			
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		String dia = new SimpleDateFormat("dd").format  (dataCorrente);
		String mes = new SimpleDateFormat("MM").format  (dataCorrente);
		String ano = new SimpleDateFormat("yyyy").format(dataCorrente);
		
		String nomeDigitado	= pReq.getParameter("nome");
		
		if(GerenteConsultaPaciente.pacientePorNome(controle, nomeDigitado, false)){
			
			pReq.setAttribute("Pacientes", controle.getPacientes());
			
		} else {
			
			pReq.setAttribute("Msg", "Problemas na pesquisa de pacientes");
		}
		
		acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, ano + mes + dia, session);
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoNovoPaciente(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		long dataCorrente = 0L;
		
		try{			
			dataCorrente = Long.parseLong((String) pReq.getParameter("dataCorrente"));			
		}catch (Exception e) {
			dataCorrente = System.currentTimeMillis();
		}
		
		String dia = new SimpleDateFormat("dd").format  (dataCorrente);
		String mes = new SimpleDateFormat("MM").format  (dataCorrente);
		String ano = new SimpleDateFormat("yyyy").format(dataCorrente);

		//pReq.setAttribute("Msg"					, "Preencha as informaes bsicas para cadastro futuro");
		pReq.setAttribute("eNovo"				, "sim");
		pReq.setAttribute("EPrimeiraConsulta"	, "s");
		
		acaoMontarCalendario(pReq, pResp, dataCorrente, dataCorrente, ano + mes + dia, session);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param miliDataAtual
	 * @param miliDataAnterior
	 * @param detalhe
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */

	@SuppressWarnings("deprecation")
	private void acaoMontarCalendario(HttpServletRequest pReq, HttpServletResponse pResp, long miliDataAtual, long miliDataAnterior, String detalhe, HttpSession session) 
		throws ServletException, IOException {
		
		ControlePrincipal controle = new ControlePrincipal();
		
		ConsultaDAO consultaDAO				= new ConsultaDAO(controle);

		Vector<HorarioConsulta> horarios	= null;
		Vector<ViewPacienteConsulta> views	= new Vector<ViewPacienteConsulta>();
		
		ViewPacienteConsulta view			= null;
		
		int[] monthDays 		= GerenteCalendario.carregaArrayMeses();
		
		boolean eSecretaria		= (Integer) session.getAttribute(Constantes.ATRIB_TIPO_ACESSO) == Constantes.ACESSO_SECRETARIA;
		
		int medico				= 0;
		
		try{			
			medico				= Integer.parseInt(pReq.getParameter("medico"));			
		}catch (Exception e) {			
			medico				= 0;
		}

		int diaSemana 			= 0;
		int diaDetalhe 			= 0;
		int mesDetalhe 			= 0;
		int anoDetalhe 			= 0;
		int auxDia 				= Integer.parseInt(new SimpleDateFormat("dd").format(miliDataAtual));
		int visualizacao		= 0;
		int idUsuarioLogado		= eSecretaria ? medico : (Integer) session.getAttribute(Constantes.ATRIB_ID_USUARIO_LOGADO);
		
		try{
			visualizacao = Integer.parseInt(pReq.getParameter("visualizacao"));
		}catch (Exception e) {
			visualizacao = 1;
		}	
		
		String[] links 			= null;
		
		String descMes 			= "";		
		String descricaoData	= "";
		String dia 				= "";
		String mes 				= new SimpleDateFormat("MM").format  (miliDataAtual);
		String ano 				= new SimpleDateFormat("yyyy").format(miliDataAtual);
		String codDigitado		= (String) pReq.getAttribute("CodPaciente");
		String convenio			= (String) pReq.getAttribute("Convenio");
		String nomeDigitado		= (String) pReq.getAttribute("Nome");
		String contatoDigitado	= (String) pReq.getAttribute("Contato");
		String novoDigitado		= (String) pReq.getAttribute("EPrimeiraConsulta");
		String obsDigitado		= (String) pReq.getAttribute("Observacao");
		
		if(convenio == null || convenio.equals("")){
			
			convenio			= pReq.getParameter("convenio");
			
			if(convenio == null || convenio.equals(""))
				convenio = "-1";			
		}

		if(nomeDigitado == null){
			
			nomeDigitado		= pReq.getParameter("nome");
			
			if(nomeDigitado == null || nomeDigitado.equals(""))
				nomeDigitado = "";
		}

		if(contatoDigitado == null){
			
			contatoDigitado		= pReq.getParameter("contato");
			
			if(contatoDigitado == null || contatoDigitado.equals(""))
				contatoDigitado = "";
		}

		if(novoDigitado == null){
			
			novoDigitado		= pReq.getParameter("novo");
			
			if(novoDigitado == null || novoDigitado.equals(""))
				novoDigitado = "";
		}

		if(obsDigitado == null){
			
			obsDigitado			= pReq.getParameter("observacao");
			
			if(obsDigitado == null || obsDigitado.equals(""))
				obsDigitado = "";
		}

		if(codDigitado == null){
			
			codDigitado			= pReq.getParameter("codPaciente");
			
			if(codDigitado == null || codDigitado.equals(""))
				codDigitado = "";
		}
		
		if(detalhe != null){
			
			diaDetalhe	= Integer.parseInt(detalhe.substring(6));
			mesDetalhe	= Integer.parseInt(detalhe.substring(4, 6));
			anoDetalhe	= Integer.parseInt(detalhe.substring(0, 4));
			
			//--- Tratamento do ltimo dia do ms a ser apresentado ---//
			
			while(true){
				if(diaDetalhe > monthDays[mesDetalhe - 1]){
					diaDetalhe -= 1;
				} else {
					break;
				}
			}
			
			//---------------------------------------------------------//
			
			if (String.valueOf(diaDetalhe).length() < 2)
				detalhe	=  detalhe.substring(0, 4) + detalhe.substring(4, 6) + "0" + diaDetalhe;
			else
				detalhe	=  detalhe.substring(0, 4) + detalhe.substring(4, 6) + diaDetalhe;
		
		} else {
			
			diaDetalhe 	= auxDia;			
			mesDetalhe 	= Integer.parseInt(mes);
			anoDetalhe 	= Integer.parseInt(ano);
		}
			
		descMes 		= GerenteCalendario.descricaoMes(mesDetalhe);
		
		descricaoData 	= diaDetalhe + " de " + descMes + " de " + anoDetalhe;

		links 			= new String[monthDays[Integer.parseInt(mes) - 1]];
		
		for(int i = 0; i < links.length; i++){
			
			dia = (i+1) + "";
			
			if (dia.length() < 2)
				dia = "0" + dia;
			
			links[i] = "javascript:detalhe(" + ano + mes + dia + ")";
		}
		
		Date date = new Date();
		date.setDate	(diaDetalhe);
		date.setMonth	(Integer.parseInt(mes) - 1);
		date.setYear	(Integer.parseInt(ano) - 1900);
		
		Calendar calendar				 	= new GregorianCalendar(); 
		calendar.setTimeInMillis(date.getTime());
		
		diaSemana = Utilitarios.getDiaSemana(calendar.get(Calendar.DAY_OF_WEEK));
		
		if(GerenteConsultaHorarioConsulta.horariosPorDiaSemana(controle, diaSemana, idUsuarioLogado)){
			
			horarios = controle.getHorariosConsulta();
			
			for(int i = 0; i < horarios.size(); i++){
				
				view = consultaDAO.carregaViewPacienteConsulta(
					new SimpleDateFormat("dd/MM/yyyy").format(date.getTime()),
					idUsuarioLogado, 
					horarios.get(i).getIdHorarioConsulta(), 
					visualizacao
				);
				
				if(view != null) 
					views.add(view);
			}
			
			pReq.setAttribute("PacientesConsulta", views);
			
		} else {
			
			pReq.setAttribute("Msg"	, "Problemas ao carregar as consultas");
		}

		GerenteConsultaConvenio.todosConvenios	(controle);
		GerenteConsultaUsuario.usuarioMedico	(controle);
		
		if(eSecretaria)
			pReq.setAttribute("eSecretaria"	, "sim");

		pReq.setAttribute("Medicos"				, controle.getUsuarios());
		pReq.setAttribute("Medico"				, String.valueOf(medico));
		pReq.setAttribute("descricaoData"		, descricaoData);
		pReq.setAttribute("dataDetalhe"			, detalhe);
		pReq.setAttribute("miliDataDetalhe"		, date.getTime());
		pReq.setAttribute("links"				, links);
		pReq.setAttribute("data"				, String.valueOf(miliDataAtual));
		pReq.setAttribute("Visualizacao"		, String.valueOf(visualizacao));
		pReq.setAttribute("Convenios"			, controle.getConvenios());
		pReq.setAttribute("Convenio"			, convenio);
		pReq.setAttribute("CodPaciente"			, codDigitado);
		pReq.setAttribute("Nome"				, nomeDigitado);
		pReq.setAttribute("Contato"				, contatoDigitado);
		pReq.setAttribute("EPrimeiraConsulta"	, novoDigitado);
		pReq.setAttribute("Observacao"			, obsDigitado);
		
		ativarPagina(pReq, pResp, "/agendamentoConsulta.jsp");
	}
}