package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.ufpr.mityba.controller.GerenteConsultaAlimento;
import br.ufpr.mityba.controller.GerenteConsultaConsulta;
import br.ufpr.mityba.controller.GerenteConsultaConvenio;
import br.ufpr.mityba.controller.GerenteConsultaDiarioAlimentacao;
import br.ufpr.mityba.controller.GerenteConsultaExameCadastrado;
import br.ufpr.mityba.controller.GerenteConsultaGrupoAlimenticio;
import br.ufpr.mityba.controller.GerenteConsultaHistoricoPaciente;
import br.ufpr.mityba.controller.GerenteConsultaIntoleranciaPaciente;
import br.ufpr.mityba.controller.GerenteConsultaPaciente;
import br.ufpr.mityba.controller.GerenteConsultaProfissao;
import br.ufpr.mityba.dao.ConsultaDAO;
import br.ufpr.mityba.dao.HistoricoPacienteDAO;
import br.ufpr.mityba.dao.IntoleranciaPacienteDAO;
import br.ufpr.mityba.dao.LancamentoDAO;
import br.ufpr.mityba.model.Consulta;
import br.ufpr.mityba.model.Convenio;
import br.ufpr.mityba.model.DiarioAlimentacaoPaciente;
import br.ufpr.mityba.model.ExameCadastrado;
import br.ufpr.mityba.model.GrupoAlimenticio;
import br.ufpr.mityba.model.HistoricoPaciente;
import br.ufpr.mityba.model.IntoleranciaPaciente;
import br.ufpr.mityba.model.Lancamento;
import br.ufpr.mityba.model.Paciente;
import br.ufpr.mityba.util.Constantes;
import br.ufpr.mityba.util.ControlePrincipal;


/**
 * Servlet implementation class for Servlet: ServletConsulta
 * 
 * @author Mityba
 * @since 28/11/2008
 * @version 1.0 28/11/2008
 * 
 */
public class ServletConsulta extends HttpServlet implements Servlet {

	static final long serialVersionUID = 1546465L;	

	/**
    * @param pReq 
    * @param pResp 
    * @throws ServletException 
    * @throws IOException 
    * 
    */
	public void service(HttpServletRequest pReq, HttpServletResponse pResp)	throws ServletException, IOException {

		Vector<String> tErro = new Vector<String>();
		
		HttpSession session = pReq.getSession(false);
		
		if (session == null) {

			tErro.add("Voc deve efetuar o login antes de acessar essa funcionalidade!");

		} else {

			String service = pReq.getParameter("service");
	
			if (service == null || service.equals("")) {
	
				tErro.add("Informar a ao a ser executada\n");			
				
			} else if (service.equals("atenderConsulta")) {
				
				acaoRealizarConsulta(pReq, pResp, session);
				
			} else if (service.equals("avancarPrincipal")) {
				
				acaoAvancarPrincipal(pReq, pResp, session);
				
			} else if (service.equals("avancarAnamnese")) {
				
				acaoAvancarAnamnese(pReq, pResp, session);
				
			} else if (service.equals("avancarExames")) {
				
				acaoAvancarExames(pReq, pResp, session);
				
			} else if (service.equals("avancarDieta")) {
				
				acaoAvancarDieta(pReq, pResp, session);
				
			} else if (service.equals("avancarGraficos")) {
				
				acaoAvancarGraficos(pReq, pResp, session);
				
			} else if (service.equals("avancarSite")) {
				
				acaoAvancarSite(pReq, pResp, session);
				
			} else if (service.equals("voltarAnamnese")) {
				
				acaoVoltarAnamnese(pReq, pResp, session);
				
			} else if (service.equals("voltarExames")) {
				
				acaoVoltarExames(pReq, pResp, session);
				
			} else if (service.equals("concluirPrescricao")) {
				
				acaoConcluirPrescricao(pReq, pResp, session);
				
			} else if (service.equals("calcular")) {
				
				acaoCalcular(pReq, pResp, session);
				
			} else if (service.equals("confirmarMedicamento")) {
				
				acaoConfirmarMedicamento(pReq, pResp, session);
				
			} else if (service.equals("confirmarMedicamentoPrescricao")) {
				
				acaoConfirmarMedicamentoPrescricao(pReq, pResp, session);
				
			} else if (service.equals("mudaExame")) {
				
				acaoMudaExame(pReq, pResp, session);
				
			} else if (service.equals("infoExame")) {
				
				acaoInfoExame(pReq, pResp, session);
				
			} else if (service.equals("confirmarExame")) {
				
				acaoConfirmarExame(pReq, pResp, session);
				
			} else if (service.equals("valorEnergeticoDieta")) {
				
				acaoCalcularValorEnergeticoDieta(pReq, pResp, session);
				
			} else if (service.equals("adicionarIntolerancia")) {
				
				acaoAdicionarIntolerancia(pReq, pResp, session);
				
			} else if (service.equals("removerIntolerancia")) {
				
				acaoExcluirIntolerancia(pReq, pResp, session);
				
			} else if (service.equals("removerIntolerancia")) {
				
				acaoExcluirIntolerancia(pReq, pResp, session);
				
			} else if (service.equals("gerarGrafico")) {
				
				acaoGerarGrafico(pReq, pResp, session);
				
			} else if (service.equals("impressaoPrescricao")) {
				
				acaoImpressaoPrescricao(pReq, pResp, session);
				
			} else if (service.equals("impressaoDeclaracao")) {
				
				acaoImpressaoDeclaracao(pReq, pResp, session);
				
			} else if (service.equals("voltaTela")) {
				
				ativarPagina(pReq, pResp, "/PaginaInicial.jsp");
			
			}
		}
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

	@SuppressWarnings("unused")
	private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {

		pReq.setAttribute("Erros", pErro);

		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {

		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoRealizarConsulta(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
				
		session.removeAttribute("CodConsulta");
		session.removeAttribute("CodPaciente");
		session.removeAttribute("CodMotivacao");
		session.removeAttribute("CodAtividade");
		session.removeAttribute("Pressao");
		session.removeAttribute("AnamneseHistorico");
		session.removeAttribute("AnamneseAtual");
		session.removeAttribute("ExamesHistorico");
		session.removeAttribute("ExamesAtual");
		session.removeAttribute("PrescricaoHistorico");
		session.removeAttribute("PrescricaoAtual");		
		session.removeAttribute("Nome");
		session.removeAttribute("Sexo");
		session.removeAttribute("Nascimento");
		session.removeAttribute("Profissao");
		session.removeAttribute("Profissao");
		session.removeAttribute("Peso");
		session.removeAttribute("PesoMeta");
		session.removeAttribute("Altura");
		session.removeAttribute("PercentualGordura");
		session.removeAttribute("ValorEnergeticoTotal");
		session.removeAttribute("ValorEnergeticoDieta");
		
		ControlePrincipal controle 			= new ControlePrincipal();
		
		Vector<HistoricoPaciente> historico	= null;
		
		Paciente paciente					= null;
		Consulta consulta					= null;
		HistoricoPaciente ultHistorico		= null;
		
		int codConsulta 					= Integer.parseInt((String) pReq.getAttribute("CodConsulta"));
		int codPaciente 					= 0;
		
		GerenteConsultaConsulta.consultaPorCodigo					(controle, codConsulta);
		
		consulta 							= controle.getConsultas().get(0);
		
		codPaciente							= consulta.getIdPacienteConsulta();

		GerenteConsultaHistoricoPaciente.historicoPorCodigoPaciente	(controle, codPaciente);
		GerenteConsultaPaciente.pacientePorCodigo					(controle, codPaciente);

		historico 							= controle.getHistoricoPacientes();
		paciente							= controle.getPacientes().get(0);
		
		GerenteConsultaProfissao.profissaoPorCodigo(controle, paciente.getIdProfissao());

		session.setAttribute("Nome"			, paciente.getNome());
		session.setAttribute("Sexo"			, paciente.getSexo().equals("m") ? "Masculino" : "Feminino");
		session.setAttribute("Nascimento"	, paciente.getDtNasc());
		session.setAttribute("Idade"		, paciente.getIdade());
		
		try{
			session.setAttribute("Profissao"	, controle.getProfissoes().get(0).getDescrProfissao());
		}catch (Exception e) {
			session.setAttribute("Profissao"	, "No fornecida");
		}
		
		if(historico != null && historico.size() > 0){
			
			ultHistorico = historico.get(0);

			pReq.setAttribute("CodMotivacao"		, String.valueOf(ultHistorico.getIdMotivoHistoricoPaciente()));
			pReq.setAttribute("CodAtividade"		, String.valueOf(ultHistorico.getIdAtividadeFisicaHistoricoPaciente()));
			pReq.setAttribute("Peso"				, String.valueOf(ultHistorico.getPesoHistoricoPaciente()));
			pReq.setAttribute("PesoMeta"			, String.valueOf(ultHistorico.getPesoMetaHistoricoPaciente()));
			pReq.setAttribute("Altura"				, String.valueOf(ultHistorico.getAlturaHistoricoPaciente()));
			pReq.setAttribute("Pressao"				, String.valueOf(ultHistorico.getPressaoArterialHistoricoPaciente()));
			pReq.setAttribute("PercentualGordura"	, String.valueOf(ultHistorico.getPercentualGorduraHistoricoPaciente()));
		}
		
		session.setAttribute("CodPaciente", String.valueOf(codPaciente));
		session.setAttribute("CodConsulta", String.valueOf(codConsulta));
		
		ativarPagina(pReq, pResp, "/realizarConsultaPrincipal.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoCalcular(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idMotivoHistoricoPaciente 				= pReq.getParameter("motivacao");
		String idAtividadeFisicaHistoricoPaciente 		= pReq.getParameter("atividadeFisica");		
		String pesoHistoricoPaciente 					= pReq.getParameter("peso");
		String pesoMetaHistoricoPaciente 				= pReq.getParameter("pesoMeta");
		String alturaHistoricoPaciente 					= pReq.getParameter("altura");
		String percentualGorduraHistoricoPaciente 		= pReq.getParameter("perGordura");
		String pressaoArterialHistoricoPaciente 		= pReq.getParameter("pressao");
		
		int semanaGestacao						 		= 0;
		
		try{
			semanaGestacao								= Integer.parseInt(pReq.getParameter("semanaGestacao"));
		} catch (Exception e) {
			semanaGestacao								= 0;
		}

		String ideal								 	= pReq.getParameter("ideal");
		
		String classificacaoIMC							= "";
		
		double imc = 0;
			
		// PESO / ALTURA
		
		imc = 				Double.parseDouble(pesoHistoricoPaciente) / 
				(Double.parseDouble(alturaHistoricoPaciente) * Double.parseDouble(alturaHistoricoPaciente));
		
		if(idMotivoHistoricoPaciente.equals("1")){ //Gestante
			
			switch (semanaGestacao) {
			case 6:
				if(imc <= 19.9)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 24.9)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 7:
				if(imc <= 20)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 24.95)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.05)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 8:
				if(imc <= 20.1)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.1)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 9:
				if(imc <= 20.15)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.1)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.15)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 10:
				if(imc <= 20.2)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.2)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.20)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 11:
				if(imc <= 20.3)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.3)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.3)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 12:
				if(imc <= 20.4)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.4)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.3)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 13:
				if(imc <= 20.6)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.6)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.4)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 14:
				if(imc <= 20.7)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.7)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.5)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 15:
				if(imc <= 20.8)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.8)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.6)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 16:
				if(imc <= 21)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 25.9)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.7)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 17:
				if(imc <= 21.1)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.8)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 18:
				if(imc <= 21.2)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26.1)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.9)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 19:
				if(imc <= 21.4)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26.2)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 30.9)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 20:
				if(imc <= 21.5)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26.3)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 21:
				if(imc <= 21.7)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26.4)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.1)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 22:
				if(imc <= 21.8)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26.6)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.2)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 23:
				if(imc <= 22)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26.8)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.3)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 24:
				if(imc <= 22.2)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 26.9)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.5)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 25:
				if(imc <= 22.4)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 27)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.6)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 26:
				if(imc <= 22.6)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 27.2)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.7)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 27:
				if(imc <= 22.7)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 27.3)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.8)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 28:
				if(imc <= 22.9)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 27.5)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 31.9)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 29:
				if(imc <= 23.1)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 27.6)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 30:
				if(imc <= 23.3)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 27.8)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.1)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 31:
				if(imc <= 23.4)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 27.9)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.2)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 32:
				if(imc <= 23.6)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.3)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 33:
				if(imc <= 23.8)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28.1)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.4)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 34:
				if(imc <= 23.9)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28.3)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.5)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 35:
				if(imc <= 24.1)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28.4)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.6)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 36:
				if(imc <= 24.2)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28.5)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.7)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 37:
				if(imc <= 24.4)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28.7)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.8)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 38:
				if(imc <= 24.5)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28.8)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 32.9)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 39:
				if(imc <= 24.7)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 28.9)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 33)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 40:
				if(imc <= 24.9)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 29.1)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 33.1)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 41:
				if(imc <= 25)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 29.2)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 33.2)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;				
				break;

			case 42:
				if(imc <= 25)
					classificacaoIMC = Constantes.IMC_BAIXO_PESO;
				else if(imc <= 29.2)
					classificacaoIMC = Constantes.IMC_ADEQUADO;
				else if(imc <= 33.2)
					classificacaoIMC = Constantes.IMC_SOBREPESO;
				else
					classificacaoIMC = Constantes.IMC_OBESIDADE;
				break;
			}
		} else { //No-Gestante
			
			if(imc <= 18.4)
				classificacaoIMC = Constantes.IMC_BAIXO_PESO;
			else if(imc <= 24.9)
				classificacaoIMC = Constantes.IMC_IDEAL;
			else if(imc <= 29.9)
				classificacaoIMC = Constantes.IMC_PRE_OBESO;
			else if(imc <= 33.9)
				classificacaoIMC = Constantes.IMC_OBESIDADE_LEVE;
			else if(imc <= 39.9)
				classificacaoIMC = Constantes.IMC_OBESIDADE_MODERADA;
			else
				classificacaoIMC = Constantes.IMC_OBESIDADE_MORBIDA;
		}
		
		double pesoTeoricoMinimo = 0;
		double pesoTeoricoMaximo = 0;
		
		if(alturaHistoricoPaciente != null && ! alturaHistoricoPaciente.equals("")){
			pesoTeoricoMinimo = (Double.parseDouble(alturaHistoricoPaciente) * Double.parseDouble(alturaHistoricoPaciente)) * 20;
			pesoTeoricoMaximo = (Double.parseDouble(alturaHistoricoPaciente) * Double.parseDouble(alturaHistoricoPaciente)) * 25;
		}
		
		double kgGordura							 	= 0;
		
		if(pesoHistoricoPaciente != null && ! pesoHistoricoPaciente.equals("")
		&& percentualGorduraHistoricoPaciente != null && ! percentualGorduraHistoricoPaciente.equals("")){
			
			kgGordura = (Double.parseDouble(pesoHistoricoPaciente) * Double.parseDouble(percentualGorduraHistoricoPaciente)) / 100;
		}
		
		pReq.setAttribute("CodMotivacao"		, idMotivoHistoricoPaciente);
		pReq.setAttribute("CodAtividade"		, idAtividadeFisicaHistoricoPaciente);
		pReq.setAttribute("Peso"				, pesoHistoricoPaciente);
		pReq.setAttribute("PesoMeta"			, pesoMetaHistoricoPaciente);
		pReq.setAttribute("Altura"				, alturaHistoricoPaciente);
		pReq.setAttribute("PercentualGordura"	, percentualGorduraHistoricoPaciente);
		pReq.setAttribute("Pressao"				, pressaoArterialHistoricoPaciente);
		pReq.setAttribute("SemanaGestacao"		, String.valueOf(semanaGestacao));
		pReq.setAttribute("PesoTeoricoMinimo"	, String.valueOf(pesoTeoricoMinimo));
		pReq.setAttribute("PesoTeoricoMaximo"	, String.valueOf(pesoTeoricoMaximo));
		pReq.setAttribute("IMC"					, String.valueOf(imc));
		pReq.setAttribute("ClassificacaoIMC"	, classificacaoIMC);	
		pReq.setAttribute("KgGordura"			, String.valueOf(kgGordura));
		pReq.setAttribute("ClassificacaoGordura", acaoCalcularIdealGordura(pReq, pResp, session));
		pReq.setAttribute("Ideal"				, ideal);
		
		
		ativarPagina(pReq, pResp, "/realizarConsultaPrincipal.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private String acaoCalcularIdealGordura(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String sexoPaciente								= (String) session.getAttribute("Sexo");
		String idadePaciente							= (String) session.getAttribute("Idade");
		
		String idMotivoHistoricoPaciente 				= pReq.getParameter("motivacao");
		String percentualGorduraHistoricoPaciente 		= pReq.getParameter("perGordura");	
		String semanaGestacao						 	= pReq.getParameter("semanaGestacao");
		
		String idealGordura = "";
		
		int idade			= 0;
		
		try{
			idade 			= Integer.parseInt(idadePaciente);
		}catch (Exception e) {
			idade			= 0;
		}
		
		if(percentualGorduraHistoricoPaciente != null && (! percentualGorduraHistoricoPaciente.equals("")) && idade >= 15){
			
			double percentual = Double.parseDouble(percentualGorduraHistoricoPaciente);
			
			//TODO ----- Masculino
			
			if(sexoPaciente.equals("Masculino")){
				
				if(idade <= 37){
					
					if(percentual <= 12)
						idealGordura = Constantes.IDEAL_EXCELENTE;
					else if(percentual <= 17)
						idealGordura = Constantes.IDEAL_BOM;
					else if(percentual <= 22)
						idealGordura = Constantes.IDEAL_MODERADO;
					else if(percentual <= 27)
						idealGordura = Constantes.IDEAL_SOBREPESO;
					else
						idealGordura = Constantes.IDEAL_OBESO;
				
				} else if (idade <= 47){
					
					if(percentual <= 13)
						idealGordura = Constantes.IDEAL_EXCELENTE;
					else if(percentual <= 18)
						idealGordura = Constantes.IDEAL_BOM;
					else if(percentual <= 23)
						idealGordura = Constantes.IDEAL_MODERADO;
					else if(percentual <= 28)
						idealGordura = Constantes.IDEAL_SOBREPESO;
					else
						idealGordura = Constantes.IDEAL_OBESO;
				
				} else if (idade <= 57){
					
					if(percentual <= 14)
						idealGordura = Constantes.IDEAL_EXCELENTE;
					else if(percentual <= 19)
						idealGordura = Constantes.IDEAL_BOM;
					else if(percentual <= 24)
						idealGordura = Constantes.IDEAL_MODERADO;
					else if(percentual <= 29)
						idealGordura = Constantes.IDEAL_SOBREPESO;
					else
						idealGordura = Constantes.IDEAL_OBESO;
					
				} else if (idade <= 67){
					
					if(percentual <= 15)
						idealGordura = Constantes.IDEAL_EXCELENTE;
					else if(percentual <= 20)
						idealGordura = Constantes.IDEAL_BOM;
					else if(percentual <= 28)
						idealGordura = Constantes.IDEAL_MODERADO;
					else if(percentual <= 30)
						idealGordura = Constantes.IDEAL_SOBREPESO;
					else
						idealGordura = Constantes.IDEAL_OBESO;
					
				} else {
					
					if(percentual <= 16)
						idealGordura = Constantes.IDEAL_EXCELENTE;
					else if(percentual <= 21)
						idealGordura = Constantes.IDEAL_BOM;
					else if(percentual <= 29)
						idealGordura = Constantes.IDEAL_MODERADO;
					else if(percentual <= 31)
						idealGordura = Constantes.IDEAL_SOBREPESO;
					else
						idealGordura = Constantes.IDEAL_OBESO;					
				}
				
			//TODO ---- Feminino

			} else {
				
				//TODO ---- Gestante
				
				if(idMotivoHistoricoPaciente.equals("1")){
					
					if(semanaGestacao != null && ! semanaGestacao.equals("")){
						
						int semGestacao = Integer.parseInt(semanaGestacao);
					
						switch (semGestacao) {
						case 6:
							if(percentual <= 19.9)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 24.9)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 7:
							if(percentual <= 20)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 24.95)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.05)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 8:
							if(percentual <= 20.1)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.1)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 9:
							if(percentual <= 20.15)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.1)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.15)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 10:
							if(percentual <= 20.2)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.2)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.20)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 11:
							if(percentual <= 20.3)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.3)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.3)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 12:
							if(percentual <= 20.4)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.4)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.3)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 13:
							if(percentual <= 20.6)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.6)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.4)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 14:
							if(percentual <= 20.7)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.7)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.5)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 15:
							if(percentual <= 20.8)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.8)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.6)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 16:
							if(percentual <= 21)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 25.9)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.7)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 17:
							if(percentual <= 21.1)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.8)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 18:
							if(percentual <= 21.2)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26.1)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.9)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 19:
							if(percentual <= 21.4)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26.2)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 30.9)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 20:
							if(percentual <= 21.5)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26.3)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 21:
							if(percentual <= 21.7)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26.4)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.1)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 22:
							if(percentual <= 21.8)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26.6)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.2)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 23:
							if(percentual <= 22)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26.8)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.3)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 24:
							if(percentual <= 22.2)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 26.9)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.5)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 25:
							if(percentual <= 22.4)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 27)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.6)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 26:
							if(percentual <= 22.6)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 27.2)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.7)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 27:
							if(percentual <= 22.7)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 27.3)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.8)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 28:
							if(percentual <= 22.9)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 27.5)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 31.9)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 29:
							if(percentual <= 23.1)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 27.6)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 30:
							if(percentual <= 23.3)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 27.8)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.1)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 31:
							if(percentual <= 23.4)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 27.9)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.2)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 32:
							if(percentual <= 23.6)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.3)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 33:
							if(percentual <= 23.8)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28.1)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.4)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 34:
							if(percentual <= 23.9)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28.3)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.5)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 35:
							if(percentual <= 24.1)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28.4)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.6)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 36:
							if(percentual <= 24.2)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28.5)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.7)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 37:
							if(percentual <= 24.4)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28.7)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.8)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 38:
							if(percentual <= 24.5)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28.8)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 32.9)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 39:
							if(percentual <= 24.7)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 28.9)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 33)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 40:
							if(percentual <= 24.9)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 29.1)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 33.1)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 41:
							if(percentual <= 25)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 29.2)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 33.2)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;				
							break;
			
						case 42:
							if(percentual <= 25)
								idealGordura = Constantes.IDEAL_BAIXO_PESO;
							else if(percentual <= 29.2)
								idealGordura = Constantes.IDEAL_ADEQUADO;
							else if(percentual <= 33.2)
								idealGordura = Constantes.IDEAL_SOBREPESO;
							else
								idealGordura = Constantes.IDEAL_OBESIDADE;
							break;
						}
					}
				//TODO ----- No Gestante
					
				} else {
					
					if(idade <= 18){
						
						if(percentual <= 17)
							idealGordura = Constantes.IDEAL_EXCELENTE;
						else if(percentual <= 22)
							idealGordura = Constantes.IDEAL_BOM;
						else if(percentual <= 27)
							idealGordura = Constantes.IDEAL_MODERADO;
						else if(percentual <= 32)
							idealGordura = Constantes.IDEAL_SOBREPESO;
						else
							idealGordura = Constantes.IDEAL_OBESO;
					
					} else if (idade <= 28){
						
						if(percentual <= 18)
							idealGordura = Constantes.IDEAL_EXCELENTE;
						else if(percentual <= 23)
							idealGordura = Constantes.IDEAL_BOM;
						else if(percentual <= 28)
							idealGordura = Constantes.IDEAL_MODERADO;
						else if(percentual <= 33)
							idealGordura = Constantes.IDEAL_SOBREPESO;
						else
							idealGordura = Constantes.IDEAL_OBESO;
					
					} else if (idade <= 38){
						
						if(percentual <= 19)
							idealGordura = Constantes.IDEAL_EXCELENTE;
						else if(percentual <= 24)
							idealGordura = Constantes.IDEAL_BOM;
						else if(percentual <= 29)
							idealGordura = Constantes.IDEAL_MODERADO;
						else if(percentual <= 35)
							idealGordura = Constantes.IDEAL_SOBREPESO;
						else
							idealGordura = Constantes.IDEAL_OBESO;
						
					} else if (idade <= 48){
						
						if(percentual <= 20)
							idealGordura = Constantes.IDEAL_EXCELENTE;
						else if(percentual <= 25)
							idealGordura = Constantes.IDEAL_BOM;
						else if(percentual <= 30)
							idealGordura = Constantes.IDEAL_MODERADO;
						else if(percentual <= 35)
							idealGordura = Constantes.IDEAL_SOBREPESO;
						else
							idealGordura = Constantes.IDEAL_OBESO;
						
					} else if (idade <= 58){
						
						if(percentual <= 21)
							idealGordura = Constantes.IDEAL_EXCELENTE;
						else if(percentual <= 26)
							idealGordura = Constantes.IDEAL_BOM;
						else if(percentual <= 31)
							idealGordura = Constantes.IDEAL_MODERADO;
						else if(percentual <= 36)
							idealGordura = Constantes.IDEAL_SOBREPESO;
						else
							idealGordura = Constantes.IDEAL_OBESO;
						
					} else {
						
						if(percentual <= 22)
							idealGordura = Constantes.IDEAL_EXCELENTE;
						else if(percentual <= 27)
							idealGordura = Constantes.IDEAL_BOM;
						else if(percentual <= 32)
							idealGordura = Constantes.IDEAL_MODERADO;
						else if(percentual <= 37)
							idealGordura = Constantes.IDEAL_SOBREPESO;
						else
							idealGordura = Constantes.IDEAL_OBESO;					
					}
				}
			}
		}

		return idealGordura;
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAvancarPrincipal(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");
		
		String idMotivoHistoricoPaciente 			= pReq.getParameter("motivacao");
		String idAtividadeFisicaHistoricoPaciente 	= pReq.getParameter("atividadeFisica");		
		String pesoHistoricoPaciente 				= pReq.getParameter("peso");
		String pesoMetaHistoricoPaciente 			= pReq.getParameter("pesoMeta");
		String alturaHistoricoPaciente 				= pReq.getParameter("altura");
		String percentualGorduraHistoricoPaciente 	= pReq.getParameter("perGordura");
		String pressaoArterialHistoricoPaciente 	= pReq.getParameter("pressao");
		String imcDigitado						 	= pReq.getParameter("imc");
		String classificacaoIMC						= pReq.getParameter("classificacaoIMC");		
		String semanaGestacao						= pReq.getParameter("semanaGestacao");
		String classificacaoGordura					= pReq.getParameter("classificacaoGordura");
		String pesoTeoricoMinimo					= pReq.getParameter("pesoTeoricoMinimo");
		String pesoTeoricoMaximo					= pReq.getParameter("pesoTeoricoMaximo");
		String kgGordura							= pReq.getParameter("kgGordura");
		String idealGordura							= pReq.getParameter("ideal");

		session.setAttribute("CodMotivacao"			, idMotivoHistoricoPaciente);
		session.setAttribute("CodAtividade"			, idAtividadeFisicaHistoricoPaciente);
		session.setAttribute("Peso"					, pesoHistoricoPaciente);
		session.setAttribute("PesoMeta"				, pesoMetaHistoricoPaciente);
		session.setAttribute("Altura"				, alturaHistoricoPaciente);
		session.setAttribute("PercentualGordura"	, percentualGorduraHistoricoPaciente);
		session.setAttribute("Pressao"				, pressaoArterialHistoricoPaciente);
		session.setAttribute("SemanaGestacao"		, String.valueOf(semanaGestacao));
		session.setAttribute("PesoTeoricoMinimo"	, pesoTeoricoMinimo);
		session.setAttribute("PesoTeoricoMaximo"	, pesoTeoricoMaximo);
		session.setAttribute("IMC"					, imcDigitado);
		session.setAttribute("ClassificacaoIMC"		, classificacaoIMC);
		session.setAttribute("KgGordura"			, kgGordura);
		session.setAttribute("ClassificacaoGordura"	, classificacaoGordura);
		session.setAttribute("Ideal"				, idealGordura);
		
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaHistoricoPaciente.historicoPorCodigoPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));

		Vector<HistoricoPaciente> historico = controle.getHistoricoPacientes();
		
		if(historico != null && historico.size() > 0){
			HistoricoPaciente ultHistorico = historico.get(0);
			session.setAttribute("AnamneseHistorico", ultHistorico.getAnamneseHistoricoHistoricoPaciente());
		}
		
		ativarPagina(pReq, pResp, "/realizarConsultaAnamnese.jsp");
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAvancarSite(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");		
		
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaHistoricoPaciente.historicoPorCodigoPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));

		Vector<HistoricoPaciente> historico = controle.getHistoricoPacientes();
		
		if(historico != null && historico.size() > 0){
			HistoricoPaciente ultHistorico = historico.get(0);
			session.setAttribute("PrescricaoHistorico", ultHistorico.getPrescricaoHistoricoHistoricoPaciente());
		}
		
		ativarPagina(pReq, pResp, "/realizarConsultaPrescricao.jsp");
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAvancarExames(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");	
		
		String historico							= pReq.getParameter("historico");
		
		session.setAttribute("ExamesHistorico"		, historico);
		
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		GerenteConsultaGrupoAlimenticio.todosGrupos(controle);
		
		Vector<GrupoAlimenticio> grupos	= controle.getGruposAlimenticios();		
		Vector<String> valores 			= new Vector<String>();

		for(int i = 0; i < grupos.size(); i++){
			valores.add("0");
		}

		pReq.setAttribute("Grupos"	, grupos);
		pReq.setAttribute("Valores"	, valores);

		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		pReq.setAttribute("IntoleranciasPaciente", controle.getIntoleranciasPaciente());

		pReq.setAttribute("ValorEnergeticoTotal", String.valueOf(acaoCalcularValorEnergeticoTotal(pReq, pResp, session)));

		ativarPagina(pReq, pResp, "/realizarConsultaDieta.jsp");
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoCalcularValorEnergeticoDieta(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");
		String valorEnergeticoTotal					= pReq.getParameter("valorEnergeticoTotal");;
						
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		GerenteConsultaGrupoAlimenticio.todosGrupos(controle);
		
		Vector<GrupoAlimenticio> grupos = controle.getGruposAlimenticios();
		
		Vector<String> valores = new Vector<String>();
		
		for(int i = 0; i < grupos.size(); i++){			
			valores.add(pReq.getParameter(String.valueOf(grupos.get(i).getIdGrupoAlimenticio())));
		}

		pReq.setAttribute("Grupos"	, grupos);
		pReq.setAttribute("Valores"	, valores);
		
		double valorEnergeticoDieta = 0;
		
		for(int i = 0; i < grupos.size(); i++){			
			valorEnergeticoDieta += Double.parseDouble(valores.get(i)) * grupos.get(i).getValorCaloricoGrupoAlimenticio();
		}
		
		double comparativo = acaoCalcularComparativoDieta(valorEnergeticoDieta, Double.parseDouble(valorEnergeticoTotal));
		String classificacao = "";		
		
		if(comparativo < 10)
			classificacao = Constantes.COMPARATIVO_HIPOCALORICA;
		else if(comparativo > 10)
			classificacao = Constantes.COMPARATIVO_HIPERCALORICA;
		else if(comparativo == 10)
			classificacao = Constantes.COMPARATIVO_NORMOCALORICA;
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		pReq.setAttribute("IntoleranciasPaciente"	, controle.getIntoleranciasPaciente());
		pReq.setAttribute("Comparativo"				, String.valueOf(comparativo));
		pReq.setAttribute("Classificacao"			, classificacao);
		pReq.setAttribute("ValorEnergeticoDieta"	, String.valueOf(valorEnergeticoDieta));
		pReq.setAttribute("ValorEnergeticoTotal"	, valorEnergeticoTotal);
		
		ativarPagina(pReq, pResp, "/realizarConsultaDieta.jsp");
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAdicionarIntolerancia(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");
		String valorEnergeticoTotal					= pReq.getParameter("valorEnergeticoTotal");;
		String valorEnergeticoDieta					= pReq.getParameter("valorEnergeticoDieta");;
		String comparativoDieta						= pReq.getParameter("comparativo");;
		String classificacaoDieta					= pReq.getParameter("comparacao");;
						
		ControlePrincipal controle = new ControlePrincipal();
		GerenteConsultaGrupoAlimenticio.todosGrupos(controle);
		
		int intolerancia = Integer.parseInt(pReq.getParameter("intolerancia"));
		
		IntoleranciaPaciente intoleranciaPaciente = new IntoleranciaPaciente(
				intolerancia,
				Integer.parseInt(idPacienteHistoricoPaciente)
		);
		
		new IntoleranciaPacienteDAO().incluiIntoleranciaPaciente(intoleranciaPaciente);
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		
		Vector<GrupoAlimenticio> grupos = controle.getGruposAlimenticios();
		
		Vector<String> valores = new Vector<String>();
		
		for(int i = 0; i < grupos.size(); i++){			
			valores.add(pReq.getParameter(String.valueOf(grupos.get(i).getIdGrupoAlimenticio())));
		}

		pReq.setAttribute("Grupos"	, grupos);
		pReq.setAttribute("Valores"	, valores);
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		pReq.setAttribute("IntoleranciasPaciente"	, controle.getIntoleranciasPaciente());
		pReq.setAttribute("Comparativo"				, comparativoDieta);
		pReq.setAttribute("Classificacao"			, classificacaoDieta);
		pReq.setAttribute("ValorEnergeticoDieta"	, String.valueOf(valorEnergeticoDieta));
		pReq.setAttribute("ValorEnergeticoTotal"	, valorEnergeticoTotal);
		
		ativarPagina(pReq, pResp, "/realizarConsultaDieta.jsp");
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoExcluirIntolerancia(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");
		String valorEnergeticoTotal					= pReq.getParameter("valorEnergeticoTotal");;
		String valorEnergeticoDieta					= pReq.getParameter("valorEnergeticoDieta");;
		String comparativoDieta						= pReq.getParameter("comparativo");;
		String classificacaoDieta					= pReq.getParameter("comparacao");;
						
		ControlePrincipal controle = new ControlePrincipal();
		GerenteConsultaGrupoAlimenticio.todosGrupos(controle);
		
		int intolerancia = Integer.parseInt(pReq.getParameter("intoleranciasEscolhidas"));
		
		new IntoleranciaPacienteDAO().excluiIntoleranciaPaciente(intolerancia, Integer.parseInt(idPacienteHistoricoPaciente));
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		
		Vector<GrupoAlimenticio> grupos = controle.getGruposAlimenticios();
		
		Vector<String> valores = new Vector<String>();
		
		for(int i = 0; i < grupos.size(); i++){			
			valores.add(pReq.getParameter(String.valueOf(grupos.get(i).getIdGrupoAlimenticio())));
		}

		pReq.setAttribute("Grupos"	, grupos);
		pReq.setAttribute("Valores"	, valores);
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		pReq.setAttribute("IntoleranciasPaciente"	, controle.getIntoleranciasPaciente());
		pReq.setAttribute("Comparativo"				, comparativoDieta);
		pReq.setAttribute("Classificacao"			, classificacaoDieta);
		pReq.setAttribute("ValorEnergeticoDieta"	, String.valueOf(valorEnergeticoDieta));
		pReq.setAttribute("ValorEnergeticoTotal"	, valorEnergeticoTotal);
		
		ativarPagina(pReq, pResp, "/realizarConsultaDieta.jsp");
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAvancarDieta(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");
		String valorEnergeticoTotal					= pReq.getParameter("valorEnergeticoTotal");;
		String valorEnergeticoDieta					= pReq.getParameter("valorEnergeticoDieta");;
		String comparativoDieta						= pReq.getParameter("comparativo");;
		String classificacaoDieta					= pReq.getParameter("comparacao");;
						
		ControlePrincipal controle = new ControlePrincipal();
		GerenteConsultaGrupoAlimenticio.todosGrupos(controle);
		
		GerenteConsultaIntoleranciaPaciente.intoleranciaPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		
		Vector<GrupoAlimenticio> grupos = controle.getGruposAlimenticios();
		
		Vector<String> valores = new Vector<String>();
		
		for(int i = 0; i < grupos.size(); i++){			
			valores.add(pReq.getParameter(String.valueOf(grupos.get(i).getIdGrupoAlimenticio())));
		}

		session.setAttribute("Valores"				, valores);		
		session.setAttribute("Comparativo"			, comparativoDieta);
		session.setAttribute("Classificacao"		, classificacaoDieta);
		session.setAttribute("ValorEnergeticoDieta"	, String.valueOf(valorEnergeticoDieta));
		session.setAttribute("ValorEnergeticoTotal"	, valorEnergeticoTotal);
		
		ativarPagina(pReq, pResp, "/realizarConsultaGraficos.jsp");
	}
	
	/**
	 * 
	 * @param valorEnergeticoDieta
	 * @param valorEnergeticoTotal
	 * @return comparativo
	 */
	
	private double acaoCalcularComparativoDieta(double valorEnergeticoDieta, double valorEnergeticoTotal){		
		return ((valorEnergeticoDieta * 100) / valorEnergeticoTotal) - 100;
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoVoltarAnamnese(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		pReq.setAttribute("CodMotivacao"		, (String) session.getAttribute("CodMotivacao"));
		pReq.setAttribute("CodAtividade"		, (String) session.getAttribute("CodAtividade"));
		pReq.setAttribute("Peso"				, (String) session.getAttribute("Peso"));
		pReq.setAttribute("PesoMeta"			, (String) session.getAttribute("PesoMeta"));
		pReq.setAttribute("Altura"				, (String) session.getAttribute("Altura"));
		pReq.setAttribute("PercentualGordura"	, (String) session.getAttribute("PercentualGordura"));
		pReq.setAttribute("Pressao"				, (String) session.getAttribute("Pressao"));
		pReq.setAttribute("SemanaGestacao"		, (String) session.getAttribute("SemanaGestacao"));
		pReq.setAttribute("PesoTeoricoMinimo"	, (String) session.getAttribute("PesoTeoricoMinimo"));
		pReq.setAttribute("PesoTeoricoMaximo"	, (String) session.getAttribute("PesoTeoricoMaximo"));
		pReq.setAttribute("IMC"					, (String) session.getAttribute("IMC"));
		pReq.setAttribute("ClassificacaoIMC"	, (String) session.getAttribute("ClassificacaoIMC"));
		pReq.setAttribute("KgGordura"			, (String) session.getAttribute("KgGordura"));
		pReq.setAttribute("ClassificacaoGordura", (String) session.getAttribute("ClassificacaoGordura"));
		pReq.setAttribute("Ideal"				, (String) session.getAttribute("Ideal"));
		
		ativarPagina(pReq, pResp, "/realizarConsultaPrincipal.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoGerarGrafico(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
				
		String idConsultaHistoricoPaciente 		= (String) session.getAttribute("CodConsulta");
		String idPacienteHistoricoPaciente 		= (String) session.getAttribute("CodPaciente");
		
		boolean ePeso							= pReq.getParameter("tpGrafico").equals("peso");
		
		StringBuffer xml 						= new StringBuffer("");
		
		try{
			
			ControlePrincipal controle				= new ControlePrincipal();
			
			Vector<HistoricoPaciente> historico		= new Vector<HistoricoPaciente>();
			
			GerenteConsultaHistoricoPaciente.historicoPorCodigoPaciente	(controle, Integer.parseInt(idPacienteHistoricoPaciente));
			GerenteConsultaPaciente.pacientePorCodigo					(controle, Integer.parseInt(idPacienteHistoricoPaciente));
			
			historico								= controle.getHistoricoPacientes();
			
			Paciente paciente						= controle.getPacientes().get(0);
			
			String titulo = ePeso ? "Historico de Peso" : "Historico de Kg Gordura";  
			
			xml.append(" - <chart caption='" + titulo + "' subcaption='" + paciente.getNome() + "' lineThickness='1' showValues='1' ")
			.append("formatNumberScale='0' anchorRadius='2' divLineAlpha='20' divLineColor='CC3300' divLineIsDashed='1' showAlternateHGridColor='1' ")
			.append("alternateHGridColor='CC3300' shadowAlpha='40' labelStep='2' numvdivlines='5' chartRightMargin='35' ")
			.append("bgColor='FFFFFF,CC3300' bgAngle='270' bgAlpha='10,10'>")
			.append("- <categories>");
		
		for(int i = historico.size() - 1; i >= 0; i --){
			
			int idConsulta = historico.get(i).getIdConsultaHistoricoPaciente();
			
			GerenteConsultaConsulta.consultaPorCodigo(controle, idConsulta);
			
			xml.append("<category label='" + controle.getConsultas().get(0).getDataConsulta() + "' />");
		}
		
		GerenteConsultaConsulta.consultaPorCodigo(controle, Integer.parseInt(idConsultaHistoricoPaciente));
		
		xml.append("<category label='" + controle.getConsultas().get(0).getDataConsulta() + "' />")
		.append("</categories>")
		.append(" - <dataset seriesName='" + (ePeso ? "Peso" : "Kg Gordura ") + " Paciente' color='1D8BD1' anchorBorderColor='1D8BD1' anchorBgColor='1D8BD1'>");
		
		for(int i = historico.size() - 1; i >= 0; i --){
			
			int idConsulta = historico.get(i).getIdConsultaHistoricoPaciente();
			
			GerenteConsultaConsulta.consultaPorCodigo(controle, idConsulta);
			
			xml.append("<set value='" + (ePeso ? historico.get(i).getPesoHistoricoPaciente() :  ((historico.get(i).getPesoHistoricoPaciente() * historico.get(i).getPercentualGorduraHistoricoPaciente())/100))+ "' />");
		}
		
		xml.append("<set value='" + (ePeso ? session.getAttribute("Peso") :  session.getAttribute("PercentualGordura")) + "' />")
			.append("</dataset>");
		
		if(ePeso){
			
			xml.append(" - <dataset seriesName='Peso Meta do Paciente' color='F1683C' anchorBorderColor='F1683C' anchorBgColor='F1683C'>");
			
			for(int i = historico.size() - 1; i >= 0; i --){
				
				int idConsulta = historico.get(i).getIdConsultaHistoricoPaciente();
				
				GerenteConsultaConsulta.consultaPorCodigo(controle, idConsulta);
				
				xml.append("<set value='" + historico.get(i).getPesoMetaHistoricoPaciente() + "' />");
			}
			
			xml.append("<set value='" + session.getAttribute("PesoMeta") + "' />")
				.append("</dataset>");
		}
		
		xml.append(" - <styles>")
			.append(" - <definition>")
			.append("<style name='CaptionFont' type='font' size='12' /> ")
			.append("</definition>")
			.append(" - <application>")
			.append("<apply toObject='CAPTION' styles='CaptionFont' /> ")
			.append("<apply toObject='SUBCAPTION' styles='CaptionFont' /> ")
			.append("</application>")
			.append("</styles>")
			.append("</chart>");
			
		}catch (Exception e) {
			//Caso ocorra algum erro durante a gerao do xml nenhum grafico  gerado
		}
		
		pReq.setAttribute("xml", xml.toString());
		
		ativarPagina(pReq, pResp, "/realizarConsultaGraficos.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAvancarGraficos(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String idPacienteHistoricoPaciente 		= (String) session.getAttribute("CodPaciente");
		
		ControlePrincipal controle				= new ControlePrincipal();
		
		Vector<DiarioAlimentacaoPaciente> diario;
		
		GerenteConsultaDiarioAlimentacao.diarioPorPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		
		diario = controle.getDiariosAlimentacao();
		
		String descrRef = "";
		
		StringBuffer descricaoDiario = new StringBuffer();
		
		for(int i = 0; i < diario.size(); i++){
			
			GerenteConsultaAlimento.alimentoPorCodigo(controle, diario.get(i).getIdAlimentoDiarioAlimentacaoPaciente());
			
			if(diario.get(i).getRefeicaoDiarioAlimentacaoPaciente() == Constantes.REFEICAO_ALMOCO){
				descrRef = "Almoo - ";
			} else if(diario.get(i).getRefeicaoDiarioAlimentacaoPaciente() == Constantes.REFEICAO_DESJEJUM){
				descrRef = "Desjejum - ";
			} else if(diario.get(i).getRefeicaoDiarioAlimentacaoPaciente() == Constantes.REFEICAO_JANTAR){
				descrRef = "Jantar - ";
			} else if(diario.get(i).getRefeicaoDiarioAlimentacaoPaciente() == Constantes.REFEICAO_LANCHE){
				descrRef = "Lanche - ";
			}
			
			descricaoDiario.append(descrRef + controle.getAlimentos().get(0).getNomeAlimento() + "<br>");
		}
		
		pReq.setAttribute("Site", descricaoDiario.toString());
		
		ativarPagina(pReq, pResp, "/realizarConsultaSite.jsp");
	}

	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoVoltarExames(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String nomePaciente						= (String) session.getAttribute("Nome");
		String sexoPaciente						= (String) session.getAttribute("Sexo");
		String nascimentoPaciente				= (String) session.getAttribute("Nascimento");
		String idadePaciente					= (String) session.getAttribute("Profissao");
		String profissaoPaciente				= (String) session.getAttribute("Profissao");
		String idConsultaHistoricoPaciente 		= (String) session.getAttribute("CodConsulta");
		String idPacienteHistoricoPaciente 		= (String) session.getAttribute("CodPaciente");
		
		pReq.setAttribute("Nome"				, nomePaciente);
		pReq.setAttribute("Sexo"				, sexoPaciente);
		pReq.setAttribute("Idade"				, idadePaciente);
		pReq.setAttribute("Nascimento"			, nascimentoPaciente);
		pReq.setAttribute("Profissao"			, profissaoPaciente);
		pReq.setAttribute("CodConsulta"			, idConsultaHistoricoPaciente);
		pReq.setAttribute("CodPaciente"			, idPacienteHistoricoPaciente);
		
		ativarPagina(pReq, pResp, "/realizarConsultaAnamnese.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAvancarAnamnese(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String idPacienteHistoricoPaciente 		= (String) session.getAttribute("CodPaciente");
		String anamneseHistorico 				= pReq.getParameter("historico");
		String anamneseAtual		 			= pReq.getParameter("atual");		

		session.setAttribute("AnamneseHistorico"	, anamneseHistorico);
		session.setAttribute("AnamneseAtual"		, anamneseAtual);
		
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaExameCadastrado.todosExames(controle);
		
		GerenteConsultaHistoricoPaciente.historicoPorCodigoPaciente(controle, Integer.parseInt(idPacienteHistoricoPaciente));

		Vector<HistoricoPaciente> historico = controle.getHistoricoPacientes();
		
		if(historico != null && historico.size() > 0){
			HistoricoPaciente ultHistorico = historico.get(0);
			session.setAttribute("ExamesHistorico", ultHistorico.getExamesHistoricoHistoricoPaciente());
		}
		

		pReq.setAttribute("Exames"	, controle.getExamesCadastrados());
		pReq.setAttribute("CodExame", "0");

		ativarPagina(pReq, pResp, "/realizarConsultaExames.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoConcluirPrescricao(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String nomePaciente							= (String) session.getAttribute("Nome");
		String sexoPaciente							= (String) session.getAttribute("Sexo");
		String nascimentoPaciente					= (String) session.getAttribute("Nascimento");
		String idadePaciente						= (String) session.getAttribute("Profissao");
		String profissaoPaciente					= (String) session.getAttribute("Profissao");
		String idConsultaHistoricoPaciente 			= (String) session.getAttribute("CodConsulta");
		String idPacienteHistoricoPaciente 			= (String) session.getAttribute("CodPaciente");
		
		pReq.setAttribute("Nome"					, nomePaciente);
		pReq.setAttribute("Sexo"					, sexoPaciente);
		pReq.setAttribute("Idade"					, idadePaciente);
		pReq.setAttribute("Nascimento"				, nascimentoPaciente);
		pReq.setAttribute("Profissao"				, profissaoPaciente);
		pReq.setAttribute("CodConsulta"				, idConsultaHistoricoPaciente);
		pReq.setAttribute("CodPaciente"				, idPacienteHistoricoPaciente);
		
		double peso					= 0;
		double pesoMeta 			= 0;
		double altura 				= 0;
		double percentualGordura	= 0;
		double valorTotal 			= 0;
		double valorDieta 			= 0;

		try{
			peso = Double.parseDouble((String) session.getAttribute("Peso"));
		} catch (Exception e) {
			peso = 0;
		}
		try{
			pesoMeta = Double.parseDouble((String) session.getAttribute("PesoMeta"));
		} catch (Exception e) {
			pesoMeta = 0;
		}
		try{
			altura = Double.parseDouble((String) session.getAttribute("Altura"));
		} catch (Exception e) {
			altura = 0;
		}
		try{
			percentualGordura = Double.parseDouble((String) session.getAttribute("PercentualGordura"));
		} catch (Exception e) {
			percentualGordura = 0;
		}
		try{
			valorTotal = Double.parseDouble((String) session.getAttribute("ValorEnergeticoTotal"));
		} catch (Exception e) {
			valorTotal = 0;
		}
		try{
			valorDieta = Double.parseDouble((String) session.getAttribute("ValorEnergeticoDieta"));
		} catch (Exception e) {
			valorDieta = 0;
		}

		String anamneseHistorico 	= (String) session.getAttribute("AnamneseHistorico");
		String anamneseAtual 		= (String) session.getAttribute("AnamneseAtual");
		String examesHistorico 		= (String) session.getAttribute("ExamesHistorico");
		String examesAtual 			= (String) session.getAttribute("ExamesAtual");
		String prescricaoHistorico 	= (String) session.getAttribute("PrescricaoHistorico");
		String prescricaoAtual 		= (String) session.getAttribute("PrescricaoAtual");

		if(anamneseHistorico == null){
			anamneseHistorico = "";
		}
		if(anamneseAtual == null){
			anamneseAtual = "";
		}
		if(examesHistorico == null){
			examesHistorico = "";
		}
		if(examesAtual == null){
			examesAtual = "";
		}
		if(prescricaoHistorico == null){
			prescricaoHistorico = "";
		}
		if(prescricaoAtual == null){
			prescricaoAtual = "";
		}
		
		anamneseHistorico 	+= "\r\n" + anamneseAtual;
		examesHistorico 	+= "\r\n" + examesAtual;
		prescricaoHistorico += "\r\n" + prescricaoAtual;
		
		HistoricoPaciente historico = new HistoricoPaciente(
			0,
			Integer.parseInt(idConsultaHistoricoPaciente),
			Integer.parseInt(idPacienteHistoricoPaciente),
			Integer.parseInt((String) session.getAttribute("CodMotivacao")),
			Integer.parseInt((String) session.getAttribute("CodAtividade")),
			peso,
			pesoMeta,
			altura,
			percentualGordura,
			valorTotal,
			valorDieta,
			(String) session.getAttribute("Pressao"),
			anamneseHistorico,
			anamneseAtual,
			examesHistorico,
			examesAtual,
			prescricaoHistorico,
			prescricaoAtual
		);
		
		new HistoricoPacienteDAO().incluiHistoricoPaciente(historico);
				
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaConsulta.consultaPorCodigo(controle, Integer.parseInt(idConsultaHistoricoPaciente));
		GerenteConsultaPaciente.pacientePorCodigo(controle, Integer.parseInt(idPacienteHistoricoPaciente));
		
		Consulta consulta = controle.getConsultas().get(0);
		Paciente paciente = controle.getPacientes().get(0);
		
		GerenteConsultaConvenio.convenioPorCodigo(controle, paciente.getIdConvenio());
		
		Convenio convenio = controle.getConvenios().get(0);
		
		consulta.setIdStatusConsulta(Constantes.COD_CONSULTA_ATENDIDA);
		
		Lancamento lancamento = new Lancamento(
			0,
			convenio.getIdConvenio(),
			Constantes.COD_CONSULTA_ATENDIDA,
			convenio.getValorConsultaConvenio(),
			consulta.getDataConsulta()
		);
		
		new ConsultaDAO().alteraConsulta(consulta);
		new LancamentoDAO().incluiLancamento(lancamento);
		
		ativarPagina(pReq, pResp, "/realizarConsultaImpressoes.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoConfirmarExame(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String sexoPaciente						= (String) session.getAttribute("Sexo");
		String idadePaciente					= (String) session.getAttribute("Idade");
		String historico						= pReq.getParameter("historico");
		String valorEsperado 					= "";
		String valorObtido				 		= pReq.getParameter("valorObtido");
		
		if(historico == null){
			historico = "";
		}
		
		if(idadePaciente != null && ! idadePaciente.equals("")){
			
			ControlePrincipal controle			= new ControlePrincipal();		
			
			String exameDigitado				= pReq.getParameter("exames");
			
			GerenteConsultaExameCadastrado.examePorCodigo(controle, Integer.parseInt(exameDigitado));
			
			ExameCadastrado exame				= controle.getExamesCadastrados().get(0);
			
			String mensagem						= "";
			
			int idade							= Integer.parseInt(idadePaciente);
			
			if(idade >= 6){
				
				if(!exame.getMinimo06().equals("")){
					
					valorEsperado = exame.getMinimo06() + " a " + exame.getMaximo06();
					
					if(Double.parseDouble(valorObtido) > Double.parseDouble(exame.getMaximo06())){
						mensagem = exame.getObsAcima();
					} else if(Double.parseDouble(valorObtido) < Double.parseDouble(exame.getMinimo06())){
						mensagem = exame.getObsAbaixo();
					} else {
						mensagem = "Dentro do intervalo esperado";
					}
				}
			} else if (idade >= 12){
				
				if(!exame.getMinimo712().equals("")){
					
					valorEsperado = exame.getMinimo712() + " a " + exame.getMaximo712();
					
					if(Double.parseDouble(valorObtido) > Double.parseDouble(exame.getMaximo712())){
						mensagem = exame.getObsAcima();
					} else if(Double.parseDouble(valorObtido) < Double.parseDouble(exame.getMinimo712())){
						mensagem = exame.getObsAbaixo();
					} else {
						mensagem = "Dentro do intervalo esperado";
					}
				}
				
			} else if (idade <= 65){
				
				if(!exame.getMinimo65().equals("")){
					
					valorEsperado = exame.getMinimo712() + " a " + exame.getMaximo712();
					
					if(Double.parseDouble(valorObtido) > Double.parseDouble(exame.getMaximo65())){
						mensagem = exame.getObsAcima();
					} else if(Double.parseDouble(valorObtido) < Double.parseDouble(exame.getMinimo65())){
						mensagem = exame.getObsAbaixo();
					} else {
						mensagem = "Dentro do intervalo esperado";
					}
				}
			}
			
			if(mensagem.equals("")){
				
				if (sexoPaciente.equals("Feminino")){
					
					if(!exame.getMinimoFem().equals("")){
						
						valorEsperado = exame.getMinimoFem() + " a " + exame.getMaximoFem();
						
						if(Double.parseDouble(valorObtido) > Double.parseDouble(exame.getMaximoFem())){
							mensagem = exame.getObsAcima();
						} else if(Double.parseDouble(valorObtido) < Double.parseDouble(exame.getMinimoFem())){
							mensagem = exame.getObsAbaixo();
						} else {
							mensagem = "Dentro do intervalo esperado";
						}
					}
				} else {

					if(!exame.getMinimoMas().equals("")){
						
						valorEsperado = exame.getMinimoMas() + " a " + exame.getMaximoMas();
						
						if(Double.parseDouble(valorObtido) > Double.parseDouble(exame.getMaximoMas())){
							mensagem = exame.getObsAcima();
						} else if(Double.parseDouble(valorObtido) < Double.parseDouble(exame.getMinimoMas())){
							mensagem = exame.getObsAbaixo();
						} else {
							mensagem = "Dentro do intervalo esperado";
						}
					}
				}
			}
			
			historico += "\r\n" + exame.getNome() + " - Valor esperado: " + valorEsperado + 
						" - Valor Obtido: " + valorObtido + "\r\nMensagem: " + mensagem;
		}
		
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaExameCadastrado.todosExames(controle);

		pReq.setAttribute("ValorEsperado"		, valorEsperado);
		pReq.setAttribute("ValorObtido"			, valorObtido);
		session.setAttribute("ExamesHistorico"	, historico);
		pReq.setAttribute("Exames"				, controle.getExamesCadastrados());

		ativarPagina(pReq, pResp, "/realizarConsultaExames.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoMudaExame(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String sexoPaciente						= (String) session.getAttribute("Sexo");
		String idadePaciente					= (String) session.getAttribute("Idade");
		String historico						= pReq.getParameter("historico");
		String valorEsperado 					= "";
		
		if(idadePaciente != null && ! idadePaciente.equals("")){
			
			ControlePrincipal controle			= new ControlePrincipal();		
			
			String exameDigitado				= pReq.getParameter("exames");
			
			GerenteConsultaExameCadastrado.examePorCodigo(controle, Integer.parseInt(exameDigitado));
			
			ExameCadastrado exame				= controle.getExamesCadastrados().get(0);
			
			int idade							= Integer.parseInt(idadePaciente);
			
			if(idade >= 6){
				
				if(!exame.getMinimo06().equals("")){
					
					valorEsperado = exame.getMinimo06() + " a " + exame.getMaximo06();
				}
			} else if (idade >= 12){
				
				if(!exame.getMinimo712().equals("")){
					
					valorEsperado = exame.getMinimo712() + " a " + exame.getMaximo712();
				}
				
			} else if (idade <= 65){
				
				if(!exame.getMinimo65().equals("")){
					
					valorEsperado = exame.getMinimo712() + " a " + exame.getMaximo712();
				}
			}
			
			if(valorEsperado.equals("")){
				
				if (sexoPaciente.equals("Feminino")){
					
					if(!exame.getMinimoFem().equals("")){
						
						valorEsperado = exame.getMinimoFem() + " a " + exame.getMaximoFem();
					}
				} else {
					if(!exame.getMinimoMas().equals("")){						
						valorEsperado = exame.getMinimoMas() + " a " + exame.getMaximoMas();
					}
				}
			}
			
			pReq.setAttribute("CodExame", String.valueOf(exame.getIdExame()));
		}
		
		ControlePrincipal controle = new ControlePrincipal();
		
		GerenteConsultaExameCadastrado.todosExames(controle);

		pReq.setAttribute("Historico"			, historico);
		pReq.setAttribute("ValorEsperado"		, valorEsperado);
		pReq.setAttribute("Exames"				, controle.getExamesCadastrados());	
		
		ativarPagina(pReq, pResp, "/realizarConsultaExames.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoInfoExame(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String sexoPaciente						= (String) session.getAttribute("Sexo");
		String idadePaciente					= (String) session.getAttribute("Idade");
		String historico						= pReq.getParameter("historico");
		String valorEsperado 					= "";
		String informacao	 					= "";
		String exameDigitado					= "";
		
		ControlePrincipal controle			= new ControlePrincipal();		
		
		if(idadePaciente != null && ! idadePaciente.equals("")){
			
			exameDigitado						= pReq.getParameter("exames");
			
			GerenteConsultaExameCadastrado.examePorCodigo(controle, Integer.parseInt(exameDigitado));
			
			ExameCadastrado exame				= controle.getExamesCadastrados().get(0);
			
			informacao = "- Abaixo do Esperado:\r\n" + exame.getObsAbaixo() + "\r\n\r\n- Acima do Esperado:\r\n" + exame.getObsAcima();
			
			int idade							= Integer.parseInt(idadePaciente);
			
			if(idade >= 6){
				
				if(!exame.getMinimo06().equals("")){
					
					valorEsperado = exame.getMinimo06() + " a " + exame.getMaximo06();
				}
			} else if (idade >= 12){
				
				if(!exame.getMinimo712().equals("")){
					
					valorEsperado = exame.getMinimo712() + " a " + exame.getMaximo712();
				}
				
			} else if (idade <= 65){
				
				if(!exame.getMinimo65().equals("")){
					
					valorEsperado = exame.getMinimo712() + " a " + exame.getMaximo712();
				}
			}
			
			if(valorEsperado.equals("")){
				
				if (sexoPaciente.equals("Feminino")){
					
					if(!exame.getMinimoFem().equals("")){
						
						valorEsperado = exame.getMinimoFem() + " a " + exame.getMaximoFem();
					}
				} else {
					if(!exame.getMinimoMas().equals("")){						
						valorEsperado = exame.getMinimoMas() + " a " + exame.getMaximoMas();
					}
				}
			}
		}
		
		GerenteConsultaExameCadastrado.todosExames(controle);

		pReq.setAttribute("Historico"			, historico);
		pReq.setAttribute("InfoExame"			, informacao);
		pReq.setAttribute("ValorEsperado"		, valorEsperado);
		pReq.setAttribute("CodExame"			, exameDigitado);	
		pReq.setAttribute("Exames"				, controle.getExamesCadastrados());	
		
		ativarPagina(pReq, pResp, "/realizarConsultaExames.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @return vct
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private double acaoCalcularValorEnergeticoTotal(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String sexoPaciente		= (String) session.getAttribute("Sexo");
		String idadePaciente	= (String) session.getAttribute("Idade");
		
		String motivacao 		= (String) session.getAttribute("CodMotivacao");
		String atividadeFisica 	= (String) session.getAttribute("CodAtividade");
		String peso				= (String) session.getAttribute("Peso");
		String altura			= (String) session.getAttribute("Altura");
		
		double valorEnergeticoTotal = 0.0;
		
		if(peso != null && ! peso.equals("") && altura != null && !altura.equals("") && idadePaciente != null && !idadePaciente.equals("")){
			
			if(sexoPaciente.equals("Feminino")){
				
				if(motivacao.equals("1")){//Gestante
					
					valorEnergeticoTotal = (354 - (6.91 * (Integer.parseInt(idadePaciente))) + 
							acaoCalcularClassificacaoAtividadeFisica(true, false, Integer.parseInt(atividadeFisica))) * 
							(9.36 * Double.parseDouble(peso) + 726 * Double.parseDouble(altura)) + 
							acaoCalcularExtraGestante(pReq, pResp, session);
				
				} else if (Integer.parseInt(idadePaciente) > 18){
					
					valorEnergeticoTotal = 354 - (6.91 * (Integer.parseInt(idadePaciente))) + 
							acaoCalcularClassificacaoAtividadeFisica(false, false, Integer.parseInt(atividadeFisica)) * 
							((9.36 * Double.parseDouble(peso)) + (726 * Double.parseDouble(altura)));
					
				} else {
					
					valorEnergeticoTotal = (7.4 * Double.parseDouble(peso)) + (482 * Double.parseDouble(altura)) + 217;
				}
				
			} else {
			
				if (Integer.parseInt(idadePaciente) > 18){
					
					valorEnergeticoTotal = (662 - (9.53 * (Integer.parseInt(idadePaciente))) + 
							acaoCalcularClassificacaoAtividadeFisica(false, true, Integer.parseInt(atividadeFisica))) * 
							(15.91 * Double.parseDouble(peso) + 539.6 * Double.parseDouble(altura));
					
				} else {
					
					valorEnergeticoTotal = (16.6 * Double.parseDouble(peso)) + (77 * Double.parseDouble(altura)) + 572;
				}
			}
		}
		
		return valorEnergeticoTotal;
	}
	
	/**
	 * 
	 * @param eGestante
	 * @param eHomem
	 * @param atividadeFisica
	 * @return classificacao
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private double acaoCalcularClassificacaoAtividadeFisica(boolean eGestante, boolean eHomem, int atividadeFisica) throws ServletException, IOException {
		
		if(eHomem){
			
			switch (atividadeFisica) {
			case 1:
				return 1.3;
			case 2:
				return 1.55;
			case 3:
				return 1.78;
			case 4:
				return 2.1;
			} 
			
		} else {
			
			if(eGestante){
				
				switch (atividadeFisica) {
				case 1:
					return 1;
				case 2:
					return 1.12;
				case 3:
					return 1.27;
				case 4:
					return 1.45;
				}
				
			}else{
				
				switch (atividadeFisica) {
				case 1:
					return 1.27;
				case 2:
					return 1.56;
				case 3:
					return 1.64;
				case 4:
					return 1.82;
				} 
			}
		}
		
		return 0;
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @return extra
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private int acaoCalcularExtraGestante(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String classificacaoIMC = (String) pReq.getAttribute("ClassificacaoIMC");
		
		if(classificacaoIMC != null && ! classificacaoIMC.equals("")){
			
			if(classificacaoIMC.equals(Constantes.IMC_BAIXO_PESO)){
				
				return 430;
				
			} else if(classificacaoIMC.equals(Constantes.IMC_ADEQUADO)){
				
				return 400;
				
			} else if(classificacaoIMC.equals(Constantes.IMC_SOBREPESO)){
				
				return 350;
				
			} else if(classificacaoIMC.equals(Constantes.IMC_OBESIDADE)){
				
				return 200;
				
			}
		}
		
		return 0;
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoConfirmarMedicamento(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {

		String medicamento							= pReq.getParameter("medicamento");
		String historico							= pReq.getParameter("historico");
		String anamneseAtual						= pReq.getParameter("atual");
		
		anamneseAtual += "\r\nMedicamento utilizado: " + medicamento;
		session.setAttribute("AnamneseAtual"		, anamneseAtual);
		session.setAttribute("AnamneseHistorico"	, historico);
		
		ativarPagina(pReq, pResp, "/realizarConsultaAnamnese.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoConfirmarMedicamentoPrescricao(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String medicamento							= pReq.getParameter("medicamento");
		String prescricaoAtual						= pReq.getParameter("atual");
		
		prescricaoAtual += "\r\nMedicamento a utilizar: " + medicamento;
		session.setAttribute("PrescricaoAtual"		, prescricaoAtual);
		
		ativarPagina(pReq, pResp, "/realizarConsultaPrescricao.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoImpressaoPrescricao(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
				
		ativarPagina(pReq, pResp, "/Prescricao.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoImpressaoDeclaracao(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
				
		ativarPagina(pReq, pResp, "/Declaracao.jsp");
	}
}