package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.ufpr.mityba.controller.GerenteConsultaMensagem;
import br.ufpr.mityba.controller.GerenteConsultaPaciente;
import br.ufpr.mityba.controller.GerenteConsultaProfissao;
import br.ufpr.mityba.dao.MensagemDAO;
import br.ufpr.mityba.model.Mensagem;
import br.ufpr.mityba.model.Paciente;
import br.ufpr.mityba.model.Profissao;
import br.ufpr.mityba.util.Constantes;
import br.ufpr.mityba.util.ControlePrincipal;
import br.ufpr.mityba.util.SendMail;


/**
 * Servlet implementation class for Servlet: ServletMensagem
 * 
 * @author Mityba
 * @since 22/10/2008
 * @version 1.0 22/10/2008
 * @version 2.0 18/11/2008
 * @version 2.1 19/11/2008
 */
 public class ServletMensagem extends HttpServlet implements Servlet {
	 
   static final long serialVersionUID = 13242132L;
   
   /**
    * @param pReq 
    * @param pResp 
    * @throws ServletException 
    * @throws IOException 
    * 
    */
   public void service(HttpServletRequest pReq, HttpServletResponse pResp)	throws ServletException, IOException {
	   
		Vector<String> tErro = new Vector<String>();
		
		HttpSession session = pReq.getSession(false);

		String service = pReq.getParameter("service");
		
		if (session == null){
			
			tErro.add("Voc deve efetuar o login antes de acessar essa funcionalidade!");
			
		} else {
		
			if (service == null || service.equals("")) {
	
				tErro.add("Informar a ao a ser executada\n");

			} else if (service.equals("cadastroMensagens")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("msgConsulta")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoAvisoConsulta(pReq, pResp);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("msgAniversario")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoMensagemAniversario(pReq, pResp);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("msgProfissional")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
								
					acaoDiaProfissional(pReq, pResp);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("msgBoasVindas")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoMensagemBoasVindas(pReq, pResp);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("msgNova")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
								
					acaoMensagemNova(pReq, pResp);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("mudaProfissao")) {
				
				acaoMudaProfissao(pReq, pResp);

			} else if (service.equals("pesquisarPacientesMsg")) {
				
				acaoPesquisarPacientes(pReq, pResp);

			} else if (service.equals("enviarNovaMensagem")) {
				
				acaoEnviarNovaMensagem(pReq, pResp);

			} else if (service.equals("filtrarDestinatarios")) {

				acaoFiltarDestinatariosMensagem(pReq, pResp);

			} else if (service.equals("salvarMensagem")) {

				acaoSalvar(pReq, pResp);
	
			} else if (service.equals("voltaTela")) {
				
				ativarPagina(pReq, pResp, "/PaginaInicial.jsp");
			}
		}
		
		if (tErro.size() > 0){
			
			mostrarErro(pReq, pResp, tErro, "/PaginaInicial.jsp");
		}
   }

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

	private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {

		pReq.setAttribute("Erros", pErro);

		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {

		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoDiaProfissional(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
		
		ControlePrincipal controle = new ControlePrincipal();
		
		if(GerenteConsultaProfissao.todasProfissoes(controle)){
			
			pReq.setAttribute("profissoes", controle.getProfissoes());
			
		} else {
			
			pReq.setAttribute("Msg", "Erro ao recuperar profisses!");
		}
		
		pReq.setAttribute("tpMsg"	, Constantes.DESC_MSG_DIA_PROFISSIONAL);		
		pReq.setAttribute("msgVazia", "sim");
		
		ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoMudaProfissao(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
				
		String codigo 				= (String) pReq.getParameter("profissao");
		String comboProfissoes 		= "";
		
		ControlePrincipal controle 	= new ControlePrincipal();

		Vector<Mensagem> mensagens;
		Vector<Profissao> profissoes;
		
		Mensagem mensagem;
		
		if(GerenteConsultaMensagem.mensagensProfissao(controle, codigo)
		&& GerenteConsultaProfissao.todasProfissoes(controle)){

			mensagens 	= controle.getMensagens();
			profissoes 	= controle.getProfissoes();
			
			if(mensagens.size() > 0){
				
				mensagem = mensagens.get(0);
				
				pReq.setAttribute("dia"			, mensagem.getDataEnvioMensagem().substring(0,2));
				pReq.setAttribute("mes"			, mensagem.getDataEnvioMensagem().substring(3,5));
				pReq.setAttribute("titulo"		, mensagem.getTituloMensagem().trim());
				pReq.setAttribute("descricao"	, mensagem.getDescricaoMensagem().trim());
			}
			
			for(int i = 0; i < profissoes.size(); i++){
				
				comboProfissoes += "<option value=\"" + profissoes.get(i).getIdProfissao() + "\" ";
				
				if(profissoes.get(i).getIdProfissao() == Integer.parseInt(codigo))
					comboProfissoes += "selected=\"selected\"";
				
				comboProfissoes += " >" + profissoes.get(i).getDescrProfissao() + "</option>\n";
			}
			
			pReq.setAttribute("comboProfissoes"	, comboProfissoes);
			
		} else {
			pReq.setAttribute("Msg", "Erro ao carregar a pgina");
		}
		
		pReq.setAttribute("tpMsg", Constantes.DESC_MSG_DIA_PROFISSIONAL);
		
		ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoSalvar(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
		
		Vector<String> tErro 			= new Vector<String>();
		
		String tpMsg 					= pReq.getParameter("tipoMsg");		
		
		if(tpMsg.equals(Constantes.DESC_MSG_DIA_PROFISSIONAL)){
			
			String comboProfissoes 		= "";
			
			String codigo 				= (String) pReq.getParameter("profissao");
			
			boolean existe = false;
			
			ControlePrincipal controle 	= new ControlePrincipal();
			
			MensagemDAO mensagemDAO		= new MensagemDAO();

			Vector<Mensagem>  mensagens;
			Vector<Profissao> profissoes;
			
			Mensagem mensagemDel		= null;
			Mensagem mensagemIn			= null;

			String dia 			= pReq.getParameter("dia");
			String mes 			= pReq.getParameter("mes");
			String titulo 		= pReq.getParameter("titulo");
			String descricao 	= pReq.getParameter("descricao");

			if(dia == null || dia.equals(""))
				tErro.add("O campo dia deve ser preenchido");
			
			if(mes == null || mes.equals(""))
				tErro.add("O campo mes deve ser preenchido");
			
			if(titulo == null || titulo.equals(""))
				tErro.add("O campo ttulo deve ser preenchido");
			
			if(descricao == null || descricao.equals(""))
				tErro.add("O campo descrio deve ser preenchido");
			
			if(tErro.size() > 0){
				
				mostrarErro(pReq, pResp, tErro, "/apresentaMensagens.jsp");
				
			} else {
				
				if(GerenteConsultaMensagem.mensagensProfissao(controle, codigo)){
									
					mensagens 	= controle.getMensagens();
					
					if(mensagens.size() > 0){
						mensagemDel = mensagens.get(0);
						existe = true;
					}
					
					mensagemIn = new Mensagem(
						0, Integer.parseInt(codigo), Constantes.COD_MSG_DIA_PROFISSIONAL, 0, dia + "/" + mes, titulo, descricao
					);
					
					if(mensagemDAO.incluiMensagem(mensagemIn)){
						
						if(existe)
							mensagemDAO.excluiMensagem(mensagemDel.getIdMensagem());
						
						GerenteConsultaProfissao.todasProfissoes(controle);
						
						profissoes 	= controle.getProfissoes();
						
						for(int i = 0; i < profissoes.size(); i++){
							
							comboProfissoes += "<option value=\"" + profissoes.get(i).getIdProfissao() + "\" ";
							
							if(profissoes.get(i).getIdProfissao() == Integer.parseInt(codigo))
								comboProfissoes += "selected=\"selected\"";
							
							comboProfissoes += " >" + profissoes.get(i).getDescrProfissao() + "</option>\n";
						}
						
						pReq.setAttribute("comboProfissoes"	, comboProfissoes);
						
						pReq.setAttribute("Msg", "Mensagem armazenada com sucesso!");
					
					} else {
						pReq.setAttribute("Msg", "Problemas com o armazenamento!");
					}
				} else {
					pReq.setAttribute("Msg", "Problemas com o armazenamento!");
				}
				
				acaoMudaProfissao(pReq, pResp);
			}
		
		} else if(tpMsg.equals(Constantes.DESC_MSG_ANIVERSARIO)){
			
			boolean existe = false;
			
			Vector<Mensagem> mensagens = null;

			Mensagem mensagem 	= null;
			Mensagem mensagemIn = null;
			
			ControlePrincipal controle 	= new ControlePrincipal();

			MensagemDAO mensagemDAO		= new MensagemDAO();

			String titulo 		= pReq.getParameter("titulo");
			String descricao 	= pReq.getParameter("descricao");
			
			if(titulo == null || titulo.equals(""))
				tErro.add("O campo ttulo deve ser preenchido");
			
			if(descricao == null || descricao.equals(""))
				tErro.add("O campo descrio deve ser preenchido");
			
			if(tErro.size() > 0){
				
				mostrarErro(pReq, pResp, tErro, "/apresentaMensagens.jsp");
				
			} else {
			
				if(GerenteConsultaMensagem.mensagensAniversario(controle)){
					
					mensagens 	= controle.getMensagens();
					
					if(mensagens.size() > 0){
						
						mensagem = mensagens.get(0);						
						existe = true;
					}
					
					mensagemIn = new Mensagem(
						0, 0, Constantes.COD_MSG_ANIVERSARIO, 0, "", titulo, descricao
					);
					
					if(mensagemDAO.incluiMensagem(mensagemIn)){

						if(existe)
							mensagemDAO.excluiMensagem(mensagem.getIdMensagem());
						
						pReq.setAttribute("Msg", "Mensagem armazenada com sucesso!");
						
					} else {
						pReq.setAttribute("Msg", "Problemas com o armazenamento!");
					}
				} else {
					pReq.setAttribute("Msg", "Problemas com o armazenamento!");
				}
				
				acaoMensagemAniversario(pReq, pResp);
			}
		
		} else if(tpMsg.equals(Constantes.DESC_MSG_AVISO_CONSULTA)){
			
			boolean existe = false;
			
			Vector<Mensagem> mensagens = null;
			
			Mensagem mensagem 	= null;
			Mensagem mensagemIn = null;
			
			ControlePrincipal controle 	= new ControlePrincipal();
			
			MensagemDAO mensagemDAO		= new MensagemDAO();

			String titulo 		= pReq.getParameter("titulo");
			String descricao 	= pReq.getParameter("descricao");
			String qdeDias	 	= pReq.getParameter("qdeDias");
			
			int qdeDiasNum		= 0;
			
			if(titulo == null || titulo.equals(""))
				tErro.add("O campo ttulo deve ser preenchido");
			
			if(descricao == null || descricao.equals(""))
				tErro.add("O campo descrio deve ser preenchido");
			
			if(qdeDias == null || qdeDias.equals(""))
				tErro.add("O campo quantidade de dias deve ser preenchido");
			else {
				try{
					qdeDiasNum = Integer.parseInt(qdeDias);
				} catch (NumberFormatException e) {
					tErro.add("O campo Quantidade de dias deve ser preenchido por caracterer numricos apenas");
				}
			}
			
			if(tErro.size() > 0){
				
				mostrarErro(pReq, pResp, tErro, "/apresentaMensagens.jsp");
				
			} else {
			
				if(GerenteConsultaMensagem.mensagensConsulta(controle)){
					
					mensagens 	= controle.getMensagens();
					
					if(mensagens.size() > 0){
						
						mensagem = mensagens.get(0);						
						existe = true;
					}
					
					mensagemIn = new Mensagem(
						0, 0, Constantes.COD_MSG_AVISO_CONSULTA, qdeDiasNum, "", titulo, descricao
					);
					
					if(mensagemDAO.incluiMensagem(mensagemIn)){
											
						if(existe)
							mensagemDAO.excluiMensagem(mensagem.getIdMensagem());
						
						pReq.setAttribute("Msg", "Mensagem armazenada com sucesso!");
						
					} else {
						pReq.setAttribute("Msg", "Problemas com o armazenamento!");
					}
				} else {
					pReq.setAttribute("Msg", "Problemas com o armazenamento!");
				}
				
				acaoAvisoConsulta(pReq, pResp);
			}

		} else if(tpMsg.equals(Constantes.DESC_MSG_BOAS_VINDAS)){
			
			boolean existe = false;
			
			Vector<Mensagem> mensagens = null;
			
			Mensagem mensagem 	= null;
			Mensagem mensagemIn = null;
			
			ControlePrincipal controle 	= new ControlePrincipal();
			
			MensagemDAO mensagemDAO		= new MensagemDAO();

			String titulo 		= pReq.getParameter("titulo");
			String descricao 	= pReq.getParameter("descricao");
			String qdeDias	 	= pReq.getParameter("qdeDias");
			
			int qdeDiasNum		= 0;
			
			if(titulo == null || titulo.equals(""))
				tErro.add("O campo ttulo deve ser preenchido");
			
			if(descricao == null || descricao.equals(""))
				tErro.add("O campo descrio deve ser preenchido");
			
			if(qdeDias == null || qdeDias.equals(""))
				tErro.add("O campo quantidade de dias deve ser preenchido");
			else {
				try{
					qdeDiasNum = Integer.parseInt(qdeDias);
				} catch (NumberFormatException e) {
					tErro.add("O campo quantidade de dias deve ser preenchido por caracterer numricos apenas");
				}
			}
			
			if(tErro.size() > 0){
				
				mostrarErro(pReq, pResp, tErro, "/apresentaMensagens.jsp");
				
			} else {
			
				if(GerenteConsultaMensagem.mensagensBoasVindas(controle)){
					
					mensagens 	= controle.getMensagens();
					
					if(mensagens.size() > 0){
						
						mensagem = mensagens.get(0);
						existe = true;
					}
					
					mensagemIn = new Mensagem(
						0, 0, Constantes.COD_MSG_BOAS_VINDAS, qdeDiasNum, "", titulo, descricao
					);
					
					if(mensagemDAO.incluiMensagem(mensagemIn)){
											
						if(existe)
							mensagemDAO.excluiMensagem(mensagem.getIdMensagem());
						
						pReq.setAttribute("Msg", "Mensagem armazenada com sucesso!");
						
					} else {
						pReq.setAttribute("Msg", "Problemas com o armazenamento!");
					}
				} else {
					pReq.setAttribute("Msg", "Problemas com o armazenamento!");
				}
				
				acaoAvisoConsulta(pReq, pResp);
			}
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoMensagemAniversario(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
				
		Vector<Mensagem> mensagens = null;
		
		Mensagem mensagem = null;
		
		ControlePrincipal controle = new ControlePrincipal();
		
		if(GerenteConsultaMensagem.mensagensAniversario(controle)){
			
			mensagens 	= controle.getMensagens();
			
			if(mensagens.size() > 0){
				
				mensagem = mensagens.get(0);
				
				pReq.setAttribute("Titulo", mensagem.getTituloMensagem().trim());
				pReq.setAttribute("Descricao", mensagem.getDescricaoMensagem().trim());
			}
		
		} else {
			
			pReq.setAttribute("Msg", "Problemas ao carregar mensagens");
		}
		
		pReq.setAttribute("tpMsg", Constantes.DESC_MSG_ANIVERSARIO);
		
		ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoAvisoConsulta(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {

		Vector<Mensagem> mensagens = null;
		
		Mensagem mensagem = null;
		
		ControlePrincipal controle = new ControlePrincipal();
		
		if(GerenteConsultaMensagem.mensagensConsulta(controle)){
			
			mensagens 	= controle.getMensagens();
			
			if(mensagens.size() > 0){
				
				mensagem = mensagens.get(0);
				
				pReq.setAttribute("Titulo"		, mensagem.getTituloMensagem().trim());
				pReq.setAttribute("Descricao"	, mensagem.getDescricaoMensagem().trim());
				pReq.setAttribute("QdeDias"		, String.valueOf(mensagem.getQdeDiasAntesMensagem()));
			}
		
		} else {
			
			pReq.setAttribute("Msg", "Problemas ao carregar mensagens");
		}
		
		pReq.setAttribute("tpMsg", Constantes.DESC_MSG_AVISO_CONSULTA);
		
		ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoMensagemBoasVindas(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
				
		Vector<Mensagem> mensagens = null;
		
		Mensagem mensagem = null;
		
		ControlePrincipal controle = new ControlePrincipal();
		
		if(GerenteConsultaMensagem.mensagensBoasVindas(controle)){
			
			mensagens 	= controle.getMensagens();
			
			if(mensagens.size() > 0){
				
				mensagem = mensagens.get(0);
				
				pReq.setAttribute("Titulo"		, mensagem.getTituloMensagem().trim());
				pReq.setAttribute("Descricao"	, mensagem.getDescricaoMensagem().trim());
				pReq.setAttribute("QdeDias"		, String.valueOf(mensagem.getQdeDiasAntesMensagem()));
			}
		
		} else {
			
			pReq.setAttribute("Msg", "Problemas ao carregar mensagens");
		}
		
		pReq.setAttribute("tpMsg", Constantes.DESC_MSG_BOAS_VINDAS);
		
		ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoMensagemNova(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {

		pReq.setAttribute("tpMsg", Constantes.DESC_MSG_NOVA);
		
		ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoPesquisarPacientes(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {

		Vector<String> tErro		= new Vector<String>();
		
		ControlePrincipal controle	= new ControlePrincipal();
		
		String nomeDigitado 		= pReq.getParameter("nome");
		String sexoDigitado 		= pReq.getParameter("sexo");
		String statusDigitado 		= pReq.getParameter("ativo");
		
		int idadeDigitado 			= 0;
		int convenioDigitado		= 0;
		int profissaoDigitado		= 0;

		try{
			idadeDigitado 			= Integer.parseInt(pReq.getParameter("idade"));
		}catch (NumberFormatException e) {
			tErro.add("O campo idade deve ser preenchido por caracteres numricos apenas");
		}		
		
		try{
			convenioDigitado 		= Integer.parseInt(pReq.getParameter("convenio"));
		}catch (NumberFormatException e) {
			tErro.add("O campo convnio deve ser preenchido por caracteres numricos apenas");
		}
		
		try{
			profissaoDigitado 		= Integer.parseInt(pReq.getParameter("profissao"));
		}catch (NumberFormatException e) {
			tErro.add("O campo profisso deve ser preenchido por caracteres numricos apenas");
		}
		
		GerenteConsultaPaciente.pacientePorCamposMsg(controle, nomeDigitado, idadeDigitado, sexoDigitado, statusDigitado, 
														convenioDigitado, profissaoDigitado);
		
		pReq.setAttribute("pacientes", controle.getPacientes());
		
		ativarPagina(pReq, pResp, "/consultaPacientesMensagens.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoEnviarNovaMensagem(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {

		Vector<String> tErro 		= new Vector<String>();
		Vector<Paciente> pacientes	= null;
		
		SendMail enviarEmail		= new SendMail();
		
		ControlePrincipal controle	= new ControlePrincipal();
		
		Paciente paciente			= null;
		
		String titulo 				= pReq.getParameter("titulo");
		String descricao 			= pReq.getParameter("descricao");
		
		String[] idsPacientes		= pReq.getParameterValues("idsPacientes");
		
		if(titulo == null || titulo.equals(""))
			tErro.add("O campo ttulo deve ser preenchido");
		
		if(descricao == null || descricao.equals(""))
			tErro.add("O campo descrio deve ser preenchido");		
		
		if(tErro.size() > 0){
			
			mostrarErro(pReq, pResp, tErro, "/apresentaMensagens.jsp");
			
		} else {
			
			if(GerenteConsultaPaciente.pacientePorCodigos(controle, idsPacientes)){
				
				pacientes = controle.getPacientes();
				
				for(int i = 0; i < pacientes.size(); i++){
					
					paciente = pacientes.get(i);
					
					if(paciente.getEmail() == null || paciente.getEmail().equals("")){
						
						pReq.setAttribute("Msg", "E-mails enviados com sucesso");
						
						if(!enviarEmail.sendMail(
							Constantes.USUARIO_EMAIL_COMPLETO, 
							paciente.getEmail(), 
							titulo.replace	 ("<paciente>", paciente.getNome()),
							descricao.replace("<paciente>", paciente.getNome())))
						{
							pReq.setAttribute("Msg", "Problemas no envio dos emails");
							break;
						}
					}
				}
			} else {
				pReq.setAttribute("Msg", "Problemas no envio dos emails");
			}
			
			pReq.setAttribute("tpMsg", Constantes.DESC_MSG_BOAS_VINDAS);
			
			ativarPagina(pReq, pResp, "/apresentaMensagens.jsp");
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoFiltarDestinatariosMensagem(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {

		Vector<String> tErro 	= new Vector<String>();
		
		String titulo			= pReq.getParameter("titulo");
		String descricao		= pReq.getParameter("descricao");
		
		if(titulo == null || (titulo.trim()).equals("")){
			tErro.add("O campo ttulo deve ser preenchido");
		}
		if(descricao == null || (descricao.trim()).equals("")){
			tErro.add("O campo descrio deve ser preenchido");
		}
		
		if(tErro.size() > 0){			
			mostrarErro(pReq, pResp, tErro, "/apresentaMensagens.jsp");
			
		} else {
			
			pReq.setAttribute("Titulo"		, titulo);
			pReq.setAttribute("Descricao"	, descricao);
			
			ativarPagina(pReq, pResp, "/consultaPacientesMensagens.jsp");
		}
	}
}