package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * Servlet implementation class for Servlet: ServletRedir
 * 
 * @author Mityba
 * @since 06/09/2008
 * @version 1.0
 */
 public class ServletRedir extends HttpServlet implements Servlet {
	 
   static final long serialVersionUID = 132432L;
   
   /**
	 * @param pReq 
	 * @param pResp 
	 * @throws ServletException 
	 * @throws IOException 
	 * 
	 */
   public void service(HttpServletRequest pReq, HttpServletResponse pResp)	throws ServletException, IOException {
	   
		Vector<String> tErro = new Vector<String>();
				
		RequestDispatcher disp;

		String service = pReq.getParameter("service");
		
		if (service == null || service.equals("")) {

			tErro.add("Informar a ao a ser executada\n");

		} else if (service.equals("entrarAgenda")) {
						
			disp = pReq.getRequestDispatcher("ServletCalendario");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroPacientes") || service.equals("pesquisarPacientes")) {
			
			disp = pReq.getRequestDispatcher("ServletPaciente");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroExames") || service.equals("pesquisarExames")) {
			
			disp = pReq.getRequestDispatcher("ServletExame");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroMensagens")) {
			
			disp = pReq.getRequestDispatcher("ServletMensagem");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroUsuarios") || service.equals("pesquisarUsuarios")) {
			
			disp = pReq.getRequestDispatcher("ServletUsuario");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroConvenios") || service.equals("pesquisarConvenios")) {
			
			disp = pReq.getRequestDispatcher("ServletConvenio");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroMedicamentos") || service.equals("pesquisarMedicamentos")) {
			
			disp = pReq.getRequestDispatcher("ServletMedicamento");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroTabelaSubstituicao")) {
			
			disp = pReq.getRequestDispatcher("ServletAlimento");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroHorarios")) {
			
			disp = pReq.getRequestDispatcher("ServletHorarioConsulta");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("cadastroDietasApoio") || service.equals("pesquisarDietasApoio")) {
			
			disp = pReq.getRequestDispatcher("ServletDietaApoio");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("apresentaFinanceiro")) {

			disp = pReq.getRequestDispatcher("ServletFinanceiro");
			disp.forward(pReq, pResp);
			
		} else if (service.equals("Logout")) {
			
			disp = pReq.getRequestDispatcher("ServletLogin");
			disp.forward(pReq, pResp);
		}
		
		if (tErro.size() > 0){
			
			mostrarErro(pReq, pResp, tErro, "/PaginaInicial.jsp");
		}
   }

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

   private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {

		pReq.setAttribute("Erros", pErro);

		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {

		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}
}