package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class for Servlet: ServletRedirSite
 * 
 * @author Mityba
 * @since 08/12/2008
 * @version 1.0
 */
 public class ServletRedirSite extends HttpServlet implements Servlet {
	 
   static final long serialVersionUID = 13243842L;
   
   /**
	 * @param pReq 
	 * @param pResp 
	 * @throws ServletException 
	 * @throws IOException 
	 * 
	 */
   public void service(HttpServletRequest pReq, HttpServletResponse pResp)	throws ServletException, IOException {
	   
		Vector<String> tErro = new Vector<String>();
				
		RequestDispatcher disp;

		String service = pReq.getParameter("service");
		
		if (service == null || service.equals("")) {

			tErro.add("Informar a ao a ser executada\n");

		} else if (service.equals("cadastro")) {
			
			disp = pReq.getRequestDispatcher("ServletCadastroSite");
			disp.forward(pReq, pResp);

		} else if (service.equals("dieta")) {
			
			disp = pReq.getRequestDispatcher("ServletDietaSite");
			disp.forward(pReq, pResp);

		} else if (service.equals("diario")) {
			
			disp = pReq.getRequestDispatcher("ServletDiarioAlimentacao");
			disp.forward(pReq, pResp);

		} else if (service.equals("agenda")) {
			
			disp = pReq.getRequestDispatcher("ServletAgendaSite");
			disp.forward(pReq, pResp);

		} else if (service.equals("Logout")) {
			
			disp = pReq.getRequestDispatcher("ServletLogin");
			disp.forward(pReq, pResp);
		}
		
		if (tErro.size() > 0){
			
			mostrarErro(pReq, pResp, tErro, "/user_home.jsp");
		}
   }

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

   private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {

		pReq.setAttribute("Erros", pErro);

		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {

		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}
}