package br.ufpr.mityba.servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.ufpr.mityba.controller.GerenteConsultaEndereco;
import br.ufpr.mityba.controller.GerenteConsultaUsuario;
import br.ufpr.mityba.dao.AuditLogDAO;
import br.ufpr.mityba.dao.UsuarioDAO;
import br.ufpr.mityba.model.AuditLog;
import br.ufpr.mityba.model.Endereco;
import br.ufpr.mityba.model.Usuario;
import br.ufpr.mityba.util.Constantes;
import br.ufpr.mityba.util.ControlePrincipal;
import br.ufpr.mityba.util.Criptografia;


/**
 * Servlet implementation class for Servlet: ServletUsuario
 * 
 * @author Mityba
 * @since 03/11/2008
 * @version 1.0
 */
 public class ServletUsuario extends HttpServlet implements Servlet {
	 
   static final long serialVersionUID = 13242132L;
   
   /**
	 * @param pReq 
	 * @param pResp 
	 * @throws ServletException 
	 * @throws IOException 
	 * 
	 */
   public void service(HttpServletRequest pReq, HttpServletResponse pResp)	throws ServletException, IOException {
	   
		Vector<String> tErro = new Vector<String>();
		
		HttpSession session = pReq.getSession(false);

		String service = pReq.getParameter("service");
		
		if (session == null){
			
			tErro.add("Voc deve efetuar o login antes de acessar essa funcionalidade!");
			
		} else {	
			
			if (service == null || service.equals("")) {
	
				tErro.add("Informar a ao a ser executada\n");

			} else if (service.equals("cadastroUsuarios")) {
				
				session.setAttribute(Constantes.ATRIB_DT_INI_CAD_USUARIO, Constantes.HORA_ATUAL());
				
				ativarPagina(pReq, pResp, "/cadastroUsuario.jsp");

			} else if (service.equals("pesquisarUsuarios")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) >= 2){
				
					session.setAttribute(Constantes.ATRIB_DT_INI_ALT_USUARIO, Constantes.HORA_ATUAL());
					session.setAttribute(Constantes.ATRIB_DT_INI_EXC_USUARIO, Constantes.HORA_ATUAL());
					
					ativarPagina(pReq, pResp, "/consultaUsuario.jsp");
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("pesquisaPorNome")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) >= 2){
				
					acaoPesquisarUsuario(pReq, pResp, 1);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("pesquisaPorCpf")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) >= 2){
				
					acaoPesquisarUsuario(pReq, pResp, 2);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("pesquisaPorLogin")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) >= 2){
				
					acaoPesquisarUsuario(pReq, pResp, 3);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("procurarEndereco")) {
				
				acaoProcurarEndereco(pReq, pResp);
				
			} else if (service.equals("salvarCadastro")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoSalvarCadastro(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("exibirUsuario")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){

					session.setAttribute(Constantes.ATRIB_DT_INI_ALT_USUARIO, Constantes.HORA_ATUAL());
					session.setAttribute(Constantes.ATRIB_DT_INI_EXC_USUARIO, Constantes.HORA_ATUAL());
					
					acaoExibirUsuario(pReq, pResp);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}
				
			} else if (service.equals("excluir")) {
				
				if((Integer) session.getAttribute(Constantes.ATRIB_ACESSO_CADASTRO) == 3){
				
					acaoExclusaoConfirmada(pReq, pResp, session);
				
				} else {
					
					tErro.add("Voc no tem o nvel de privilgio necessrio para acessar essa funcionalidade");
				}

			} else if (service.equals("voltaTelaConsulta")) {
				
				ativarPagina(pReq, pResp, "/consultaUsuario.jsp");

			} else if (service.equals("voltaTela")) {
				
				ativarPagina(pReq, pResp, "/PaginaInicial.jsp");
			}
		}
		
		if (tErro.size() > 0){
			
			mostrarErro(pReq, pResp, tErro, "/PaginaInicial.jsp");
		}
   }

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pErro
	 * @param pPag
	 * @throws ServletException
	 * @throws IOException
	 */

	private void mostrarErro(HttpServletRequest pReq, HttpServletResponse pResp, Vector<String> pErro, String pPag) throws ServletException, IOException {

		pReq.setAttribute("Erros", pErro);

		ativarPagina(pReq, pResp, pPag);
	}

	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param pPagina
	 * @throws ServletException
	 * @throws IOException
	 */

	private void ativarPagina(HttpServletRequest pReq, HttpServletResponse pResp, String pPagina) throws ServletException, IOException {

		ServletContext tContexto 		= getServletContext();
		RequestDispatcher tDespachante 	= tContexto.getRequestDispatcher(pPagina);
		tDespachante.forward(pReq, pResp);
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoProcurarEndereco(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
		
		Vector<String> tErro 	= new Vector<String>();
		
		String cepDigitado 		= pReq.getParameter("cep");
		
		if(cepDigitado == null || cepDigitado.equals("")){
			
			tErro.add("Digite o nmero do CEP!");
		
		} else {

			String nomeDigitado 		= pReq.getParameter("nome");
			String cpfDigitado 			= pReq.getParameter("cpf");
			String rgDigitado 			= pReq.getParameter("rg");
			String crnDigitado 			= pReq.getParameter("crn");
			String numEnderecoDigitado	= pReq.getParameter("numEndereco");
			String complementoDigitado	= pReq.getParameter("complemento");
			String foneResDigitado		= pReq.getParameter("foneResidencial");
			String foneComDigitado 		= pReq.getParameter("foneComercial");
			String foneCelDigitado 		= pReq.getParameter("foneCelular");
			String emailDigitado 		= pReq.getParameter("email");
			String loginDigitado 		= pReq.getParameter("login");
			String senhaDigitado 		= pReq.getParameter("senha");
			String confSenhaDigitado 	= pReq.getParameter("confSenha");
			String cadastroDigitado 	= pReq.getParameter("cadastro");
			String financeiroDigitado 	= pReq.getParameter("financeiro");
			String agendaDigitado 		= pReq.getParameter("agenda");
			
			Endereco endereco;
			
			ControlePrincipal controle 	= new ControlePrincipal();
			
			GerenteConsultaEndereco.enderecoPorCep(controle, cepDigitado.replace("-", ""));
			
			try{
			
				endereco = controle.getEnderecos().get(0);
				
				pReq.setAttribute("Logradouro"	, endereco.getTipoLogradouro().trim() + " " + endereco.getNomeLogradouro());
				pReq.setAttribute("Bairro"		, endereco.getNomeBairro());
				pReq.setAttribute("Cidade"		, endereco.getNomeCidade());
				pReq.setAttribute("UF"			, endereco.getNomeUF());
				
				
			}catch (ArrayIndexOutOfBoundsException e) {
				
				pReq.setAttribute("Msg", "<font color='red'>No existe nenhum endereo para o CEP informado</font>");
			}
			
			//-------------------------------- Dados j digitados ----------------------------//
			
			pReq.setAttribute("Nome"		, nomeDigitado);
			pReq.setAttribute("CPF"			, cpfDigitado);
			pReq.setAttribute("RG"			, rgDigitado);
			pReq.setAttribute("CRN"			, crnDigitado);
			pReq.setAttribute("CEP"			, cepDigitado);
			pReq.setAttribute("NumEndereco"	, numEnderecoDigitado);
			pReq.setAttribute("Complemento"	, complementoDigitado);
			pReq.setAttribute("FoneRes"		, foneResDigitado);
			pReq.setAttribute("FoneCom"		, foneComDigitado);
			pReq.setAttribute("FoneCel"		, foneCelDigitado);
			pReq.setAttribute("Email"		, emailDigitado);
			pReq.setAttribute("Login"		, loginDigitado);
			pReq.setAttribute("Senha"		, senhaDigitado);
			pReq.setAttribute("ConfSenha"	, confSenhaDigitado);
			pReq.setAttribute("Cadastro"	, cadastroDigitado);
			pReq.setAttribute("Financeiro"	, financeiroDigitado);
			pReq.setAttribute("Agenda"		, agendaDigitado);

			//--------------------------------------------------------------------------------//
		}
		
		boolean eCadastro = pReq.getParameter("eCadastro").equals("sim");
		
		if(tErro.size() > 0){
			
			mostrarErro(pReq, pResp, tErro, eCadastro ? "/cadastroUsuario.jsp" : "/visualizacaoUsuario.jsp");
						
		} else {
			
			ativarPagina(pReq, pResp, eCadastro ? "/cadastroUsuario.jsp" : "/visualizacaoUsuario.jsp");
		}
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoSalvarCadastro(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		Vector<String> tErro		= new Vector<String>();
		
		String nomeDigitado 		= pReq.getParameter("nome");
		String cpfDigitado 			= pReq.getParameter("cpf");
		String rgDigitado 			= pReq.getParameter("rg");
		String crnDigitado 			= pReq.getParameter("crn");
		String cepDigitado			= pReq.getParameter("cep");
		String enderecoDigitado		= pReq.getParameter("rua");
		String numEnderecoDigitado	= pReq.getParameter("numEndereco");
		String bairroDigitado		= pReq.getParameter("bairro");
		String cidadeDigitado		= pReq.getParameter("cidade");
		String ufDigitado			= pReq.getParameter("uf");
		String complementoDigitado	= pReq.getParameter("complemento");
		String foneResDigitado		= pReq.getParameter("foneResidencial");
		String foneComDigitado 		= pReq.getParameter("foneComercial");
		String foneCelDigitado 		= pReq.getParameter("foneCelular");
		String emailDigitado 		= pReq.getParameter("email");
		String loginDigitado 		= pReq.getParameter("login");
		String senhaDigitado 		= pReq.getParameter("senha");
		String confSenhaDigitado 	= pReq.getParameter("confSenha");
		String cadastroDigitado 	= pReq.getParameter("cadastro");
		String financeiroDigitado 	= pReq.getParameter("financeiro");
		String agendaDigitado 		= pReq.getParameter("agenda");
		String tpAcessoDigitado 	= pReq.getParameter("tpAcesso");
				
		if(nomeDigitado == null || nomeDigitado.equals(""))
			tErro.add("O campo nome deve ser preenchido!");
		
		if(loginDigitado == null || loginDigitado.equals(""))
			tErro.add("O campo login deve ser preenchido!");
		
		if(senhaDigitado == null || senhaDigitado.equals(""))
			tErro.add("O campo senha deve ser preenchido!");
		
		if(confSenhaDigitado == null || confSenhaDigitado.equals(""))
			tErro.add("O campo confirmao da senha deve ser preenchido!");
		
		if(!senhaDigitado.equals(confSenhaDigitado))
			tErro.add("Confirmao de senha no confere!");		

		try {
			senhaDigitado = Criptografia.criptografar(senhaDigitado);
		} catch (Exception e) {
			tErro.add("O campo senha no pde ser criptografado");
			e.printStackTrace();
		}
		
		try {
			loginDigitado = Criptografia.criptografar(loginDigitado);
		} catch (Exception e) {
			tErro.add("O campo login no pde ser criptografado");
			e.printStackTrace();
		}
		
		if(tErro.size() > 0){
			mostrarErro(pReq, pResp, tErro, "/cadastroUsuario.jsp");
			
		} else {
			
			UsuarioDAO usuarioDAO 		= new UsuarioDAO();
			Usuario usuario				= null;
			
			if(usuarioDAO.procuraLogin(loginDigitado) >= 1){
				
				pReq.setAttribute("Msg", "<font color='red'>J existe um usurio com esse login</font>");
			
			} else {
				
				usuario = new Usuario(
					0,
					Integer.parseInt(cadastroDigitado),
					Integer.parseInt(financeiroDigitado),
					Integer.parseInt(agendaDigitado),
					nomeDigitado,
					cpfDigitado,
					rgDigitado,
					crnDigitado,
					cepDigitado,
					enderecoDigitado,
					numEnderecoDigitado,
					bairroDigitado,
					cidadeDigitado,
					ufDigitado,
					complementoDigitado,
					foneResDigitado,
					foneComDigitado,
					foneCelDigitado,
					emailDigitado,
					loginDigitado,
					senhaDigitado,
					Integer.parseInt(tpAcessoDigitado)
				);
				
				if(usuarioDAO.incluiUsuario(usuario)){
					
					String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
					String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
					String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_CAD_USUARIO);
					
					AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_CADASTRO_USUARIO);
					
					new AuditLogDAO().incluiRegistro(audit);
					
					pReq.setAttribute("Msg", "Usurio cadastrado com sucesso");
					
					session.setAttribute(Constantes.ATRIB_DT_INI_CAD_USUARIO, Constantes.HORA_ATUAL());
				
				} else {
					
					pReq.setAttribute("Msg", "Problemas ao cadastrar usurio");
				}
			}
			
			ativarPagina(pReq, pResp, "/cadastroUsuario.jsp");
		}
	}
	

	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @throws ServletException
	 * @throws IOException
	 */

	private void acaoExibirUsuario(HttpServletRequest pReq, HttpServletResponse pResp) throws ServletException, IOException {
				
		ControlePrincipal controle = new ControlePrincipal();	

		Usuario usuario;
		
		int codUsuario = 0;
		
		try{
			codUsuario = Integer.parseInt(pReq.getParameter("codUsuario"));
		}catch (NumberFormatException e) {
			codUsuario = 0;
		}	
		
		if(GerenteConsultaUsuario.usuarioPorCodigo(controle, codUsuario)){
			
			usuario = controle.getUsuarios().get(0);

			pReq.setAttribute("CodUsuario"		, String.valueOf(usuario.getIdUsuario()));
			pReq.setAttribute("Agenda"			, String.valueOf(usuario.getAgendaUsuario()));
			pReq.setAttribute("Financeiro"		, String.valueOf(usuario.getFinanceiroUsuario()));
			pReq.setAttribute("Cadastro"		, String.valueOf(usuario.getCadastroUsuario()));
			pReq.setAttribute("Nome"			, usuario.getNomeUsuario());
			pReq.setAttribute("CPF"				, usuario.getCpfUsuario());
			pReq.setAttribute("RG"				, usuario.getRgUsuario());
			pReq.setAttribute("CRN"				, usuario.getCrnUsuario());
			pReq.setAttribute("CEP"				, usuario.getCepUsuario());
			pReq.setAttribute("Logradouro"		, usuario.getLogradouroUsuario());
			pReq.setAttribute("NumEndereco"		, usuario.getNumLogradouroUsuario());
			pReq.setAttribute("Complemento"		, usuario.getComplementoUsuario());
			pReq.setAttribute("Bairro"			, usuario.getBairroUsuario());
			pReq.setAttribute("Cidade"			, usuario.getCidadeUsuario());
			pReq.setAttribute("UF"				, usuario.getUfUsuario());
			pReq.setAttribute("FoneRes"			, usuario.getFoneResUsuario());
			pReq.setAttribute("FoneCom"			, usuario.getFoneComUsuario());
			pReq.setAttribute("FoneCel"			, usuario.getFoneCelUsuario());
			pReq.setAttribute("Email"			, usuario.getEmailUsuario());
			pReq.setAttribute("Login"			, usuario.getLoginUsuario());
			pReq.setAttribute("Senha"			, usuario.getSenhaUsuario());
			pReq.setAttribute("ConfSenha"		, usuario.getSenhaUsuario());
		
		} else {
			
			pReq.setAttribute("Msg", "Problemas ao exibir usurio");
		}
		
		ativarPagina(pReq, pResp, "/visualizacaoUsuario.jsp");
	}
	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param session
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoExclusaoConfirmada(HttpServletRequest pReq, HttpServletResponse pResp, HttpSession session) throws ServletException, IOException {
		
		String codUsuario = pReq.getParameter("codUsuario");
		
		if(new UsuarioDAO().excluiUsuario(Integer.parseInt(codUsuario))){
			
			String loginUsuario = (String) session.getAttribute(Constantes.ATRIB_USUARIO_LOGADO);
			String ipUsuario 	= (String) session.getAttribute(Constantes.ATRIB_IP_LOGADO);
			String dtIni 		= (String) session.getAttribute(Constantes.ATRIB_DT_INI_EXC_USUARIO);
			
			AuditLog audit 		= new AuditLog(0, loginUsuario, ipUsuario, dtIni, Constantes.HORA_ATUAL(), Constantes.COD_EXCLUSAO_USUARIO);
			
			new AuditLogDAO().incluiRegistro(audit);

			pReq.setAttribute("Msg", "Usuario excludo com sucesso");
			
		} else {
			
			pReq.setAttribute("Msg", "Problemas na excluso do usurio");
		}
		
		ativarPagina(pReq, pResp, "/consultaUsuario.jsp");
	}
	

	
	/**
	 * 
	 * @param pReq
	 * @param pResp
	 * @param eNome
	 * @throws ServletException
	 * @throws IOException
	 */
	
	private void acaoPesquisarUsuario(HttpServletRequest pReq, HttpServletResponse pResp, int idCampo) throws ServletException, IOException {
		
		ControlePrincipal controle = new ControlePrincipal();
		
		Vector<Usuario> usuarios;
		
		String campo = "";
		
		if(idCampo == 1){
			
			campo = pReq.getParameter("nome");
			pReq.setAttribute("Nome", campo);
			
			if(GerenteConsultaUsuario.usuarioPorNome(controle, campo)){
				
				usuarios = controle.getUsuarios();
				
				pReq.setAttribute("Usuarios", usuarios);
			
			} else {
				
				pReq.setAttribute("Msg", "Problemas ao realizar consulta de usuarios");
			}
			
		} else if(idCampo == 2) {
			
			campo = pReq.getParameter("cpf");
			pReq.setAttribute("CPF", campo);
			
			if(GerenteConsultaUsuario.usuarioPorCpf(controle, campo)){
				
				usuarios = controle.getUsuarios();
				
				pReq.setAttribute("Usuarios", usuarios);
			
			} else {
				
				pReq.setAttribute("Msg", "Problemas ao realizar consulta de usuarios");
			}
		
		} else {
			
			campo = pReq.getParameter("login");
			pReq.setAttribute("Login", campo);
			
			if(GerenteConsultaUsuario.usuarioPorLogin(controle, campo)){
				
				usuarios = controle.getUsuarios();
				
				pReq.setAttribute("Usuarios", usuarios);
			
			} else {
				
				pReq.setAttribute("Msg", "Problemas ao realizar consulta de usuarios");
			}
		
		}

		ativarPagina(pReq, pResp, "/consultaUsuario.jsp");
	}
}