package br.ufpr.mityba.util;

import java.util.Vector;

import br.ufpr.mityba.model.Alimento;
import br.ufpr.mityba.model.AuditLog;
import br.ufpr.mityba.model.Consulta;
import br.ufpr.mityba.model.Convenio;
import br.ufpr.mityba.model.DiarioAlimentacaoPaciente;
import br.ufpr.mityba.model.DietaApoio;
import br.ufpr.mityba.model.Endereco;
import br.ufpr.mityba.model.ExameCadastrado;
import br.ufpr.mityba.model.GrupoAlimenticio;
import br.ufpr.mityba.model.HistoricoPaciente;
import br.ufpr.mityba.model.HistoricoPorcao;
import br.ufpr.mityba.model.HorarioConsulta;
import br.ufpr.mityba.model.IntervaloHorarioConsulta;
import br.ufpr.mityba.model.IntoleranciaPaciente;
import br.ufpr.mityba.model.Lancamento;
import br.ufpr.mityba.model.Medicamento;
import br.ufpr.mityba.model.Mensagem;
import br.ufpr.mityba.model.NomeGenerico;
import br.ufpr.mityba.model.Paciente;
import br.ufpr.mityba.model.Profissao;
import br.ufpr.mityba.model.UnidadeExame;
import br.ufpr.mityba.model.Usuario;
import br.ufpr.mityba.model.ViewPacienteConsulta;


/**
 * @author Mityba
 * @since 05/09/08
 * @version 1.0 
 *
 */
public class ControlePrincipal {
	
	private Vector<ExameCadastrado> examesCadastrados;
	private Vector<AuditLog> auditLog;
	private Vector<Endereco> enderecos;
	private Vector<Paciente> pacientes;
	private Vector<Profissao> profissoes;
	private Vector<Mensagem> mensagens;
	private Vector<Usuario> usuarios;
	private Vector<Convenio> convenios;
	private Vector<UnidadeExame> unidadesExame;
	private Vector<Medicamento> medicamentos;
	private Vector<NomeGenerico> nomesGenericos;
	private Vector<GrupoAlimenticio> gruposAlimenticios;
	private Vector<HorarioConsulta> horariosConsulta;
	private Vector<Consulta> consultas;
	private Vector<Lancamento> financeiros;
	private Vector<ViewPacienteConsulta> viewPacienteConsultas;
	private Vector<DietaApoio> dietasApoio;
	private Vector<IntervaloHorarioConsulta> intervalosConsulta;
	private Vector<DiarioAlimentacaoPaciente> diariosAlimentacao;
	private Vector<IntoleranciaPaciente> intoleranciasPaciente;
	private Vector<HistoricoPorcao> historicoPorcoes;
	private Vector<HistoricoPaciente> historicoPacientes;
	
	
	
	/**
	 * @return the intervalosConsulta
	 */
	public Vector<IntervaloHorarioConsulta> getIntervalosConsulta() {
		return intervalosConsulta;
	}

	/**
	 * @param intervalosConsulta the intervalosConsulta to set
	 */
	public void setIntervalosConsulta(Vector<IntervaloHorarioConsulta> intervalosConsulta) {
		this.intervalosConsulta = intervalosConsulta;
	}

	/**
	 * @return the viewPacienteConsultas
	 */
	public Vector<ViewPacienteConsulta> getViewPacienteConsultas() {
		return viewPacienteConsultas;
	}

	/**
	 * @param viewPacienteConsultas the viewPacienteConsultas to set
	 */
	public void setViewPacienteConsultas(
			Vector<ViewPacienteConsulta> viewPacienteConsultas) {
		this.viewPacienteConsultas = viewPacienteConsultas;
	}

	/**
	 * @return the consultas
	 */
	public Vector<Consulta> getConsultas() {
		return consultas;
	}

	/**
	 * @param consultas the consultas to set
	 */
	public void setConsultas(Vector<Consulta> consultas) {
		this.consultas = consultas;
	}

	/**
	 * @return the financeiros
	 */
	public Vector<Lancamento> getFinanceiros() {
		return financeiros;
	}

	/**
	 * @param financeiros the financeiros to set
	 */
	public void setFinanceiros(Vector<Lancamento> financeiros) {
		this.financeiros = financeiros;
	}

	/**
	 * @return the horariosConsulta
	 */
	public Vector<HorarioConsulta> getHorariosConsulta() {
		return horariosConsulta;
	}

	/**
	 * @param horariosConsulta the horariosConsulta to set
	 */
	public void setHorariosConsulta(Vector<HorarioConsulta> horariosConsulta) {
		this.horariosConsulta = horariosConsulta;
	}

	/**
	 * @return the gruposAlimenticios
	 */
	public Vector<GrupoAlimenticio> getGruposAlimenticios() {
		return gruposAlimenticios;
	}

	/**
	 * @param gruposAlimenticios the gruposAlimenticios to set
	 */
	public void setGruposAlimenticios(Vector<GrupoAlimenticio> gruposAlimenticios) {
		this.gruposAlimenticios = gruposAlimenticios;
	}

	/**
	 * @return the alimentos
	 */
	public Vector<Alimento> getAlimentos() {
		return alimentos;
	}

	/**
	 * @param alimentos the alimentos to set
	 */
	public void setAlimentos(Vector<Alimento> alimentos) {
		this.alimentos = alimentos;
	}

	private Vector<Alimento> alimentos;

	/**
	 * @return the medicamentos
	 */
	public Vector<Medicamento> getMedicamentos() {
		return medicamentos;
	}

	/**
	 * @param medicamentos the medicamentos to set
	 */
	public void setMedicamentos(Vector<Medicamento> medicamentos) {
		this.medicamentos = medicamentos;
	}

	/**
	 * @return the nomesGenericos
	 */
	public Vector<NomeGenerico> getNomesGenericos() {
		return nomesGenericos;
	}

	/**
	 * @param nomesGenericos the nomesGenericos to set
	 */
	public void setNomesGenericos(Vector<NomeGenerico> nomesGenericos) {
		this.nomesGenericos = nomesGenericos;
	}

	/**
	 * @return the unidadesExame
	 */
	public Vector<UnidadeExame> getUnidadesExame() {
		return unidadesExame;
	}

	/**
	 * @param unidadesExame the unidadesExame to set
	 */
	public void setUnidadesExame(Vector<UnidadeExame> unidadesExame) {
		this.unidadesExame = unidadesExame;
	}

	/**
	 * @return the convenios
	 */
	public Vector<Convenio> getConvenios() {
		return convenios;
	}

	/**
	 * @param convenios the convenios to set
	 */
	public void setConvenios(Vector<Convenio> convenios) {
		this.convenios = convenios;
	}

	/**
	 * @return the usuarios
	 */
	public Vector<Usuario> getUsuarios() {
		return usuarios;
	}

	/**
	 * @param usuarios the usuarios to set
	 */
	public void setUsuarios(Vector<Usuario> usuarios) {
		this.usuarios = usuarios;
	}

	/**
	 * @return the enderecos
	 */
	public Vector<Endereco> getEnderecos() {
		return enderecos;
	}

	/**
	 * @param enderecos the enderecos to set
	 */
	public void setEnderecos(Vector<Endereco> enderecos) {
		this.enderecos = enderecos;
	}

	/**
	 * @return the examesCadastrados
	 */
	public Vector<ExameCadastrado> getExamesCadastrados() {
		return examesCadastrados;
	}


	/**
	 * @param examesCadastrados the examesCadastrados to set
	 */
	public void setExamesCadastrados(Vector<ExameCadastrado> examesCadastrados) {
		this.examesCadastrados = examesCadastrados;
	}

	/**
	 * @return the auditLog
	 */
	public Vector<AuditLog> getAuditLog() {
		return auditLog;
	}

	/**
	 * @param auditLog the auditLog to set
	 */
	public void setAuditLog(Vector<AuditLog> auditLog) {
		this.auditLog = auditLog;
	}

	/**
	 * @return the pacientes
	 */
	public Vector<Paciente> getPacientes() {
		return pacientes;
	}

	/**
	 * @param pacientes the pacientes to set
	 */
	public void setPacientes(Vector<Paciente> pacientes) {
		this.pacientes = pacientes;
	}

	/**
	 * @return the profissoes
	 */
	public Vector<Profissao> getProfissoes() {
		return profissoes;
	}

	/**
	 * @param profissoes the profissoes to set
	 */
	public void setProfissoes(Vector<Profissao> profissoes) {
		this.profissoes = profissoes;
	}

	/**
	 * @return the mensagens
	 */
	public Vector<Mensagem> getMensagens() {
		return mensagens;
	}

	/**
	 * @param mensagens the mensagens to set
	 */
	public void setMensagens(Vector<Mensagem> mensagens) {
		this.mensagens = mensagens;
	}

	/**
	 * @return the dietasApoio
	 */
	public Vector<DietaApoio> getDietasApoio() {
		return dietasApoio;
	}

	/**
	 * @param dietasApoio the dietasApoio to set
	 */
	public void setDietasApoio(Vector<DietaApoio> dietasApoio) {
		this.dietasApoio = dietasApoio;
	}

	/**
	 * @return the diariosAlimentacao
	 */
	public Vector<DiarioAlimentacaoPaciente> getDiariosAlimentacao() {
		return diariosAlimentacao;
	}

	/**
	 * @param diariosAlimentacao the diariosAlimentacao to set
	 */
	public void setDiariosAlimentacao(
			Vector<DiarioAlimentacaoPaciente> diariosAlimentacao) {
		this.diariosAlimentacao = diariosAlimentacao;
	}

	/**
	 * @return the intoleranciasPaciente
	 */
	public Vector<IntoleranciaPaciente> getIntoleranciasPaciente() {
		return intoleranciasPaciente;
	}

	/**
	 * @return the historicoPorcoes
	 */
	public Vector<HistoricoPorcao> getHistoricoPorcoes() {
		return historicoPorcoes;
	}

	/**
	 * @return the historicoPacientes
	 */
	public Vector<HistoricoPaciente> getHistoricoPacientes() {
		return historicoPacientes;
	}

	/**
	 * @param intoleranciasPaciente the intoleranciasPaciente to set
	 */
	public void setIntoleranciasPaciente(
			Vector<IntoleranciaPaciente> intoleranciasPaciente) {
		this.intoleranciasPaciente = intoleranciasPaciente;
	}

	/**
	 * @param historicoPorcoes the historicoPorcoes to set
	 */
	public void setHistoricoPorcoes(Vector<HistoricoPorcao> historicoPorcoes) {
		this.historicoPorcoes = historicoPorcoes;
	}

	/**
	 * @param historicoPacientes the historicoPacientes to set
	 */
	public void setHistoricoPacientes(Vector<HistoricoPaciente> historicoPacientes) {
		this.historicoPacientes = historicoPacientes;
	}
}
