package br.ufpr.mityba.util;

import java.io.IOException;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

/**
 * 
 * @author Mityba
 * @since 07/11/2008
 * @version 1.0
 *
 */

public class Criptografia {  
   
    private static SecretKey skey;  
    private static KeySpec ks;  
    private static PBEParameterSpec ps;  
    private static final String algorithm = "PBEWithMD5AndDES";  
    private static BASE64Encoder enc = new BASE64Encoder();  
    private static BASE64Decoder dec = new BASE64Decoder(); 
    
    static {
        try {  
            SecretKeyFactory skf = SecretKeyFactory.getInstance(algorithm);  
            ps = new PBEParameterSpec (new byte[]{3,1,4,1,5,9,2,6}, 20);
            ks = new PBEKeySpec ("EAlGeEen3/m8/YkO".toCharArray());
            skey = skf.generateSecret (ks);             
        } catch (NoSuchAlgorithmException ex) {  
            ex.printStackTrace();  
        } catch (InvalidKeySpecException ex) {  
            ex.printStackTrace();  
        }  
    }

    /**
     * 
     * @param senha
     * @return senhaCriptografada
     * @throws BadPaddingException
     * @throws NoSuchPaddingException
     * @throws IllegalBlockSizeException
     * @throws InvalidKeyException
     * @throws NoSuchAlgorithmException
     * @throws InvalidAlgorithmParameterException
     */
    
    public static final String criptografar(final String senha) throws BadPaddingException, NoSuchPaddingException, IllegalBlockSizeException,  
    																	InvalidKeyException, NoSuchAlgorithmException, InvalidAlgorithmParameterException {          
        final Cipher cipher = Cipher.getInstance(algorithm);  
        cipher.init(Cipher.ENCRYPT_MODE, skey, ps);  
        return enc.encode (cipher.doFinal(senha.getBytes()));  
    }
    
    /**
     * 
     * @param senha
     * @return senhaDecriptografada
     * @throws BadPaddingException
     * @throws NoSuchPaddingException
     * @throws IllegalBlockSizeException
     * @throws InvalidKeyException
     * @throws NoSuchAlgorithmException
     * @throws InvalidAlgorithmParameterException
     * @throws IOException
     */
    
    public static final String decriptografar(final String senha) throws BadPaddingException, NoSuchPaddingException, IllegalBlockSizeException,  
																		InvalidKeyException, NoSuchAlgorithmException, InvalidAlgorithmParameterException, IOException {
               
        final Cipher cipher = Cipher.getInstance(algorithm);  
        cipher.init(Cipher.DECRYPT_MODE, skey, ps);  
        String senhaRetorno = null;

        senhaRetorno = new String(cipher.doFinal(dec.decodeBuffer (senha)));  

        return senhaRetorno;  
    }  
    
}